var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CommandsButton = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactNative = require("react-native");
var _SuggestionsContext = require("../../contexts/suggestionsContext/SuggestionsContext");
var _ThemeContext = require("../../contexts/themeContext/ThemeContext");
var _Lightning = require("../../icons/Lightning");
var _jsxRuntime = require("react/jsx-runtime");
var _this = this,
  _jsxFileName = "/home/runner/work/stream-chat-react-native/stream-chat-react-native/package/src/components/MessageInput/CommandsButton.tsx";
var CommandsButtonWithContext = function CommandsButtonWithContext(props) {
  var handleOnPress = props.handleOnPress,
    suggestions = props.suggestions;
  var _useTheme = (0, _ThemeContext.useTheme)(),
    _useTheme$theme = _useTheme.theme,
    _useTheme$theme$color = _useTheme$theme.colors,
    accent_blue = _useTheme$theme$color.accent_blue,
    grey = _useTheme$theme$color.grey,
    commandsButton = _useTheme$theme.messageInput.commandsButton;
  return (0, _jsxRuntime.jsx)(_reactNative.Pressable, {
    onPress: handleOnPress,
    style: [commandsButton],
    testID: "commands-button",
    children: (0, _jsxRuntime.jsx)(_Lightning.Lightning, {
      fill: suggestions && suggestions.data.some(function (suggestion) {
        return (0, _SuggestionsContext.isSuggestionCommand)(suggestion);
      }) ? accent_blue : grey,
      size: 32
    })
  });
};
var areEqual = function areEqual(prevProps, nextProps) {
  var prevSuggestions = prevProps.suggestions;
  var nextSuggestions = nextProps.suggestions;
  var suggestionsEqual = !!prevSuggestions === !!nextSuggestions;
  if (!suggestionsEqual) {
    return false;
  }
  return true;
};
var MemoizedCommandsButton = _react["default"].memo(CommandsButtonWithContext, areEqual);
var CommandsButton = exports.CommandsButton = function CommandsButton(props) {
  var _useSuggestionsContex = (0, _SuggestionsContext.useSuggestionsContext)(),
    suggestions = _useSuggestionsContex.suggestions;
  return (0, _jsxRuntime.jsx)(MemoizedCommandsButton, Object.assign({
    suggestions: suggestions
  }, props));
};
CommandsButton.displayName = 'CommandsButton{messageInput}';
//# sourceMappingURL=CommandsButton.js.map