Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getGroupStyles = void 0;
var _utils = require("../../../utils/utils");
var getGroupStyle = function getGroupStyle(dateSeparators, message, previousMessage, nextMessage, hideDateSeparators, maxTimeBetweenGroupedMessages) {
  var _message$user, _previousMessage$user, _nextMessage$user;
  var groupStyles = [];
  var isPrevMessageTypeDeleted = (previousMessage == null ? void 0 : previousMessage.type) === 'deleted';
  var isNextMessageTypeDeleted = (nextMessage == null ? void 0 : nextMessage.type) === 'deleted';
  var userId = (message == null || (_message$user = message.user) == null ? void 0 : _message$user.id) || null;
  var isTopMessage = !previousMessage || previousMessage.type === 'system' || previousMessage.type === 'error' || userId !== (previousMessage == null || (_previousMessage$user = previousMessage.user) == null ? void 0 : _previousMessage$user.id) || !!isPrevMessageTypeDeleted || !hideDateSeparators && dateSeparators[previousMessage.id] || (0, _utils.isEditedMessage)(previousMessage);
  var isBottomMessage = !nextMessage || nextMessage.type === 'system' || nextMessage.type === 'error' || userId !== (nextMessage == null || (_nextMessage$user = nextMessage.user) == null ? void 0 : _nextMessage$user.id) || !!isNextMessageTypeDeleted || !hideDateSeparators && dateSeparators[nextMessage.id] || maxTimeBetweenGroupedMessages !== undefined && nextMessage.created_at.getTime() - message.created_at.getTime() > maxTimeBetweenGroupedMessages || (0, _utils.isEditedMessage)(message);
  if (isTopMessage) {
    groupStyles.push('top');
  }
  var isMessageTypeDeleted = message.type === 'deleted';
  if (isBottomMessage) {
    if (isTopMessage || isMessageTypeDeleted || message.type === 'error') {
      groupStyles.splice(0, groupStyles.length);
      groupStyles.push('single');
    } else {
      groupStyles.push('bottom');
    }
  }
  if (!isTopMessage && !isBottomMessage) {
    if (isMessageTypeDeleted || message.type === 'error') {
      groupStyles.splice(0, groupStyles.length);
      groupStyles.push('single');
    } else {
      groupStyles.splice(0, groupStyles.length);
      groupStyles.push('middle');
    }
  }
  return groupStyles;
};
var getGroupStyles = exports.getGroupStyles = function getGroupStyles(params) {
  var dateSeparators = params.dateSeparators,
    hideDateSeparators = params.hideDateSeparators,
    maxTimeBetweenGroupedMessages = params.maxTimeBetweenGroupedMessages,
    messages = params.messages,
    noGroupByUser = params.noGroupByUser,
    userId = params.userId;
  if (noGroupByUser) {
    return {};
  }
  var messageGroupStyles = {};
  var messagesFilteredForNonUser = messages.filter(function (message) {
    var _message$user2;
    var isMessageTypeDeleted = message.type === 'deleted';
    return !isMessageTypeDeleted || userId === ((_message$user2 = message.user) == null ? void 0 : _message$user2.id);
  });
  for (var i = 0; i < messagesFilteredForNonUser.length; i++) {
    var previousMessage = messagesFilteredForNonUser[i - 1];
    var message = messagesFilteredForNonUser[i];
    var nextMessage = messagesFilteredForNonUser[i + 1];
    if (message.id) {
      messageGroupStyles[message.id] = getGroupStyle(dateSeparators, message, previousMessage, nextMessage, hideDateSeparators, maxTimeBetweenGroupedMessages);
    }
  }
  return messageGroupStyles;
};
//# sourceMappingURL=getGroupStyles.js.map