var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useIsChannelMuted = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = require("react");
var _ChatContext = require("../../../contexts/chatContext/ChatContext");
var defaultMuteStatus = {
  createdAt: null,
  expiresAt: null,
  muted: false
};
var useIsChannelMuted = exports.useIsChannelMuted = function useIsChannelMuted(channel) {
  var _useChatContext = (0, _ChatContext.useChatContext)(),
    client = _useChatContext.client;
  var _useState = (0, _react.useState)(function () {
      return channel.muteStatus();
    }),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    muted = _useState2[0],
    setMuted = _useState2[1];
  (0, _react.useEffect)(function () {
    var handleEvent = function handleEvent() {
      setMuted(channel.muteStatus());
    };
    client.on('notification.channel_mutes_updated', handleEvent);
    return function () {
      return client.off('notification.channel_mutes_updated', handleEvent);
    };
  }, [channel, client, muted]);
  return muted != null ? muted : defaultMuteStatus;
};
//# sourceMappingURL=useIsChannelMuted.js.map