var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputButtonsWithContext = exports.InputButtons = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _MessageInputContext = require("../../contexts/messageInputContext/MessageInputContext");
var _OwnCapabilitiesContext = require("../../contexts/ownCapabilitiesContext/OwnCapabilitiesContext");
var _ThemeContext = require("../../contexts/themeContext/ThemeContext");
var _jsxRuntime = require("react/jsx-runtime");
var _this = this,
  _jsxFileName = "/home/runner/work/stream-chat-react-native/stream-chat-react-native/package/src/components/MessageInput/InputButtons.tsx";
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var styles = _reactNative.StyleSheet.create({
  attachButtonContainer: {
    paddingRight: 5
  }
});
var InputButtonsWithContext = exports.InputButtonsWithContext = function InputButtonsWithContext(props) {
  var AttachButton = props.AttachButton,
    CommandsButton = props.CommandsButton,
    giphyActive = props.giphyActive,
    hasCameraPicker = props.hasCameraPicker,
    hasCommands = props.hasCommands,
    hasFilePicker = props.hasFilePicker,
    hasImagePicker = props.hasImagePicker,
    hasText = props.hasText,
    MoreOptionsButton = props.MoreOptionsButton,
    openCommandsPicker = props.openCommandsPicker,
    setShowMoreOptions = props.setShowMoreOptions,
    showMoreOptions = props.showMoreOptions;
  var _useTheme = (0, _ThemeContext.useTheme)(),
    _useTheme$theme$messa = _useTheme.theme.messageInput,
    attachButtonContainer = _useTheme$theme$messa.attachButtonContainer,
    commandsButtonContainer = _useTheme$theme$messa.commandsButtonContainer;
  var handleShowMoreOptions = (0, _react.useCallback)(function () {
    setShowMoreOptions(true);
  }, [setShowMoreOptions]);
  var ownCapabilities = (0, _OwnCapabilitiesContext.useOwnCapabilitiesContext)();
  if (giphyActive) {
    return null;
  }
  return !showMoreOptions && (hasCameraPicker || hasImagePicker || hasFilePicker) && hasCommands ? (0, _jsxRuntime.jsx)(MoreOptionsButton, {
    handleOnPress: handleShowMoreOptions
  }) : (0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [(hasCameraPicker || hasImagePicker || hasFilePicker) && ownCapabilities.uploadFile && (0, _jsxRuntime.jsx)(_reactNative.View, {
      style: [hasCommands ? styles.attachButtonContainer : undefined, attachButtonContainer],
      children: (0, _jsxRuntime.jsx)(AttachButton, {})
    }), hasCommands && !hasText && (0, _jsxRuntime.jsx)(_reactNative.View, {
      style: commandsButtonContainer,
      children: (0, _jsxRuntime.jsx)(CommandsButton, {
        handleOnPress: openCommandsPicker
      })
    })]
  });
};
var areEqual = function areEqual(prevProps, nextProps) {
  var prevGiphyActive = prevProps.giphyActive,
    prevHasCameraPicker = prevProps.hasCameraPicker,
    prevHasCommands = prevProps.hasCommands,
    prevHasFilePicker = prevProps.hasFilePicker,
    prevHasImagePicker = prevProps.hasImagePicker,
    prevHasText = prevProps.hasText,
    prevSelectedPicker = prevProps.selectedPicker,
    prevShowMoreOptions = prevProps.showMoreOptions;
  var nextGiphyActive = nextProps.giphyActive,
    nextHasCameraPicker = nextProps.hasCameraPicker,
    nextHasCommands = nextProps.hasCommands,
    nextHasFilePicker = nextProps.hasFilePicker,
    nextHasImagePicker = nextProps.hasImagePicker,
    nextHasText = nextProps.hasText,
    nextSelectedPicker = nextProps.selectedPicker,
    nextShowMoreOptions = nextProps.showMoreOptions;
  if (prevHasCameraPicker !== nextHasCameraPicker) {
    return false;
  }
  if (prevHasImagePicker !== nextHasImagePicker) {
    return false;
  }
  if (prevHasFilePicker !== nextHasFilePicker) {
    return false;
  }
  if (prevHasCommands !== nextHasCommands) {
    return false;
  }
  if (prevSelectedPicker !== nextSelectedPicker) {
    return false;
  }
  if (prevShowMoreOptions !== nextShowMoreOptions) {
    return false;
  }
  if (prevHasText !== nextHasText) {
    return false;
  }
  if (prevGiphyActive !== nextGiphyActive) {
    return false;
  }
  return true;
};
var MemoizedInputButtonsWithContext = _react["default"].memo(InputButtonsWithContext, areEqual);
var InputButtons = exports.InputButtons = function InputButtons(props) {
  var _useMessageInputConte = (0, _MessageInputContext.useMessageInputContext)(),
    AttachButton = _useMessageInputConte.AttachButton,
    CommandsButton = _useMessageInputConte.CommandsButton,
    giphyActive = _useMessageInputConte.giphyActive,
    hasCameraPicker = _useMessageInputConte.hasCameraPicker,
    hasCommands = _useMessageInputConte.hasCommands,
    hasFilePicker = _useMessageInputConte.hasFilePicker,
    hasImagePicker = _useMessageInputConte.hasImagePicker,
    hasText = _useMessageInputConte.hasText,
    MoreOptionsButton = _useMessageInputConte.MoreOptionsButton,
    openCommandsPicker = _useMessageInputConte.openCommandsPicker,
    selectedPicker = _useMessageInputConte.selectedPicker,
    setShowMoreOptions = _useMessageInputConte.setShowMoreOptions,
    showMoreOptions = _useMessageInputConte.showMoreOptions,
    toggleAttachmentPicker = _useMessageInputConte.toggleAttachmentPicker;
  return (0, _jsxRuntime.jsx)(MemoizedInputButtonsWithContext, Object.assign({
    AttachButton: AttachButton,
    CommandsButton: CommandsButton,
    giphyActive: giphyActive,
    hasCameraPicker: hasCameraPicker,
    hasCommands: hasCommands,
    hasFilePicker: hasFilePicker,
    hasImagePicker: hasImagePicker,
    hasText: hasText,
    MoreOptionsButton: MoreOptionsButton,
    openCommandsPicker: openCommandsPicker,
    selectedPicker: selectedPicker,
    setShowMoreOptions: setShowMoreOptions,
    showMoreOptions: showMoreOptions,
    toggleAttachmentPicker: toggleAttachmentPicker
  }, props));
};
//# sourceMappingURL=InputButtons.js.map