Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDateString = getDateString;
exports.noParsingFunctionWarning = void 0;
var _TranslationContext = require("../../contexts/translationContext/TranslationContext");
var noParsingFunctionWarning = exports.noParsingFunctionWarning = 'MessageTimestamp was called but there is no datetime parsing function available';
function getDateString(_ref) {
  var calendar = _ref.calendar,
    calendarFormats = _ref.calendarFormats,
    date = _ref.date,
    format = _ref.format,
    t = _ref.t,
    tDateTimeParser = _ref.tDateTimeParser,
    timestampTranslationKey = _ref.timestampTranslationKey;
  if (!date || typeof date === 'string' && !Date.parse(date)) {
    return;
  }
  if (!tDateTimeParser) {
    console.log(noParsingFunctionWarning);
    return;
  }
  if (t && timestampTranslationKey) {
    var options = {};
    if (typeof calendar !== 'undefined' && calendar !== null) {
      options.calendar = calendar;
    }
    if (typeof calendarFormats !== 'undefined' && calendarFormats !== null) {
      options.calendarFormats = calendarFormats;
    }
    if (typeof format !== 'undefined' && format !== null) {
      options.format = format;
    }
    var translatedTimestamp = t(timestampTranslationKey, Object.assign({}, options, {
      timestamp: new Date(date)
    }));
    var translationKeyFound = timestampTranslationKey !== translatedTimestamp;
    if (translationKeyFound) {
      return translatedTimestamp;
    }
  }
  var parsedTime = tDateTimeParser(date);
  if ((0, _TranslationContext.isDayOrMoment)(parsedTime)) {
    return calendar && parsedTime.calendar ? parsedTime.calendar(undefined, calendarFormats) : parsedTime.format(format);
  }
  return new Date(date).toDateString();
}
//# sourceMappingURL=getDateString.js.map