var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.predefinedFormatters = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _getDateString = require("./getDateString");
var _excluded = ["calendarFormats"];
var predefinedFormatters = exports.predefinedFormatters = {
  timestampFormatter: function timestampFormatter(streamI18n) {
    return function (value, _, _ref) {
      var calendarFormats = _ref.calendarFormats,
        options = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
      var parsedCalendarFormats;
      try {
        if (!options.calendar) {
          parsedCalendarFormats = {};
        } else if (typeof calendarFormats === 'string') {
          parsedCalendarFormats = JSON.parse(calendarFormats);
        } else if ((0, _typeof2["default"])(calendarFormats) === 'object') {
          parsedCalendarFormats = calendarFormats;
        }
      } catch (e) {
        console.error('[TIMESTAMP FORMATTER]', e);
      }
      var result = (0, _getDateString.getDateString)(Object.assign({}, options, {
        calendarFormats: parsedCalendarFormats,
        date: value,
        tDateTimeParser: streamI18n.tDateTimeParser
      }));
      if (!result || typeof result === 'number') {
        return JSON.stringify(value);
      }
      return result;
    };
  }
};
//# sourceMappingURL=predefinedFormatters.js.map