Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.removeReactionFromLocalState = void 0;
var _deleteReaction = require("../store/apis/deleteReaction");
var removeReactionFromLocalState = exports.removeReactionFromLocalState = function removeReactionFromLocalState(_ref) {
  var _message$own_reaction, _message$latest_react, _message$reaction_gro;
  var channel = _ref.channel,
    messageId = _ref.messageId,
    reactionType = _ref.reactionType,
    user = _ref.user;
  var message = channel.state.messages.find(function (_ref2) {
    var id = _ref2.id;
    return id === messageId;
  });
  if (!message || !(channel != null && channel.id) || !(user != null && user.id)) {
    return;
  }
  message.own_reactions = (_message$own_reaction = message.own_reactions) == null ? void 0 : _message$own_reaction.filter(function (reaction) {
    return reaction.type !== reactionType;
  });
  message.latest_reactions = (_message$latest_react = message.latest_reactions) == null ? void 0 : _message$latest_react.filter(function (r) {
    return !(r.user_id === (user == null ? void 0 : user.id) && r.type === reactionType);
  });
  if ((_message$reaction_gro = message.reaction_groups) != null && _message$reaction_gro[reactionType]) {
    if (message.reaction_groups[reactionType].count > 0 || message.reaction_groups[reactionType].sum_scores > 0) {
      message.reaction_groups[reactionType].count = Math.max(0, message.reaction_groups[reactionType].count - 1);
      message.reaction_groups[reactionType].sum_scores = Math.max(0, message.reaction_groups[reactionType].sum_scores - 1);
      if (message.reaction_groups[reactionType].count === 0 || message.reaction_groups[reactionType].sum_scores === 0) {
        delete message.reaction_groups[reactionType];
      }
    } else {
      delete message.reaction_groups[reactionType];
    }
  }
  (0, _deleteReaction.deleteReaction)({
    messageId: messageId,
    reactionType: reactionType,
    userId: user.id
  });
};
//# sourceMappingURL=removeReactionFromLocalState.js.map