import React from 'react';
import { MessageInputContextValue } from '../../contexts/messageInputContext/MessageInputContext';
import { SuggestionsContextValue } from '../../contexts/suggestionsContext/SuggestionsContext';
import { TranslationContextValue } from '../../contexts/translationContext/TranslationContext';
type AutoCompleteInputPropsWithContext = Pick<MessageInputContextValue, 'additionalTextInputProps' | 'autoCompleteSuggestionsLimit' | 'giphyActive' | 'giphyEnabled' | 'maxMessageLength' | 'mentionAllAppUsersEnabled' | 'mentionAllAppUsersQuery' | 'numberOfLines' | 'onChange' | 'setGiphyActive' | 'setInputBoxRef' | 'text' | 'triggerSettings'> & Pick<SuggestionsContextValue, 'closeSuggestions' | 'openSuggestions' | 'updateSuggestions'> & Pick<TranslationContextValue, 't'> & {
    /**
     * This is currently passed in from MessageInput to avoid rerenders
     * that would happen if we put this in the MessageInputContext
     */
    cooldownActive?: boolean;
};
export type AutoCompleteInputProps = Partial<Omit<AutoCompleteInputPropsWithContext, 'triggerSettings' | 'mentionAllAppUsersQuery' | 'mentionAllAppUsersEnabled' | 'autoCompleteSuggestionsLimit'>>;
export declare const AutoCompleteInput: {
    (props: AutoCompleteInputProps): React.JSX.Element;
    displayName: string;
};
export {};
//# sourceMappingURL=AutoCompleteInput.d.ts.map