import type { ChannelContextValue } from '../../../contexts/channelContext/ChannelContext';
import type { ChatContextValue } from '../../../contexts/chatContext/ChatContext';
import type { MessageContextValue } from '../../../contexts/messageContext/MessageContext';
import type { MessagesContextValue } from '../../../contexts/messagesContext/MessagesContext';
export declare const useMessageActionHandlers: ({ channel, client, deleteMessage, deleteReaction, message, retrySendMessage, sendReaction, setEditingState, setQuotedMessageState, }: Pick<MessagesContextValue, "sendReaction" | "deleteMessage" | "deleteReaction" | "retrySendMessage" | "setEditingState" | "setQuotedMessageState" | "supportedReactions"> & Pick<ChannelContextValue, "channel" | "enforceUniqueReaction"> & Pick<ChatContextValue, "client"> & Pick<MessageContextValue, "message">) => {
    handleCopyMessage: () => void;
    handleDeleteMessage: () => void;
    handleEditMessage: () => void;
    handleFlagMessage: () => void;
    handleMarkUnreadMessage: () => Promise<void>;
    handleQuotedReplyMessage: () => void;
    handleResendMessage: () => Promise<void>;
    handleToggleBanUser: () => Promise<void>;
    handleToggleMuteUser: () => Promise<void>;
    handleTogglePinMessage: () => Promise<void>;
    handleToggleReaction: (reactionType: string) => Promise<void>;
};
//# sourceMappingURL=useMessageActionHandlers.d.ts.map