import type { MessageContextValue } from '../../../contexts/messageContext/MessageContext';
import type { OwnCapabilitiesContextValue } from '../../../contexts/ownCapabilitiesContext/OwnCapabilitiesContext';
import type { MessageActionType } from '../../MessageMenu/MessageActionListItem';
export type MessageActionsParams = {
    banUser: MessageActionType;
    copyMessage: MessageActionType;
    deleteMessage: MessageActionType;
    dismissOverlay: () => void;
    editMessage: MessageActionType;
    error: boolean | Error;
    flagMessage: MessageActionType;
    isThreadMessage: boolean;
    markUnread: MessageActionType;
    muteUser: MessageActionType;
    ownCapabilities: OwnCapabilitiesContextValue;
    pinMessage: MessageActionType;
    quotedReply: MessageActionType;
    retry: MessageActionType;
    /**
     * Determines if the message actions are visible.
     */
    showMessageReactions: boolean;
    threadReply: MessageActionType;
    unpinMessage: MessageActionType;
} & Pick<MessageContextValue, 'message' | 'isMyMessage'>;
export type MessageActionsProp = (param: MessageActionsParams) => MessageActionType[];
export declare const messageActions: ({ banUser, copyMessage, deleteMessage, editMessage, error, flagMessage, isMyMessage, isThreadMessage, markUnread, message, ownCapabilities, pinMessage, quotedReply, retry, showMessageReactions, threadReply, unpinMessage, }: MessageActionsParams) => MessageActionType[];
//# sourceMappingURL=messageActions.d.ts.map