import React from 'react';
import { ChatContextValue } from '../../contexts';
import { AttachmentPickerContextValue } from '../../contexts/attachmentPickerContext/AttachmentPickerContext';
import { ChannelContextValue } from '../../contexts/channelContext/ChannelContext';
import { MessageInputContextValue } from '../../contexts/messageInputContext/MessageInputContext';
import { MessagesContextValue } from '../../contexts/messagesContext/MessagesContext';
import { SuggestionsContextValue } from '../../contexts/suggestionsContext/SuggestionsContext';
import { ThreadContextValue } from '../../contexts/threadContext/ThreadContext';
import { TranslationContextValue } from '../../contexts/translationContext/TranslationContext';
type MessageInputPropsWithContext = Pick<AttachmentPickerContextValue, 'AttachmentPickerSelectionBar'> & Pick<ChatContextValue, 'isOnline'> & Pick<ChannelContextValue, 'channel' | 'members' | 'threadList' | 'watchers'> & Pick<MessageInputContextValue, 'additionalTextInputProps' | 'asyncIds' | 'audioRecordingEnabled' | 'asyncMessagesLockDistance' | 'asyncMessagesMinimumPressDuration' | 'asyncMessagesSlideToCancelDistance' | 'asyncMessagesMultiSendEnabled' | 'asyncUploads' | 'AudioRecorder' | 'AudioRecordingInProgress' | 'AudioRecordingLockIndicator' | 'AudioRecordingPreview' | 'cooldownEndsAt' | 'CooldownTimer' | 'clearEditingState' | 'clearQuotedMessageState' | 'closeAttachmentPicker' | 'compressImageQuality' | 'editing' | 'FileUploadPreview' | 'fileUploads' | 'giphyActive' | 'ImageUploadPreview' | 'imageUploads' | 'Input' | 'inputBoxRef' | 'InputButtons' | 'InputEditingStateHeader' | 'InputGiphySearch' | 'InputReplyStateHeader' | 'isValidMessage' | 'maxNumberOfFiles' | 'mentionedUsers' | 'numberOfUploads' | 'quotedMessage' | 'resetInput' | 'SendButton' | 'sending' | 'sendMessageAsync' | 'setShowMoreOptions' | 'setGiphyActive' | 'showMoreOptions' | 'ShowThreadMessageInChannelButton' | 'StartAudioRecordingButton' | 'removeFile' | 'removeImage' | 'text' | 'uploadNewFile' | 'uploadNewImage' | 'openPollCreationDialog' | 'closePollCreationDialog' | 'showPollCreationDialog' | 'sendMessage' | 'CreatePollContent' | 'StopMessageStreamingButton'> & Pick<MessagesContextValue, 'Reply'> & Pick<SuggestionsContextValue, 'AutoCompleteSuggestionHeader' | 'AutoCompleteSuggestionItem' | 'AutoCompleteSuggestionList' | 'suggestions' | 'triggerType'> & Pick<ThreadContextValue, 'thread'> & Pick<TranslationContextValue, 't'>;
export type MessageInputProps = Partial<MessageInputPropsWithContext>;
/**
 * UI Component for message input
 * It's a consumer of
 * [Channel Context](https://getstream.io/chat/docs/sdk/reactnative/contexts/channel-context/),
 * [Chat Context](https://getstream.io/chat/docs/sdk/reactnative/contexts/chat-context/),
 * [MessageInput Context](https://getstream.io/chat/docs/sdk/reactnative/contexts/message-input-context/),
 * [Suggestions Context](https://getstream.io/chat/docs/sdk/reactnative/contexts/suggestions-context/), and
 * [Translation Context](https://getstream.io/chat/docs/sdk/reactnative/contexts/translation-context/)
 */
export declare const MessageInput: {
    (props: MessageInputProps): React.JSX.Element;
    displayName: string;
};
export {};
//# sourceMappingURL=MessageInput.d.ts.map