import type { LocalMessage } from 'stream-chat';
import { DeletedMessagesVisibilityType } from '../../../contexts/messagesContext/MessagesContext';
import { DateSeparators } from '../utils/getDateSeparators';
export type UseMessageListParams = {
    deletedMessagesVisibilityType?: DeletedMessagesVisibilityType;
    noGroupByUser?: boolean;
    threadList?: boolean;
};
export type GroupType = string;
export type MessageGroupStyles = {
    [key: string]: string[];
};
export declare const shouldIncludeMessageInList: (message: LocalMessage, options: {
    deletedMessagesVisibilityType?: DeletedMessagesVisibilityType;
    userId?: string;
}) => boolean;
export declare const useMessageList: (params: UseMessageListParams) => {
    /** Date separators */
    dateSeparatorsRef: import("react").RefObject<DateSeparators>;
    /** Message group styles */
    messageGroupStylesRef: import("react").RefObject<MessageGroupStyles>;
    /** Messages enriched with dates/readby/groups and also reversed in order */
    processedMessageList: LocalMessage[];
    /** Raw messages from the channel state */
    rawMessageList: LocalMessage[];
};
//# sourceMappingURL=useMessageList.d.ts.map