import React, { PropsWithChildren } from 'react';
import { CreatePollData } from 'stream-chat';
import { MessageInputContextValue } from '../messageInputContext/MessageInputContext';
export type CreatePollContentContextValue = {
    createAndSendPoll: (pollData: CreatePollData) => Promise<void>;
    sendMessage: MessageInputContextValue['sendMessage'];
    /**
     * A property that defines the constant height of the options within the poll creation screen.
     *
     * **Default: ** 71
     */
    closePollCreationDialog?: () => void;
    createPollOptionHeight?: number;
};
export declare const CreatePollContentContext: React.Context<CreatePollContentContextValue>;
export declare const CreatePollContentProvider: ({ children, value, }: PropsWithChildren<{
    value: CreatePollContentContextValue;
}>) => React.JSX.Element;
export declare const useCreatePollContentContext: () => CreatePollContentContextValue;
//# sourceMappingURL=createPollContentContext.d.ts.map