import React from 'react';
import Dayjs from 'dayjs';
import type { TFunction } from 'i18next';
import type { Moment } from 'moment-timezone';
import type { TranslationLanguages } from 'stream-chat';
export declare const DEFAULT_USER_LANGUAGE: TranslationLanguages;
export declare const isDayOrMoment: (output: TDateTimeParserOutput) => output is Dayjs.Dayjs | Moment;
export type TDateTimeParserInput = string | number | Date;
export type TDateTimeParserOutput = string | number | Date | Dayjs.Dayjs | Moment;
export type TDateTimeParser = (input?: TDateTimeParserInput) => TDateTimeParserOutput;
export type TranslatorFunctions = {
    t: TFunction | ((key: string) => string);
    tDateTimeParser: TDateTimeParser;
};
export type TranslationContextValue = TranslatorFunctions & {
    userLanguage: TranslationLanguages;
};
export declare const TranslationContext: React.Context<TranslationContextValue>;
type Props = React.PropsWithChildren<{
    value: TranslationContextValue;
}>;
export declare const TranslationProvider: ({ children, value }: Props) => React.JSX.Element;
export declare const useTranslationContext: () => TranslationContextValue;
export {};
//# sourceMappingURL=TranslationContext.d.ts.map