import type { ReactionFilters, ReactionResponse, ReactionSort } from 'stream-chat';
/**
 * Fetches reactions for a message from the database based on the provided filters and sort.
 * @param currentMessageId The message ID for which reactions are to be fetched.
 * @param filters The filters to be applied while fetching reactions.
 * @param sort The sort to be applied while fetching reactions.
 */
export declare const getReactionsForFilterSort: ({ currentMessageId, filters, sort, }: {
    currentMessageId: string;
    filters?: ReactionFilters;
    sort?: ReactionSort;
}) => Promise<ReactionResponse[] | null>;
//# sourceMappingURL=getReactionsforFilterSort.d.ts.map