export type Emoji = {
  id: string;
  name: string;
  names: string[];
  unicode: string;
  skins?: string[];
};

export type Emojis = Emoji[];

export const compiledEmojis: Emojis = [
  {
    id: '+1',
    name: '+1',
    names: ['+1', 'thumbsup'],
    skins: ['👍🏻', '👍🏼', '👍🏽', '👍🏾', '👍🏿'],
    unicode: '👍',
  },
  {
    id: '-1',
    name: '-1',
    names: ['-1', 'thumbsdown'],
    skins: ['👎🏻', '👎🏼', '👎🏽', '👎🏾', '👎🏿'],
    unicode: '👎',
  },
  { id: '100', name: '100', names: ['100'], unicode: '💯' },
  { id: '1234', name: '1234', names: ['1234'], unicode: '🔢' },
  { id: '8ball', name: '8ball', names: ['8ball'], unicode: '🎱' },
  { id: 'a', name: 'a', names: ['a'], unicode: '🅰️' },
  { id: 'ab', name: 'ab', names: ['ab'], unicode: '🆎' },
  { id: 'abacus', name: 'abacus', names: ['abacus'], unicode: '🧮' },
  { id: 'abc', name: 'abc', names: ['abc'], unicode: '🔤' },
  { id: 'abcd', name: 'abcd', names: ['abcd'], unicode: '🔡' },
  { id: 'accept', name: 'accept', names: ['accept'], unicode: '🉑' },
  { id: 'accordion', name: 'accordion', names: ['accordion'], unicode: '🪗' },
  { id: 'adhesive_bandage', name: 'adhesive_bandage', names: ['adhesive_bandage'], unicode: '🩹' },
  {
    id: 'admission_tickets',
    name: 'admission_tickets',
    names: ['admission_tickets'],
    unicode: '🎟️',
  },
  {
    id: 'adult',
    name: 'adult',
    names: ['adult'],
    skins: ['🧑🏻', '🧑🏼', '🧑🏽', '🧑🏾', '🧑🏿'],
    unicode: '🧑',
  },
  { id: 'aerial_tramway', name: 'aerial_tramway', names: ['aerial_tramway'], unicode: '🚡' },
  { id: 'airplane', name: 'airplane', names: ['airplane'], unicode: '✈️' },
  {
    id: 'airplane_arriving',
    name: 'airplane_arriving',
    names: ['airplane_arriving'],
    unicode: '🛬',
  },
  {
    id: 'airplane_departure',
    name: 'airplane_departure',
    names: ['airplane_departure'],
    unicode: '🛫',
  },
  { id: 'alarm_clock', name: 'alarm_clock', names: ['alarm_clock'], unicode: '⏰' },
  { id: 'alembic', name: 'alembic', names: ['alembic'], unicode: '⚗️' },
  { id: 'alien', name: 'alien', names: ['alien'], unicode: '👽' },
  { id: 'ambulance', name: 'ambulance', names: ['ambulance'], unicode: '🚑' },
  { id: 'amphora', name: 'amphora', names: ['amphora'], unicode: '🏺' },
  { id: 'anatomical_heart', name: 'anatomical_heart', names: ['anatomical_heart'], unicode: '🫀' },
  { id: 'anchor', name: 'anchor', names: ['anchor'], unicode: '⚓' },
  {
    id: 'angel',
    name: 'angel',
    names: ['angel'],
    skins: ['👼🏻', '👼🏼', '👼🏽', '👼🏾', '👼🏿'],
    unicode: '👼',
  },
  { id: 'anger', name: 'anger', names: ['anger'], unicode: '💢' },
  { id: 'angry', name: 'angry', names: ['angry'], unicode: '😠' },
  { id: 'anguished', name: 'anguished', names: ['anguished'], unicode: '😧' },
  { id: 'ant', name: 'ant', names: ['ant'], unicode: '🐜' },
  { id: 'apple', name: 'apple', names: ['apple'], unicode: '🍎' },
  { id: 'aquarius', name: 'aquarius', names: ['aquarius'], unicode: '♒' },
  { id: 'aries', name: 'aries', names: ['aries'], unicode: '♈' },
  { id: 'arrow_backward', name: 'arrow_backward', names: ['arrow_backward'], unicode: '◀️' },
  {
    id: 'arrow_double_down',
    name: 'arrow_double_down',
    names: ['arrow_double_down'],
    unicode: '⏬',
  },
  { id: 'arrow_double_up', name: 'arrow_double_up', names: ['arrow_double_up'], unicode: '⏫' },
  { id: 'arrow_down', name: 'arrow_down', names: ['arrow_down'], unicode: '⬇️' },
  { id: 'arrow_down_small', name: 'arrow_down_small', names: ['arrow_down_small'], unicode: '🔽' },
  { id: 'arrow_forward', name: 'arrow_forward', names: ['arrow_forward'], unicode: '▶️' },
  {
    id: 'arrow_heading_down',
    name: 'arrow_heading_down',
    names: ['arrow_heading_down'],
    unicode: '⤵️',
  },
  { id: 'arrow_heading_up', name: 'arrow_heading_up', names: ['arrow_heading_up'], unicode: '⤴️' },
  { id: 'arrow_left', name: 'arrow_left', names: ['arrow_left'], unicode: '⬅️' },
  { id: 'arrow_lower_left', name: 'arrow_lower_left', names: ['arrow_lower_left'], unicode: '↙️' },
  {
    id: 'arrow_lower_right',
    name: 'arrow_lower_right',
    names: ['arrow_lower_right'],
    unicode: '↘️',
  },
  { id: 'arrow_right', name: 'arrow_right', names: ['arrow_right'], unicode: '➡️' },
  { id: 'arrow_right_hook', name: 'arrow_right_hook', names: ['arrow_right_hook'], unicode: '↪️' },
  { id: 'arrow_up', name: 'arrow_up', names: ['arrow_up'], unicode: '⬆️' },
  { id: 'arrow_up_down', name: 'arrow_up_down', names: ['arrow_up_down'], unicode: '↕️' },
  { id: 'arrow_up_small', name: 'arrow_up_small', names: ['arrow_up_small'], unicode: '🔼' },
  { id: 'arrow_upper_left', name: 'arrow_upper_left', names: ['arrow_upper_left'], unicode: '↖️' },
  {
    id: 'arrow_upper_right',
    name: 'arrow_upper_right',
    names: ['arrow_upper_right'],
    unicode: '↗️',
  },
  { id: 'arrows_clockwise', name: 'arrows_clockwise', names: ['arrows_clockwise'], unicode: '🔃' },
  {
    id: 'arrows_counterclockwise',
    name: 'arrows_counterclockwise',
    names: ['arrows_counterclockwise'],
    unicode: '🔄',
  },
  { id: 'art', name: 'art', names: ['art'], unicode: '🎨' },
  {
    id: 'articulated_lorry',
    name: 'articulated_lorry',
    names: ['articulated_lorry'],
    unicode: '🚛',
  },
  {
    id: 'artist',
    name: 'artist',
    names: ['artist'],
    skins: ['🧑🏻‍🎨', '🧑🏼‍🎨', '🧑🏽‍🎨', '🧑🏾‍🎨', '🧑🏿‍🎨'],
    unicode: '🧑‍🎨',
  },
  { id: 'astonished', name: 'astonished', names: ['astonished'], unicode: '😲' },
  {
    id: 'astronaut',
    name: 'astronaut',
    names: ['astronaut'],
    skins: ['🧑🏻‍🚀', '🧑🏼‍🚀', '🧑🏽‍🚀', '🧑🏾‍🚀', '🧑🏿‍🚀'],
    unicode: '🧑‍🚀',
  },
  { id: 'athletic_shoe', name: 'athletic_shoe', names: ['athletic_shoe'], unicode: '👟' },
  { id: 'atm', name: 'atm', names: ['atm'], unicode: '🏧' },
  { id: 'atom_symbol', name: 'atom_symbol', names: ['atom_symbol'], unicode: '⚛️' },
  { id: 'auto_rickshaw', name: 'auto_rickshaw', names: ['auto_rickshaw'], unicode: '🛺' },
  { id: 'avocado', name: 'avocado', names: ['avocado'], unicode: '🥑' },
  { id: 'axe', name: 'axe', names: ['axe'], unicode: '🪓' },
  { id: 'b', name: 'b', names: ['b'], unicode: '🅱️' },
  {
    id: 'baby',
    name: 'baby',
    names: ['baby'],
    skins: ['👶🏻', '👶🏼', '👶🏽', '👶🏾', '👶🏿'],
    unicode: '👶',
  },
  { id: 'baby_bottle', name: 'baby_bottle', names: ['baby_bottle'], unicode: '🍼' },
  { id: 'baby_chick', name: 'baby_chick', names: ['baby_chick'], unicode: '🐤' },
  { id: 'baby_symbol', name: 'baby_symbol', names: ['baby_symbol'], unicode: '🚼' },
  { id: 'back', name: 'back', names: ['back'], unicode: '🔙' },
  { id: 'bacon', name: 'bacon', names: ['bacon'], unicode: '🥓' },
  { id: 'badger', name: 'badger', names: ['badger'], unicode: '🦡' },
  {
    id: 'badminton_racquet_and_shuttlecock',
    name: 'badminton_racquet_and_shuttlecock',
    names: ['badminton_racquet_and_shuttlecock'],
    unicode: '🏸',
  },
  { id: 'bagel', name: 'bagel', names: ['bagel'], unicode: '🥯' },
  { id: 'baggage_claim', name: 'baggage_claim', names: ['baggage_claim'], unicode: '🛄' },
  { id: 'baguette_bread', name: 'baguette_bread', names: ['baguette_bread'], unicode: '🥖' },
  {
    id: 'bald_man',
    name: 'bald_man',
    names: ['bald_man'],
    skins: ['👨🏻‍🦲', '👨🏼‍🦲', '👨🏽‍🦲', '👨🏾‍🦲', '👨🏿‍🦲'],
    unicode: '👨‍🦲',
  },
  {
    id: 'bald_person',
    name: 'bald_person',
    names: ['bald_person'],
    skins: ['🧑🏻‍🦲', '🧑🏼‍🦲', '🧑🏽‍🦲', '🧑🏾‍🦲', '🧑🏿‍🦲'],
    unicode: '🧑‍🦲',
  },
  {
    id: 'bald_woman',
    name: 'bald_woman',
    names: ['bald_woman'],
    skins: ['👩🏻‍🦲', '👩🏼‍🦲', '👩🏽‍🦲', '👩🏾‍🦲', '👩🏿‍🦲'],
    unicode: '👩‍🦲',
  },
  { id: 'ballet_shoes', name: 'ballet_shoes', names: ['ballet_shoes'], unicode: '🩰' },
  { id: 'balloon', name: 'balloon', names: ['balloon'], unicode: '🎈' },
  {
    id: 'ballot_box_with_ballot',
    name: 'ballot_box_with_ballot',
    names: ['ballot_box_with_ballot'],
    unicode: '🗳️',
  },
  {
    id: 'ballot_box_with_check',
    name: 'ballot_box_with_check',
    names: ['ballot_box_with_check'],
    unicode: '☑️',
  },
  { id: 'bamboo', name: 'bamboo', names: ['bamboo'], unicode: '🎍' },
  { id: 'banana', name: 'banana', names: ['banana'], unicode: '🍌' },
  { id: 'bangbang', name: 'bangbang', names: ['bangbang'], unicode: '‼️' },
  { id: 'banjo', name: 'banjo', names: ['banjo'], unicode: '🪕' },
  { id: 'bank', name: 'bank', names: ['bank'], unicode: '🏦' },
  { id: 'bar_chart', name: 'bar_chart', names: ['bar_chart'], unicode: '📊' },
  { id: 'barber', name: 'barber', names: ['barber'], unicode: '💈' },
  {
    id: 'barely_sunny',
    name: 'barely_sunny',
    names: ['barely_sunny', 'sun_behind_cloud'],
    unicode: '🌥️',
  },
  { id: 'baseball', name: 'baseball', names: ['baseball'], unicode: '⚾' },
  { id: 'basket', name: 'basket', names: ['basket'], unicode: '🧺' },
  { id: 'basketball', name: 'basketball', names: ['basketball'], unicode: '🏀' },
  { id: 'bat', name: 'bat', names: ['bat'], unicode: '🦇' },
  {
    id: 'bath',
    name: 'bath',
    names: ['bath'],
    skins: ['🛀🏻', '🛀🏼', '🛀🏽', '🛀🏾', '🛀🏿'],
    unicode: '🛀',
  },
  { id: 'bathtub', name: 'bathtub', names: ['bathtub'], unicode: '🛁' },
  { id: 'battery', name: 'battery', names: ['battery'], unicode: '🔋' },
  {
    id: 'beach_with_umbrella',
    name: 'beach_with_umbrella',
    names: ['beach_with_umbrella'],
    unicode: '🏖️',
  },
  { id: 'beans', name: 'beans', names: ['beans'], unicode: '🫘' },
  { id: 'bear', name: 'bear', names: ['bear'], unicode: '🐻' },
  {
    id: 'bearded_person',
    name: 'bearded_person',
    names: ['bearded_person'],
    skins: ['🧔🏻', '🧔🏼', '🧔🏽', '🧔🏾', '🧔🏿'],
    unicode: '🧔',
  },
  { id: 'beaver', name: 'beaver', names: ['beaver'], unicode: '🦫' },
  { id: 'bed', name: 'bed', names: ['bed'], unicode: '🛏️' },
  { id: 'bee', name: 'bee', names: ['bee', 'honeybee'], unicode: '🐝' },
  { id: 'beer', name: 'beer', names: ['beer'], unicode: '🍺' },
  { id: 'beers', name: 'beers', names: ['beers'], unicode: '🍻' },
  { id: 'beetle', name: 'beetle', names: ['beetle'], unicode: '🪲' },
  { id: 'beginner', name: 'beginner', names: ['beginner'], unicode: '🔰' },
  { id: 'bell', name: 'bell', names: ['bell'], unicode: '🔔' },
  { id: 'bell_pepper', name: 'bell_pepper', names: ['bell_pepper'], unicode: '🫑' },
  { id: 'bellhop_bell', name: 'bellhop_bell', names: ['bellhop_bell'], unicode: '🛎️' },
  { id: 'bento', name: 'bento', names: ['bento'], unicode: '🍱' },
  { id: 'beverage_box', name: 'beverage_box', names: ['beverage_box'], unicode: '🧃' },
  {
    id: 'bicyclist',
    name: 'bicyclist',
    names: ['bicyclist'],
    skins: ['🚴🏻', '🚴🏼', '🚴🏽', '🚴🏾', '🚴🏿'],
    unicode: '🚴',
  },
  { id: 'bike', name: 'bike', names: ['bike'], unicode: '🚲' },
  { id: 'bikini', name: 'bikini', names: ['bikini'], unicode: '👙' },
  { id: 'billed_cap', name: 'billed_cap', names: ['billed_cap'], unicode: '🧢' },
  { id: 'biohazard_sign', name: 'biohazard_sign', names: ['biohazard_sign'], unicode: '☣️' },
  { id: 'bird', name: 'bird', names: ['bird'], unicode: '🐦' },
  { id: 'birthday', name: 'birthday', names: ['birthday'], unicode: '🎂' },
  { id: 'bison', name: 'bison', names: ['bison'], unicode: '🦬' },
  { id: 'biting_lip', name: 'biting_lip', names: ['biting_lip'], unicode: '🫦' },
  { id: 'black_bird', name: 'black_bird', names: ['black_bird'], unicode: '🐦‍⬛' },
  { id: 'black_cat', name: 'black_cat', names: ['black_cat'], unicode: '🐈‍⬛' },
  { id: 'black_circle', name: 'black_circle', names: ['black_circle'], unicode: '⚫' },
  {
    id: 'black_circle_for_record',
    name: 'black_circle_for_record',
    names: ['black_circle_for_record'],
    unicode: '⏺️',
  },
  { id: 'black_heart', name: 'black_heart', names: ['black_heart'], unicode: '🖤' },
  { id: 'black_joker', name: 'black_joker', names: ['black_joker'], unicode: '🃏' },
  {
    id: 'black_large_square',
    name: 'black_large_square',
    names: ['black_large_square'],
    unicode: '⬛',
  },
  {
    id: 'black_left_pointing_double_triangle_with_vertical_bar',
    name: 'black_left_pointing_double_triangle_with_vertical_bar',
    names: ['black_left_pointing_double_triangle_with_vertical_bar'],
    unicode: '⏮️',
  },
  {
    id: 'black_medium_small_square',
    name: 'black_medium_small_square',
    names: ['black_medium_small_square'],
    unicode: '◾',
  },
  {
    id: 'black_medium_square',
    name: 'black_medium_square',
    names: ['black_medium_square'],
    unicode: '◼️',
  },
  { id: 'black_nib', name: 'black_nib', names: ['black_nib'], unicode: '✒️' },
  {
    id: 'black_right_pointing_double_triangle_with_vertical_bar',
    name: 'black_right_pointing_double_triangle_with_vertical_bar',
    names: ['black_right_pointing_double_triangle_with_vertical_bar'],
    unicode: '⏭️',
  },
  {
    id: 'black_right_pointing_triangle_with_double_vertical_bar',
    name: 'black_right_pointing_triangle_with_double_vertical_bar',
    names: ['black_right_pointing_triangle_with_double_vertical_bar'],
    unicode: '⏯️',
  },
  {
    id: 'black_small_square',
    name: 'black_small_square',
    names: ['black_small_square'],
    unicode: '▪️',
  },
  {
    id: 'black_square_button',
    name: 'black_square_button',
    names: ['black_square_button'],
    unicode: '🔲',
  },
  {
    id: 'black_square_for_stop',
    name: 'black_square_for_stop',
    names: ['black_square_for_stop'],
    unicode: '⏹️',
  },
  {
    id: 'blond-haired-man',
    name: 'blond-haired-man',
    names: ['blond-haired-man'],
    skins: ['👱🏻‍♂️', '👱🏼‍♂️', '👱🏽‍♂️', '👱🏾‍♂️', '👱🏿‍♂️'],
    unicode: '👱‍♂️',
  },
  {
    id: 'blond-haired-woman',
    name: 'blond-haired-woman',
    names: ['blond-haired-woman'],
    skins: ['👱🏻‍♀️', '👱🏼‍♀️', '👱🏽‍♀️', '👱🏾‍♀️', '👱🏿‍♀️'],
    unicode: '👱‍♀️',
  },
  { id: 'blossom', name: 'blossom', names: ['blossom'], unicode: '🌼' },
  { id: 'blowfish', name: 'blowfish', names: ['blowfish'], unicode: '🐡' },
  { id: 'blue_book', name: 'blue_book', names: ['blue_book'], unicode: '📘' },
  { id: 'blue_car', name: 'blue_car', names: ['blue_car'], unicode: '🚙' },
  { id: 'blue_heart', name: 'blue_heart', names: ['blue_heart'], unicode: '💙' },
  { id: 'blueberries', name: 'blueberries', names: ['blueberries'], unicode: '🫐' },
  { id: 'blush', name: 'blush', names: ['blush'], unicode: '😊' },
  { id: 'boar', name: 'boar', names: ['boar'], unicode: '🐗' },
  { id: 'boat', name: 'boat', names: ['boat', 'sailboat'], unicode: '⛵' },
  { id: 'bomb', name: 'bomb', names: ['bomb'], unicode: '💣' },
  { id: 'bone', name: 'bone', names: ['bone'], unicode: '🦴' },
  { id: 'book', name: 'book', names: ['book', 'open_book'], unicode: '📖' },
  { id: 'bookmark', name: 'bookmark', names: ['bookmark'], unicode: '🔖' },
  { id: 'bookmark_tabs', name: 'bookmark_tabs', names: ['bookmark_tabs'], unicode: '📑' },
  { id: 'books', name: 'books', names: ['books'], unicode: '📚' },
  { id: 'boom', name: 'boom', names: ['boom', 'collision'], unicode: '💥' },
  { id: 'boomerang', name: 'boomerang', names: ['boomerang'], unicode: '🪃' },
  { id: 'boot', name: 'boot', names: ['boot'], unicode: '👢' },
  { id: 'bouquet', name: 'bouquet', names: ['bouquet'], unicode: '💐' },
  { id: 'bow', name: 'bow', names: ['bow'], skins: ['🙇🏻', '🙇🏼', '🙇🏽', '🙇🏾', '🙇🏿'], unicode: '🙇' },
  { id: 'bow_and_arrow', name: 'bow_and_arrow', names: ['bow_and_arrow'], unicode: '🏹' },
  { id: 'bowl_with_spoon', name: 'bowl_with_spoon', names: ['bowl_with_spoon'], unicode: '🥣' },
  { id: 'bowling', name: 'bowling', names: ['bowling'], unicode: '🎳' },
  { id: 'boxing_glove', name: 'boxing_glove', names: ['boxing_glove'], unicode: '🥊' },
  { id: 'boy', name: 'boy', names: ['boy'], skins: ['👦🏻', '👦🏼', '👦🏽', '👦🏾', '👦🏿'], unicode: '👦' },
  { id: 'brain', name: 'brain', names: ['brain'], unicode: '🧠' },
  { id: 'bread', name: 'bread', names: ['bread'], unicode: '🍞' },
  {
    id: 'breast-feeding',
    name: 'breast-feeding',
    names: ['breast-feeding'],
    skins: ['🤱🏻', '🤱🏼', '🤱🏽', '🤱🏾', '🤱🏿'],
    unicode: '🤱',
  },
  { id: 'bricks', name: 'bricks', names: ['bricks'], unicode: '🧱' },
  {
    id: 'bride_with_veil',
    name: 'bride_with_veil',
    names: ['bride_with_veil'],
    skins: ['👰🏻', '👰🏼', '👰🏽', '👰🏾', '👰🏿'],
    unicode: '👰',
  },
  { id: 'bridge_at_night', name: 'bridge_at_night', names: ['bridge_at_night'], unicode: '🌉' },
  { id: 'briefcase', name: 'briefcase', names: ['briefcase'], unicode: '💼' },
  { id: 'briefs', name: 'briefs', names: ['briefs'], unicode: '🩲' },
  { id: 'broccoli', name: 'broccoli', names: ['broccoli'], unicode: '🥦' },
  { id: 'broken_chain', name: 'broken_chain', names: ['broken_chain'], unicode: '⛓️‍💥' },
  { id: 'broken_heart', name: 'broken_heart', names: ['broken_heart'], unicode: '💔' },
  { id: 'broom', name: 'broom', names: ['broom'], unicode: '🧹' },
  { id: 'brown_heart', name: 'brown_heart', names: ['brown_heart'], unicode: '🤎' },
  { id: 'brown_mushroom', name: 'brown_mushroom', names: ['brown_mushroom'], unicode: '🍄‍🟫' },
  { id: 'bubble_tea', name: 'bubble_tea', names: ['bubble_tea'], unicode: '🧋' },
  { id: 'bubbles', name: 'bubbles', names: ['bubbles'], unicode: '🫧' },
  { id: 'bucket', name: 'bucket', names: ['bucket'], unicode: '🪣' },
  { id: 'bug', name: 'bug', names: ['bug'], unicode: '🐛' },
  {
    id: 'building_construction',
    name: 'building_construction',
    names: ['building_construction'],
    unicode: '🏗️',
  },
  { id: 'bulb', name: 'bulb', names: ['bulb'], unicode: '💡' },
  {
    id: 'bullettrain_front',
    name: 'bullettrain_front',
    names: ['bullettrain_front'],
    unicode: '🚅',
  },
  { id: 'bullettrain_side', name: 'bullettrain_side', names: ['bullettrain_side'], unicode: '🚄' },
  { id: 'burrito', name: 'burrito', names: ['burrito'], unicode: '🌯' },
  { id: 'bus', name: 'bus', names: ['bus'], unicode: '🚌' },
  { id: 'busstop', name: 'busstop', names: ['busstop'], unicode: '🚏' },
  {
    id: 'bust_in_silhouette',
    name: 'bust_in_silhouette',
    names: ['bust_in_silhouette'],
    unicode: '👤',
  },
  {
    id: 'busts_in_silhouette',
    name: 'busts_in_silhouette',
    names: ['busts_in_silhouette'],
    unicode: '👥',
  },
  { id: 'butter', name: 'butter', names: ['butter'], unicode: '🧈' },
  { id: 'butterfly', name: 'butterfly', names: ['butterfly'], unicode: '🦋' },
  { id: 'cactus', name: 'cactus', names: ['cactus'], unicode: '🌵' },
  { id: 'cake', name: 'cake', names: ['cake'], unicode: '🍰' },
  { id: 'calendar', name: 'calendar', names: ['calendar'], unicode: '📆' },
  {
    id: 'call_me_hand',
    name: 'call_me_hand',
    names: ['call_me_hand'],
    skins: ['🤙🏻', '🤙🏼', '🤙🏽', '🤙🏾', '🤙🏿'],
    unicode: '🤙',
  },
  { id: 'calling', name: 'calling', names: ['calling'], unicode: '📲' },
  { id: 'camel', name: 'camel', names: ['camel'], unicode: '🐫' },
  { id: 'camera', name: 'camera', names: ['camera'], unicode: '📷' },
  {
    id: 'camera_with_flash',
    name: 'camera_with_flash',
    names: ['camera_with_flash'],
    unicode: '📸',
  },
  { id: 'camping', name: 'camping', names: ['camping'], unicode: '🏕️' },
  { id: 'cancer', name: 'cancer', names: ['cancer'], unicode: '♋' },
  { id: 'candle', name: 'candle', names: ['candle'], unicode: '🕯️' },
  { id: 'candy', name: 'candy', names: ['candy'], unicode: '🍬' },
  { id: 'canned_food', name: 'canned_food', names: ['canned_food'], unicode: '🥫' },
  { id: 'canoe', name: 'canoe', names: ['canoe'], unicode: '🛶' },
  { id: 'capital_abcd', name: 'capital_abcd', names: ['capital_abcd'], unicode: '🔠' },
  { id: 'capricorn', name: 'capricorn', names: ['capricorn'], unicode: '♑' },
  { id: 'car', name: 'car', names: ['car', 'red_car'], unicode: '🚗' },
  { id: 'card_file_box', name: 'card_file_box', names: ['card_file_box'], unicode: '🗃️' },
  { id: 'card_index', name: 'card_index', names: ['card_index'], unicode: '📇' },
  {
    id: 'card_index_dividers',
    name: 'card_index_dividers',
    names: ['card_index_dividers'],
    unicode: '🗂️',
  },
  { id: 'carousel_horse', name: 'carousel_horse', names: ['carousel_horse'], unicode: '🎠' },
  { id: 'carpentry_saw', name: 'carpentry_saw', names: ['carpentry_saw'], unicode: '🪚' },
  { id: 'carrot', name: 'carrot', names: ['carrot'], unicode: '🥕' },
  { id: 'cat', name: 'cat', names: ['cat'], unicode: '🐱' },
  { id: 'cat2', name: 'cat2', names: ['cat2'], unicode: '🐈' },
  { id: 'cd', name: 'cd', names: ['cd'], unicode: '💿' },
  { id: 'chains', name: 'chains', names: ['chains'], unicode: '⛓️' },
  { id: 'chair', name: 'chair', names: ['chair'], unicode: '🪑' },
  { id: 'champagne', name: 'champagne', names: ['champagne'], unicode: '🍾' },
  { id: 'chart', name: 'chart', names: ['chart'], unicode: '💹' },
  {
    id: 'chart_with_downwards_trend',
    name: 'chart_with_downwards_trend',
    names: ['chart_with_downwards_trend'],
    unicode: '📉',
  },
  {
    id: 'chart_with_upwards_trend',
    name: 'chart_with_upwards_trend',
    names: ['chart_with_upwards_trend'],
    unicode: '📈',
  },
  { id: 'checkered_flag', name: 'checkered_flag', names: ['checkered_flag'], unicode: '🏁' },
  { id: 'cheese_wedge', name: 'cheese_wedge', names: ['cheese_wedge'], unicode: '🧀' },
  { id: 'cherries', name: 'cherries', names: ['cherries'], unicode: '🍒' },
  { id: 'cherry_blossom', name: 'cherry_blossom', names: ['cherry_blossom'], unicode: '🌸' },
  { id: 'chess_pawn', name: 'chess_pawn', names: ['chess_pawn'], unicode: '♟️' },
  { id: 'chestnut', name: 'chestnut', names: ['chestnut'], unicode: '🌰' },
  { id: 'chicken', name: 'chicken', names: ['chicken'], unicode: '🐔' },
  {
    id: 'child',
    name: 'child',
    names: ['child'],
    skins: ['🧒🏻', '🧒🏼', '🧒🏽', '🧒🏾', '🧒🏿'],
    unicode: '🧒',
  },
  {
    id: 'children_crossing',
    name: 'children_crossing',
    names: ['children_crossing'],
    unicode: '🚸',
  },
  { id: 'chipmunk', name: 'chipmunk', names: ['chipmunk'], unicode: '🐿️' },
  { id: 'chocolate_bar', name: 'chocolate_bar', names: ['chocolate_bar'], unicode: '🍫' },
  { id: 'chopsticks', name: 'chopsticks', names: ['chopsticks'], unicode: '🥢' },
  { id: 'christmas_tree', name: 'christmas_tree', names: ['christmas_tree'], unicode: '🎄' },
  { id: 'church', name: 'church', names: ['church'], unicode: '⛪' },
  { id: 'cinema', name: 'cinema', names: ['cinema'], unicode: '🎦' },
  { id: 'circus_tent', name: 'circus_tent', names: ['circus_tent'], unicode: '🎪' },
  { id: 'city_sunrise', name: 'city_sunrise', names: ['city_sunrise'], unicode: '🌇' },
  { id: 'city_sunset', name: 'city_sunset', names: ['city_sunset'], unicode: '🌆' },
  { id: 'cityscape', name: 'cityscape', names: ['cityscape'], unicode: '🏙️' },
  { id: 'cl', name: 'cl', names: ['cl'], unicode: '🆑' },
  {
    id: 'clap',
    name: 'clap',
    names: ['clap'],
    skins: ['👏🏻', '👏🏼', '👏🏽', '👏🏾', '👏🏿'],
    unicode: '👏',
  },
  { id: 'clapper', name: 'clapper', names: ['clapper'], unicode: '🎬' },
  {
    id: 'classical_building',
    name: 'classical_building',
    names: ['classical_building'],
    unicode: '🏛️',
  },
  { id: 'clinking_glasses', name: 'clinking_glasses', names: ['clinking_glasses'], unicode: '🥂' },
  { id: 'clipboard', name: 'clipboard', names: ['clipboard'], unicode: '📋' },
  { id: 'clock1', name: 'clock1', names: ['clock1'], unicode: '🕐' },
  { id: 'clock10', name: 'clock10', names: ['clock10'], unicode: '🕙' },
  { id: 'clock1030', name: 'clock1030', names: ['clock1030'], unicode: '🕥' },
  { id: 'clock11', name: 'clock11', names: ['clock11'], unicode: '🕚' },
  { id: 'clock1130', name: 'clock1130', names: ['clock1130'], unicode: '🕦' },
  { id: 'clock12', name: 'clock12', names: ['clock12'], unicode: '🕛' },
  { id: 'clock1230', name: 'clock1230', names: ['clock1230'], unicode: '🕧' },
  { id: 'clock130', name: 'clock130', names: ['clock130'], unicode: '🕜' },
  { id: 'clock2', name: 'clock2', names: ['clock2'], unicode: '🕑' },
  { id: 'clock230', name: 'clock230', names: ['clock230'], unicode: '🕝' },
  { id: 'clock3', name: 'clock3', names: ['clock3'], unicode: '🕒' },
  { id: 'clock330', name: 'clock330', names: ['clock330'], unicode: '🕞' },
  { id: 'clock4', name: 'clock4', names: ['clock4'], unicode: '🕓' },
  { id: 'clock430', name: 'clock430', names: ['clock430'], unicode: '🕟' },
  { id: 'clock5', name: 'clock5', names: ['clock5'], unicode: '🕔' },
  { id: 'clock530', name: 'clock530', names: ['clock530'], unicode: '🕠' },
  { id: 'clock6', name: 'clock6', names: ['clock6'], unicode: '🕕' },
  { id: 'clock630', name: 'clock630', names: ['clock630'], unicode: '🕡' },
  { id: 'clock7', name: 'clock7', names: ['clock7'], unicode: '🕖' },
  { id: 'clock730', name: 'clock730', names: ['clock730'], unicode: '🕢' },
  { id: 'clock8', name: 'clock8', names: ['clock8'], unicode: '🕗' },
  { id: 'clock830', name: 'clock830', names: ['clock830'], unicode: '🕣' },
  { id: 'clock9', name: 'clock9', names: ['clock9'], unicode: '🕘' },
  { id: 'clock930', name: 'clock930', names: ['clock930'], unicode: '🕤' },
  { id: 'closed_book', name: 'closed_book', names: ['closed_book'], unicode: '📕' },
  {
    id: 'closed_lock_with_key',
    name: 'closed_lock_with_key',
    names: ['closed_lock_with_key'],
    unicode: '🔐',
  },
  { id: 'closed_umbrella', name: 'closed_umbrella', names: ['closed_umbrella'], unicode: '🌂' },
  { id: 'cloud', name: 'cloud', names: ['cloud'], unicode: '☁️' },
  { id: 'clown_face', name: 'clown_face', names: ['clown_face'], unicode: '🤡' },
  { id: 'clubs', name: 'clubs', names: ['clubs'], unicode: '♣️' },
  { id: 'cn', name: 'cn', names: ['cn', 'flag-cn'], unicode: '🇨🇳' },
  { id: 'coat', name: 'coat', names: ['coat'], unicode: '🧥' },
  { id: 'cockroach', name: 'cockroach', names: ['cockroach'], unicode: '🪳' },
  { id: 'cocktail', name: 'cocktail', names: ['cocktail'], unicode: '🍸' },
  { id: 'coconut', name: 'coconut', names: ['coconut'], unicode: '🥥' },
  { id: 'coffee', name: 'coffee', names: ['coffee'], unicode: '☕' },
  { id: 'coffin', name: 'coffin', names: ['coffin'], unicode: '⚰️' },
  { id: 'coin', name: 'coin', names: ['coin'], unicode: '🪙' },
  { id: 'cold_face', name: 'cold_face', names: ['cold_face'], unicode: '🥶' },
  { id: 'cold_sweat', name: 'cold_sweat', names: ['cold_sweat'], unicode: '😰' },
  { id: 'comet', name: 'comet', names: ['comet'], unicode: '☄️' },
  { id: 'compass', name: 'compass', names: ['compass'], unicode: '🧭' },
  { id: 'compression', name: 'compression', names: ['compression'], unicode: '🗜️' },
  { id: 'computer', name: 'computer', names: ['computer'], unicode: '💻' },
  { id: 'confetti_ball', name: 'confetti_ball', names: ['confetti_ball'], unicode: '🎊' },
  { id: 'confounded', name: 'confounded', names: ['confounded'], unicode: '😖' },
  { id: 'confused', name: 'confused', names: ['confused'], unicode: '😕' },
  { id: 'congratulations', name: 'congratulations', names: ['congratulations'], unicode: '㊗️' },
  { id: 'construction', name: 'construction', names: ['construction'], unicode: '🚧' },
  {
    id: 'construction_worker',
    name: 'construction_worker',
    names: ['construction_worker'],
    skins: ['👷🏻', '👷🏼', '👷🏽', '👷🏾', '👷🏿'],
    unicode: '👷',
  },
  { id: 'control_knobs', name: 'control_knobs', names: ['control_knobs'], unicode: '🎛️' },
  {
    id: 'convenience_store',
    name: 'convenience_store',
    names: ['convenience_store'],
    unicode: '🏪',
  },
  {
    id: 'cook',
    name: 'cook',
    names: ['cook'],
    skins: ['🧑🏻‍🍳', '🧑🏼‍🍳', '🧑🏽‍🍳', '🧑🏾‍🍳', '🧑🏿‍🍳'],
    unicode: '🧑‍🍳',
  },
  { id: 'cookie', name: 'cookie', names: ['cookie'], unicode: '🍪' },
  { id: 'cool', name: 'cool', names: ['cool'], unicode: '🆒' },
  { id: 'cop', name: 'cop', names: ['cop'], skins: ['👮🏻', '👮🏼', '👮🏽', '👮🏾', '👮🏿'], unicode: '👮' },
  { id: 'copyright', name: 'copyright', names: ['copyright'], unicode: '©️' },
  { id: 'coral', name: 'coral', names: ['coral'], unicode: '🪸' },
  { id: 'corn', name: 'corn', names: ['corn'], unicode: '🌽' },
  { id: 'couch_and_lamp', name: 'couch_and_lamp', names: ['couch_and_lamp'], unicode: '🛋️' },
  {
    id: 'couple_with_heart',
    name: 'couple_with_heart',
    names: ['couple_with_heart'],
    skins: [
      '💑🏻',
      '💑🏼',
      '💑🏽',
      '💑🏾',
      '💑🏿',
      '🧑🏻‍❤️‍🧑🏼',
      '🧑🏻‍❤️‍🧑🏽',
      '🧑🏻‍❤️‍🧑🏾',
      '🧑🏻‍❤️‍🧑🏿',
      '🧑🏼‍❤️‍🧑🏻',
      '🧑🏼‍❤️‍🧑🏽',
      '🧑🏼‍❤️‍🧑🏾',
      '🧑🏼‍❤️‍🧑🏿',
      '🧑🏽‍❤️‍🧑🏻',
      '🧑🏽‍❤️‍🧑🏼',
      '🧑🏽‍❤️‍🧑🏾',
      '🧑🏽‍❤️‍🧑🏿',
      '🧑🏾‍❤️‍🧑🏻',
      '🧑🏾‍❤️‍🧑🏼',
      '🧑🏾‍❤️‍🧑🏽',
      '🧑🏾‍❤️‍🧑🏿',
      '🧑🏿‍❤️‍🧑🏻',
      '🧑🏿‍❤️‍🧑🏼',
      '🧑🏿‍❤️‍🧑🏽',
      '🧑🏿‍❤️‍🧑🏾',
    ],
    unicode: '💑',
  },
  {
    id: 'couplekiss',
    name: 'couplekiss',
    names: ['couplekiss'],
    skins: [
      '💏🏻',
      '💏🏼',
      '💏🏽',
      '💏🏾',
      '💏🏿',
      '🧑🏻‍❤️‍💋‍🧑🏼',
      '🧑🏻‍❤️‍💋‍🧑🏽',
      '🧑🏻‍❤️‍💋‍🧑🏾',
      '🧑🏻‍❤️‍💋‍🧑🏿',
      '🧑🏼‍❤️‍💋‍🧑🏻',
      '🧑🏼‍❤️‍💋‍🧑🏽',
      '🧑🏼‍❤️‍💋‍🧑🏾',
      '🧑🏼‍❤️‍💋‍🧑🏿',
      '🧑🏽‍❤️‍💋‍🧑🏻',
      '🧑🏽‍❤️‍💋‍🧑🏼',
      '🧑🏽‍❤️‍💋‍🧑🏾',
      '🧑🏽‍❤️‍💋‍🧑🏿',
      '🧑🏾‍❤️‍💋‍🧑🏻',
      '🧑🏾‍❤️‍💋‍🧑🏼',
      '🧑🏾‍❤️‍💋‍🧑🏽',
      '🧑🏾‍❤️‍💋‍🧑🏿',
      '🧑🏿‍❤️‍💋‍🧑🏻',
      '🧑🏿‍❤️‍💋‍🧑🏼',
      '🧑🏿‍❤️‍💋‍🧑🏽',
      '🧑🏿‍❤️‍💋‍🧑🏾',
    ],
    unicode: '💏',
  },
  { id: 'cow', name: 'cow', names: ['cow'], unicode: '🐮' },
  { id: 'cow2', name: 'cow2', names: ['cow2'], unicode: '🐄' },
  { id: 'crab', name: 'crab', names: ['crab'], unicode: '🦀' },
  { id: 'credit_card', name: 'credit_card', names: ['credit_card'], unicode: '💳' },
  { id: 'crescent_moon', name: 'crescent_moon', names: ['crescent_moon'], unicode: '🌙' },
  { id: 'cricket', name: 'cricket', names: ['cricket'], unicode: '🦗' },
  {
    id: 'cricket_bat_and_ball',
    name: 'cricket_bat_and_ball',
    names: ['cricket_bat_and_ball'],
    unicode: '🏏',
  },
  { id: 'crocodile', name: 'crocodile', names: ['crocodile'], unicode: '🐊' },
  { id: 'croissant', name: 'croissant', names: ['croissant'], unicode: '🥐' },
  {
    id: 'crossed_fingers',
    name: 'crossed_fingers',
    names: ['crossed_fingers', 'hand_with_index_and_middle_fingers_crossed'],
    skins: ['🤞🏻', '🤞🏼', '🤞🏽', '🤞🏾', '🤞🏿'],
    unicode: '🤞',
  },
  { id: 'crossed_flags', name: 'crossed_flags', names: ['crossed_flags'], unicode: '🎌' },
  { id: 'crossed_swords', name: 'crossed_swords', names: ['crossed_swords'], unicode: '⚔️' },
  { id: 'crown', name: 'crown', names: ['crown'], unicode: '👑' },
  { id: 'crutch', name: 'crutch', names: ['crutch'], unicode: '🩼' },
  { id: 'cry', name: 'cry', names: ['cry'], unicode: '😢' },
  { id: 'crying_cat_face', name: 'crying_cat_face', names: ['crying_cat_face'], unicode: '😿' },
  { id: 'crystal_ball', name: 'crystal_ball', names: ['crystal_ball'], unicode: '🔮' },
  { id: 'cucumber', name: 'cucumber', names: ['cucumber'], unicode: '🥒' },
  { id: 'cup_with_straw', name: 'cup_with_straw', names: ['cup_with_straw'], unicode: '🥤' },
  { id: 'cupcake', name: 'cupcake', names: ['cupcake'], unicode: '🧁' },
  { id: 'cupid', name: 'cupid', names: ['cupid'], unicode: '💘' },
  { id: 'curling_stone', name: 'curling_stone', names: ['curling_stone'], unicode: '🥌' },
  {
    id: 'curly_haired_man',
    name: 'curly_haired_man',
    names: ['curly_haired_man'],
    skins: ['👨🏻‍🦱', '👨🏼‍🦱', '👨🏽‍🦱', '👨🏾‍🦱', '👨🏿‍🦱'],
    unicode: '👨‍🦱',
  },
  {
    id: 'curly_haired_person',
    name: 'curly_haired_person',
    names: ['curly_haired_person'],
    skins: ['🧑🏻‍🦱', '🧑🏼‍🦱', '🧑🏽‍🦱', '🧑🏾‍🦱', '🧑🏿‍🦱'],
    unicode: '🧑‍🦱',
  },
  {
    id: 'curly_haired_woman',
    name: 'curly_haired_woman',
    names: ['curly_haired_woman'],
    skins: ['👩🏻‍🦱', '👩🏼‍🦱', '👩🏽‍🦱', '👩🏾‍🦱', '👩🏿‍🦱'],
    unicode: '👩‍🦱',
  },
  { id: 'curly_loop', name: 'curly_loop', names: ['curly_loop'], unicode: '➰' },
  {
    id: 'currency_exchange',
    name: 'currency_exchange',
    names: ['currency_exchange'],
    unicode: '💱',
  },
  { id: 'curry', name: 'curry', names: ['curry'], unicode: '🍛' },
  { id: 'custard', name: 'custard', names: ['custard'], unicode: '🍮' },
  { id: 'customs', name: 'customs', names: ['customs'], unicode: '🛃' },
  { id: 'cut_of_meat', name: 'cut_of_meat', names: ['cut_of_meat'], unicode: '🥩' },
  { id: 'cyclone', name: 'cyclone', names: ['cyclone'], unicode: '🌀' },
  { id: 'dagger_knife', name: 'dagger_knife', names: ['dagger_knife'], unicode: '🗡️' },
  {
    id: 'dancer',
    name: 'dancer',
    names: ['dancer'],
    skins: ['💃🏻', '💃🏼', '💃🏽', '💃🏾', '💃🏿'],
    unicode: '💃',
  },
  { id: 'dancers', name: 'dancers', names: ['dancers'], unicode: '👯' },
  { id: 'dango', name: 'dango', names: ['dango'], unicode: '🍡' },
  { id: 'dark_sunglasses', name: 'dark_sunglasses', names: ['dark_sunglasses'], unicode: '🕶️' },
  { id: 'dart', name: 'dart', names: ['dart'], unicode: '🎯' },
  { id: 'dash', name: 'dash', names: ['dash'], unicode: '💨' },
  { id: 'date', name: 'date', names: ['date'], unicode: '📅' },
  { id: 'de', name: 'de', names: ['de', 'flag-de'], unicode: '🇩🇪' },
  {
    id: 'deaf_man',
    name: 'deaf_man',
    names: ['deaf_man'],
    skins: ['🧏🏻‍♂️', '🧏🏼‍♂️', '🧏🏽‍♂️', '🧏🏾‍♂️', '🧏🏿‍♂️'],
    unicode: '🧏‍♂️',
  },
  {
    id: 'deaf_person',
    name: 'deaf_person',
    names: ['deaf_person'],
    skins: ['🧏🏻', '🧏🏼', '🧏🏽', '🧏🏾', '🧏🏿'],
    unicode: '🧏',
  },
  {
    id: 'deaf_woman',
    name: 'deaf_woman',
    names: ['deaf_woman'],
    skins: ['🧏🏻‍♀️', '🧏🏼‍♀️', '🧏🏽‍♀️', '🧏🏾‍♀️', '🧏🏿‍♀️'],
    unicode: '🧏‍♀️',
  },
  { id: 'deciduous_tree', name: 'deciduous_tree', names: ['deciduous_tree'], unicode: '🌳' },
  { id: 'deer', name: 'deer', names: ['deer'], unicode: '🦌' },
  { id: 'department_store', name: 'department_store', names: ['department_store'], unicode: '🏬' },
  {
    id: 'derelict_house_building',
    name: 'derelict_house_building',
    names: ['derelict_house_building'],
    unicode: '🏚️',
  },
  { id: 'desert', name: 'desert', names: ['desert'], unicode: '🏜️' },
  { id: 'desert_island', name: 'desert_island', names: ['desert_island'], unicode: '🏝️' },
  { id: 'desktop_computer', name: 'desktop_computer', names: ['desktop_computer'], unicode: '🖥️' },
  {
    id: 'diamond_shape_with_a_dot_inside',
    name: 'diamond_shape_with_a_dot_inside',
    names: ['diamond_shape_with_a_dot_inside'],
    unicode: '💠',
  },
  { id: 'diamonds', name: 'diamonds', names: ['diamonds'], unicode: '♦️' },
  { id: 'disappointed', name: 'disappointed', names: ['disappointed'], unicode: '😞' },
  {
    id: 'disappointed_relieved',
    name: 'disappointed_relieved',
    names: ['disappointed_relieved'],
    unicode: '😥',
  },
  { id: 'disguised_face', name: 'disguised_face', names: ['disguised_face'], unicode: '🥸' },
  { id: 'diving_mask', name: 'diving_mask', names: ['diving_mask'], unicode: '🤿' },
  { id: 'diya_lamp', name: 'diya_lamp', names: ['diya_lamp'], unicode: '🪔' },
  { id: 'dizzy', name: 'dizzy', names: ['dizzy'], unicode: '💫' },
  { id: 'dizzy_face', name: 'dizzy_face', names: ['dizzy_face'], unicode: '😵' },
  { id: 'dna', name: 'dna', names: ['dna'], unicode: '🧬' },
  { id: 'do_not_litter', name: 'do_not_litter', names: ['do_not_litter'], unicode: '🚯' },
  { id: 'dodo', name: 'dodo', names: ['dodo'], unicode: '🦤' },
  { id: 'dog', name: 'dog', names: ['dog'], unicode: '🐶' },
  { id: 'dog2', name: 'dog2', names: ['dog2'], unicode: '🐕' },
  { id: 'dollar', name: 'dollar', names: ['dollar'], unicode: '💵' },
  { id: 'dolls', name: 'dolls', names: ['dolls'], unicode: '🎎' },
  { id: 'dolphin', name: 'dolphin', names: ['dolphin', 'flipper'], unicode: '🐬' },
  { id: 'donkey', name: 'donkey', names: ['donkey'], unicode: '🫏' },
  { id: 'door', name: 'door', names: ['door'], unicode: '🚪' },
  { id: 'dotted_line_face', name: 'dotted_line_face', names: ['dotted_line_face'], unicode: '🫥' },
  {
    id: 'double_vertical_bar',
    name: 'double_vertical_bar',
    names: ['double_vertical_bar'],
    unicode: '⏸️',
  },
  { id: 'doughnut', name: 'doughnut', names: ['doughnut'], unicode: '🍩' },
  { id: 'dove_of_peace', name: 'dove_of_peace', names: ['dove_of_peace'], unicode: '🕊️' },
  { id: 'dragon', name: 'dragon', names: ['dragon'], unicode: '🐉' },
  { id: 'dragon_face', name: 'dragon_face', names: ['dragon_face'], unicode: '🐲' },
  { id: 'dress', name: 'dress', names: ['dress'], unicode: '👗' },
  { id: 'dromedary_camel', name: 'dromedary_camel', names: ['dromedary_camel'], unicode: '🐪' },
  { id: 'drooling_face', name: 'drooling_face', names: ['drooling_face'], unicode: '🤤' },
  { id: 'drop_of_blood', name: 'drop_of_blood', names: ['drop_of_blood'], unicode: '🩸' },
  { id: 'droplet', name: 'droplet', names: ['droplet'], unicode: '💧' },
  {
    id: 'drum_with_drumsticks',
    name: 'drum_with_drumsticks',
    names: ['drum_with_drumsticks'],
    unicode: '🥁',
  },
  { id: 'duck', name: 'duck', names: ['duck'], unicode: '🦆' },
  { id: 'dumpling', name: 'dumpling', names: ['dumpling'], unicode: '🥟' },
  { id: 'dvd', name: 'dvd', names: ['dvd'], unicode: '📀' },
  { id: 'e-mail', name: 'e-mail', names: ['e-mail'], unicode: '📧' },
  { id: 'eagle', name: 'eagle', names: ['eagle'], unicode: '🦅' },
  { id: 'ear', name: 'ear', names: ['ear'], skins: ['👂🏻', '👂🏼', '👂🏽', '👂🏾', '👂🏿'], unicode: '👂' },
  { id: 'ear_of_rice', name: 'ear_of_rice', names: ['ear_of_rice'], unicode: '🌾' },
  {
    id: 'ear_with_hearing_aid',
    name: 'ear_with_hearing_aid',
    names: ['ear_with_hearing_aid'],
    skins: ['🦻🏻', '🦻🏼', '🦻🏽', '🦻🏾', '🦻🏿'],
    unicode: '🦻',
  },
  { id: 'earth_africa', name: 'earth_africa', names: ['earth_africa'], unicode: '🌍' },
  { id: 'earth_americas', name: 'earth_americas', names: ['earth_americas'], unicode: '🌎' },
  { id: 'earth_asia', name: 'earth_asia', names: ['earth_asia'], unicode: '🌏' },
  { id: 'egg', name: 'egg', names: ['egg'], unicode: '🥚' },
  { id: 'eggplant', name: 'eggplant', names: ['eggplant'], unicode: '🍆' },
  { id: 'eight', name: 'eight', names: ['eight'], unicode: '8️⃣' },
  {
    id: 'eight_pointed_black_star',
    name: 'eight_pointed_black_star',
    names: ['eight_pointed_black_star'],
    unicode: '✴️',
  },
  {
    id: 'eight_spoked_asterisk',
    name: 'eight_spoked_asterisk',
    names: ['eight_spoked_asterisk'],
    unicode: '✳️',
  },
  { id: 'eject', name: 'eject', names: ['eject'], unicode: '⏏️' },
  { id: 'electric_plug', name: 'electric_plug', names: ['electric_plug'], unicode: '🔌' },
  { id: 'elephant', name: 'elephant', names: ['elephant'], unicode: '🐘' },
  { id: 'elevator', name: 'elevator', names: ['elevator'], unicode: '🛗' },
  { id: 'elf', name: 'elf', names: ['elf'], skins: ['🧝🏻', '🧝🏼', '🧝🏽', '🧝🏾', '🧝🏿'], unicode: '🧝' },
  { id: 'email', name: 'email', names: ['email', 'envelope'], unicode: '✉️' },
  { id: 'empty_nest', name: 'empty_nest', names: ['empty_nest'], unicode: '🪹' },
  { id: 'end', name: 'end', names: ['end'], unicode: '🔚' },
  {
    id: 'envelope_with_arrow',
    name: 'envelope_with_arrow',
    names: ['envelope_with_arrow'],
    unicode: '📩',
  },
  { id: 'es', name: 'es', names: ['es', 'flag-es'], unicode: '🇪🇸' },
  { id: 'euro', name: 'euro', names: ['euro'], unicode: '💶' },
  { id: 'european_castle', name: 'european_castle', names: ['european_castle'], unicode: '🏰' },
  {
    id: 'european_post_office',
    name: 'european_post_office',
    names: ['european_post_office'],
    unicode: '🏤',
  },
  { id: 'evergreen_tree', name: 'evergreen_tree', names: ['evergreen_tree'], unicode: '🌲' },
  {
    id: 'exclamation',
    name: 'exclamation',
    names: ['exclamation', 'heavy_exclamation_mark'],
    unicode: '❗',
  },
  {
    id: 'exploding_head',
    name: 'exploding_head',
    names: ['exploding_head', 'shocked_face_with_exploding_head'],
    unicode: '🤯',
  },
  { id: 'expressionless', name: 'expressionless', names: ['expressionless'], unicode: '😑' },
  { id: 'eye', name: 'eye', names: ['eye'], unicode: '👁️' },
  {
    id: 'eye-in-speech-bubble',
    name: 'eye-in-speech-bubble',
    names: ['eye-in-speech-bubble'],
    unicode: '👁️‍🗨️',
  },
  { id: 'eyeglasses', name: 'eyeglasses', names: ['eyeglasses'], unicode: '👓' },
  { id: 'eyes', name: 'eyes', names: ['eyes'], unicode: '👀' },
  { id: 'face_exhaling', name: 'face_exhaling', names: ['face_exhaling'], unicode: '😮‍💨' },
  {
    id: 'face_holding_back_tears',
    name: 'face_holding_back_tears',
    names: ['face_holding_back_tears'],
    unicode: '🥹',
  },
  { id: 'face_in_clouds', name: 'face_in_clouds', names: ['face_in_clouds'], unicode: '😶‍🌫️' },
  {
    id: 'face_palm',
    name: 'face_palm',
    names: ['face_palm'],
    skins: ['🤦🏻', '🤦🏼', '🤦🏽', '🤦🏾', '🤦🏿'],
    unicode: '🤦',
  },
  {
    id: 'face_vomiting',
    name: 'face_vomiting',
    names: ['face_vomiting', 'face_with_open_mouth_vomiting'],
    unicode: '🤮',
  },
  {
    id: 'face_with_cowboy_hat',
    name: 'face_with_cowboy_hat',
    names: ['face_with_cowboy_hat'],
    unicode: '🤠',
  },
  {
    id: 'face_with_diagonal_mouth',
    name: 'face_with_diagonal_mouth',
    names: ['face_with_diagonal_mouth'],
    unicode: '🫤',
  },
  {
    id: 'face_with_hand_over_mouth',
    name: 'face_with_hand_over_mouth',
    names: ['face_with_hand_over_mouth', 'smiling_face_with_smiling_eyes_and_hand_covering_mouth'],
    unicode: '🤭',
  },
  {
    id: 'face_with_head_bandage',
    name: 'face_with_head_bandage',
    names: ['face_with_head_bandage'],
    unicode: '🤕',
  },
  {
    id: 'face_with_monocle',
    name: 'face_with_monocle',
    names: ['face_with_monocle'],
    unicode: '🧐',
  },
  {
    id: 'face_with_open_eyes_and_hand_over_mouth',
    name: 'face_with_open_eyes_and_hand_over_mouth',
    names: ['face_with_open_eyes_and_hand_over_mouth'],
    unicode: '🫢',
  },
  {
    id: 'face_with_peeking_eye',
    name: 'face_with_peeking_eye',
    names: ['face_with_peeking_eye'],
    unicode: '🫣',
  },
  {
    id: 'face_with_raised_eyebrow',
    name: 'face_with_raised_eyebrow',
    names: ['face_with_raised_eyebrow', 'face_with_one_eyebrow_raised'],
    unicode: '🤨',
  },
  {
    id: 'face_with_rolling_eyes',
    name: 'face_with_rolling_eyes',
    names: ['face_with_rolling_eyes'],
    unicode: '🙄',
  },
  {
    id: 'face_with_spiral_eyes',
    name: 'face_with_spiral_eyes',
    names: ['face_with_spiral_eyes'],
    unicode: '😵‍💫',
  },
  {
    id: 'face_with_symbols_on_mouth',
    name: 'face_with_symbols_on_mouth',
    names: ['face_with_symbols_on_mouth', 'serious_face_with_symbols_covering_mouth'],
    unicode: '🤬',
  },
  {
    id: 'face_with_thermometer',
    name: 'face_with_thermometer',
    names: ['face_with_thermometer'],
    unicode: '🤒',
  },
  {
    id: 'facepunch',
    name: 'facepunch',
    names: ['facepunch', 'punch'],
    skins: ['👊🏻', '👊🏼', '👊🏽', '👊🏾', '👊🏿'],
    unicode: '👊',
  },
  { id: 'factory', name: 'factory', names: ['factory'], unicode: '🏭' },
  {
    id: 'factory_worker',
    name: 'factory_worker',
    names: ['factory_worker'],
    skins: ['🧑🏻‍🏭', '🧑🏼‍🏭', '🧑🏽‍🏭', '🧑🏾‍🏭', '🧑🏿‍🏭'],
    unicode: '🧑‍🏭',
  },
  {
    id: 'fairy',
    name: 'fairy',
    names: ['fairy'],
    skins: ['🧚🏻', '🧚🏼', '🧚🏽', '🧚🏾', '🧚🏿'],
    unicode: '🧚',
  },
  { id: 'falafel', name: 'falafel', names: ['falafel'], unicode: '🧆' },
  { id: 'fallen_leaf', name: 'fallen_leaf', names: ['fallen_leaf'], unicode: '🍂' },
  { id: 'family', name: 'family', names: ['family'], unicode: '👪' },
  {
    id: 'family_adult_adult_child',
    name: 'family_adult_adult_child',
    names: ['family_adult_adult_child'],
    unicode: '🧑‍🧑‍🧒',
  },
  {
    id: 'family_adult_adult_child_child',
    name: 'family_adult_adult_child_child',
    names: ['family_adult_adult_child_child'],
    unicode: '🧑‍🧑‍🧒‍🧒',
  },
  {
    id: 'family_adult_child',
    name: 'family_adult_child',
    names: ['family_adult_child'],
    unicode: '🧑‍🧒',
  },
  {
    id: 'family_adult_child_child',
    name: 'family_adult_child_child',
    names: ['family_adult_child_child'],
    unicode: '🧑‍🧒‍🧒',
  },
  {
    id: 'farmer',
    name: 'farmer',
    names: ['farmer'],
    skins: ['🧑🏻‍🌾', '🧑🏼‍🌾', '🧑🏽‍🌾', '🧑🏾‍🌾', '🧑🏿‍🌾'],
    unicode: '🧑‍🌾',
  },
  { id: 'fast_forward', name: 'fast_forward', names: ['fast_forward'], unicode: '⏩' },
  { id: 'fax', name: 'fax', names: ['fax'], unicode: '📠' },
  { id: 'fearful', name: 'fearful', names: ['fearful'], unicode: '😨' },
  { id: 'feather', name: 'feather', names: ['feather'], unicode: '🪶' },
  { id: 'feet', name: 'feet', names: ['feet', 'paw_prints'], unicode: '🐾' },
  {
    id: 'female-artist',
    name: 'female-artist',
    names: ['female-artist'],
    skins: ['👩🏻‍🎨', '👩🏼‍🎨', '👩🏽‍🎨', '👩🏾‍🎨', '👩🏿‍🎨'],
    unicode: '👩‍🎨',
  },
  {
    id: 'female-astronaut',
    name: 'female-astronaut',
    names: ['female-astronaut'],
    skins: ['👩🏻‍🚀', '👩🏼‍🚀', '👩🏽‍🚀', '👩🏾‍🚀', '👩🏿‍🚀'],
    unicode: '👩‍🚀',
  },
  {
    id: 'female-construction-worker',
    name: 'female-construction-worker',
    names: ['female-construction-worker'],
    skins: ['👷🏻‍♀️', '👷🏼‍♀️', '👷🏽‍♀️', '👷🏾‍♀️', '👷🏿‍♀️'],
    unicode: '👷‍♀️',
  },
  {
    id: 'female-cook',
    name: 'female-cook',
    names: ['female-cook'],
    skins: ['👩🏻‍🍳', '👩🏼‍🍳', '👩🏽‍🍳', '👩🏾‍🍳', '👩🏿‍🍳'],
    unicode: '👩‍🍳',
  },
  {
    id: 'female-detective',
    name: 'female-detective',
    names: ['female-detective'],
    skins: ['🕵🏻‍♀️', '🕵🏼‍♀️', '🕵🏽‍♀️', '🕵🏾‍♀️', '🕵🏿‍♀️'],
    unicode: '🕵️‍♀️',
  },
  {
    id: 'female-doctor',
    name: 'female-doctor',
    names: ['female-doctor'],
    skins: ['👩🏻‍⚕️', '👩🏼‍⚕️', '👩🏽‍⚕️', '👩🏾‍⚕️', '👩🏿‍⚕️'],
    unicode: '👩‍⚕️',
  },
  {
    id: 'female-factory-worker',
    name: 'female-factory-worker',
    names: ['female-factory-worker'],
    skins: ['👩🏻‍🏭', '👩🏼‍🏭', '👩🏽‍🏭', '👩🏾‍🏭', '👩🏿‍🏭'],
    unicode: '👩‍🏭',
  },
  {
    id: 'female-farmer',
    name: 'female-farmer',
    names: ['female-farmer'],
    skins: ['👩🏻‍🌾', '👩🏼‍🌾', '👩🏽‍🌾', '👩🏾‍🌾', '👩🏿‍🌾'],
    unicode: '👩‍🌾',
  },
  {
    id: 'female-firefighter',
    name: 'female-firefighter',
    names: ['female-firefighter'],
    skins: ['👩🏻‍🚒', '👩🏼‍🚒', '👩🏽‍🚒', '👩🏾‍🚒', '👩🏿‍🚒'],
    unicode: '👩‍🚒',
  },
  {
    id: 'female-guard',
    name: 'female-guard',
    names: ['female-guard'],
    skins: ['💂🏻‍♀️', '💂🏼‍♀️', '💂🏽‍♀️', '💂🏾‍♀️', '💂🏿‍♀️'],
    unicode: '💂‍♀️',
  },
  {
    id: 'female-judge',
    name: 'female-judge',
    names: ['female-judge'],
    skins: ['👩🏻‍⚖️', '👩🏼‍⚖️', '👩🏽‍⚖️', '👩🏾‍⚖️', '👩🏿‍⚖️'],
    unicode: '👩‍⚖️',
  },
  {
    id: 'female-mechanic',
    name: 'female-mechanic',
    names: ['female-mechanic'],
    skins: ['👩🏻‍🔧', '👩🏼‍🔧', '👩🏽‍🔧', '👩🏾‍🔧', '👩🏿‍🔧'],
    unicode: '👩‍🔧',
  },
  {
    id: 'female-office-worker',
    name: 'female-office-worker',
    names: ['female-office-worker'],
    skins: ['👩🏻‍💼', '👩🏼‍💼', '👩🏽‍💼', '👩🏾‍💼', '👩🏿‍💼'],
    unicode: '👩‍💼',
  },
  {
    id: 'female-pilot',
    name: 'female-pilot',
    names: ['female-pilot'],
    skins: ['👩🏻‍✈️', '👩🏼‍✈️', '👩🏽‍✈️', '👩🏾‍✈️', '👩🏿‍✈️'],
    unicode: '👩‍✈️',
  },
  {
    id: 'female-police-officer',
    name: 'female-police-officer',
    names: ['female-police-officer'],
    skins: ['👮🏻‍♀️', '👮🏼‍♀️', '👮🏽‍♀️', '👮🏾‍♀️', '👮🏿‍♀️'],
    unicode: '👮‍♀️',
  },
  {
    id: 'female-scientist',
    name: 'female-scientist',
    names: ['female-scientist'],
    skins: ['👩🏻‍🔬', '👩🏼‍🔬', '👩🏽‍🔬', '👩🏾‍🔬', '👩🏿‍🔬'],
    unicode: '👩‍🔬',
  },
  {
    id: 'female-singer',
    name: 'female-singer',
    names: ['female-singer'],
    skins: ['👩🏻‍🎤', '👩🏼‍🎤', '👩🏽‍🎤', '👩🏾‍🎤', '👩🏿‍🎤'],
    unicode: '👩‍🎤',
  },
  {
    id: 'female-student',
    name: 'female-student',
    names: ['female-student'],
    skins: ['👩🏻‍🎓', '👩🏼‍🎓', '👩🏽‍🎓', '👩🏾‍🎓', '👩🏿‍🎓'],
    unicode: '👩‍🎓',
  },
  {
    id: 'female-teacher',
    name: 'female-teacher',
    names: ['female-teacher'],
    skins: ['👩🏻‍🏫', '👩🏼‍🏫', '👩🏽‍🏫', '👩🏾‍🏫', '👩🏿‍🏫'],
    unicode: '👩‍🏫',
  },
  {
    id: 'female-technologist',
    name: 'female-technologist',
    names: ['female-technologist'],
    skins: ['👩🏻‍💻', '👩🏼‍💻', '👩🏽‍💻', '👩🏾‍💻', '👩🏿‍💻'],
    unicode: '👩‍💻',
  },
  {
    id: 'female_elf',
    name: 'female_elf',
    names: ['female_elf'],
    skins: ['🧝🏻‍♀️', '🧝🏼‍♀️', '🧝🏽‍♀️', '🧝🏾‍♀️', '🧝🏿‍♀️'],
    unicode: '🧝‍♀️',
  },
  {
    id: 'female_fairy',
    name: 'female_fairy',
    names: ['female_fairy'],
    skins: ['🧚🏻‍♀️', '🧚🏼‍♀️', '🧚🏽‍♀️', '🧚🏾‍♀️', '🧚🏿‍♀️'],
    unicode: '🧚‍♀️',
  },
  { id: 'female_genie', name: 'female_genie', names: ['female_genie'], unicode: '🧞‍♀️' },
  {
    id: 'female_mage',
    name: 'female_mage',
    names: ['female_mage'],
    skins: ['🧙🏻‍♀️', '🧙🏼‍♀️', '🧙🏽‍♀️', '🧙🏾‍♀️', '🧙🏿‍♀️'],
    unicode: '🧙‍♀️',
  },
  { id: 'female_sign', name: 'female_sign', names: ['female_sign'], unicode: '♀️' },
  {
    id: 'female_superhero',
    name: 'female_superhero',
    names: ['female_superhero'],
    skins: ['🦸🏻‍♀️', '🦸🏼‍♀️', '🦸🏽‍♀️', '🦸🏾‍♀️', '🦸🏿‍♀️'],
    unicode: '🦸‍♀️',
  },
  {
    id: 'female_supervillain',
    name: 'female_supervillain',
    names: ['female_supervillain'],
    skins: ['🦹🏻‍♀️', '🦹🏼‍♀️', '🦹🏽‍♀️', '🦹🏾‍♀️', '🦹🏿‍♀️'],
    unicode: '🦹‍♀️',
  },
  {
    id: 'female_vampire',
    name: 'female_vampire',
    names: ['female_vampire'],
    skins: ['🧛🏻‍♀️', '🧛🏼‍♀️', '🧛🏽‍♀️', '🧛🏾‍♀️', '🧛🏿‍♀️'],
    unicode: '🧛‍♀️',
  },
  { id: 'female_zombie', name: 'female_zombie', names: ['female_zombie'], unicode: '🧟‍♀️' },
  { id: 'fencer', name: 'fencer', names: ['fencer'], unicode: '🤺' },
  { id: 'ferris_wheel', name: 'ferris_wheel', names: ['ferris_wheel'], unicode: '🎡' },
  { id: 'ferry', name: 'ferry', names: ['ferry'], unicode: '⛴️' },
  {
    id: 'field_hockey_stick_and_ball',
    name: 'field_hockey_stick_and_ball',
    names: ['field_hockey_stick_and_ball'],
    unicode: '🏑',
  },
  { id: 'file_cabinet', name: 'file_cabinet', names: ['file_cabinet'], unicode: '🗄️' },
  { id: 'file_folder', name: 'file_folder', names: ['file_folder'], unicode: '📁' },
  { id: 'film_frames', name: 'film_frames', names: ['film_frames'], unicode: '🎞️' },
  { id: 'film_projector', name: 'film_projector', names: ['film_projector'], unicode: '📽️' },
  { id: 'fire', name: 'fire', names: ['fire'], unicode: '🔥' },
  { id: 'fire_engine', name: 'fire_engine', names: ['fire_engine'], unicode: '🚒' },
  {
    id: 'fire_extinguisher',
    name: 'fire_extinguisher',
    names: ['fire_extinguisher'],
    unicode: '🧯',
  },
  { id: 'firecracker', name: 'firecracker', names: ['firecracker'], unicode: '🧨' },
  {
    id: 'firefighter',
    name: 'firefighter',
    names: ['firefighter'],
    skins: ['🧑🏻‍🚒', '🧑🏼‍🚒', '🧑🏽‍🚒', '🧑🏾‍🚒', '🧑🏿‍🚒'],
    unicode: '🧑‍🚒',
  },
  { id: 'fireworks', name: 'fireworks', names: ['fireworks'], unicode: '🎆' },
  {
    id: 'first_place_medal',
    name: 'first_place_medal',
    names: ['first_place_medal'],
    unicode: '🥇',
  },
  {
    id: 'first_quarter_moon',
    name: 'first_quarter_moon',
    names: ['first_quarter_moon'],
    unicode: '🌓',
  },
  {
    id: 'first_quarter_moon_with_face',
    name: 'first_quarter_moon_with_face',
    names: ['first_quarter_moon_with_face'],
    unicode: '🌛',
  },
  { id: 'fish', name: 'fish', names: ['fish'], unicode: '🐟' },
  { id: 'fish_cake', name: 'fish_cake', names: ['fish_cake'], unicode: '🍥' },
  {
    id: 'fishing_pole_and_fish',
    name: 'fishing_pole_and_fish',
    names: ['fishing_pole_and_fish'],
    unicode: '🎣',
  },
  {
    id: 'fist',
    name: 'fist',
    names: ['fist'],
    skins: ['✊🏻', '✊🏼', '✊🏽', '✊🏾', '✊🏿'],
    unicode: '✊',
  },
  { id: 'five', name: 'five', names: ['five'], unicode: '5️⃣' },
  { id: 'flag-ac', name: 'flag-ac', names: ['flag-ac'], unicode: '🇦🇨' },
  { id: 'flag-ad', name: 'flag-ad', names: ['flag-ad'], unicode: '🇦🇩' },
  { id: 'flag-ae', name: 'flag-ae', names: ['flag-ae'], unicode: '🇦🇪' },
  { id: 'flag-af', name: 'flag-af', names: ['flag-af'], unicode: '🇦🇫' },
  { id: 'flag-ag', name: 'flag-ag', names: ['flag-ag'], unicode: '🇦🇬' },
  { id: 'flag-ai', name: 'flag-ai', names: ['flag-ai'], unicode: '🇦🇮' },
  { id: 'flag-al', name: 'flag-al', names: ['flag-al'], unicode: '🇦🇱' },
  { id: 'flag-am', name: 'flag-am', names: ['flag-am'], unicode: '🇦🇲' },
  { id: 'flag-ao', name: 'flag-ao', names: ['flag-ao'], unicode: '🇦🇴' },
  { id: 'flag-aq', name: 'flag-aq', names: ['flag-aq'], unicode: '🇦🇶' },
  { id: 'flag-ar', name: 'flag-ar', names: ['flag-ar'], unicode: '🇦🇷' },
  { id: 'flag-as', name: 'flag-as', names: ['flag-as'], unicode: '🇦🇸' },
  { id: 'flag-at', name: 'flag-at', names: ['flag-at'], unicode: '🇦🇹' },
  { id: 'flag-au', name: 'flag-au', names: ['flag-au'], unicode: '🇦🇺' },
  { id: 'flag-aw', name: 'flag-aw', names: ['flag-aw'], unicode: '🇦🇼' },
  { id: 'flag-ax', name: 'flag-ax', names: ['flag-ax'], unicode: '🇦🇽' },
  { id: 'flag-az', name: 'flag-az', names: ['flag-az'], unicode: '🇦🇿' },
  { id: 'flag-ba', name: 'flag-ba', names: ['flag-ba'], unicode: '🇧🇦' },
  { id: 'flag-bb', name: 'flag-bb', names: ['flag-bb'], unicode: '🇧🇧' },
  { id: 'flag-bd', name: 'flag-bd', names: ['flag-bd'], unicode: '🇧🇩' },
  { id: 'flag-be', name: 'flag-be', names: ['flag-be'], unicode: '🇧🇪' },
  { id: 'flag-bf', name: 'flag-bf', names: ['flag-bf'], unicode: '🇧🇫' },
  { id: 'flag-bg', name: 'flag-bg', names: ['flag-bg'], unicode: '🇧🇬' },
  { id: 'flag-bh', name: 'flag-bh', names: ['flag-bh'], unicode: '🇧🇭' },
  { id: 'flag-bi', name: 'flag-bi', names: ['flag-bi'], unicode: '🇧🇮' },
  { id: 'flag-bj', name: 'flag-bj', names: ['flag-bj'], unicode: '🇧🇯' },
  { id: 'flag-bl', name: 'flag-bl', names: ['flag-bl'], unicode: '🇧🇱' },
  { id: 'flag-bm', name: 'flag-bm', names: ['flag-bm'], unicode: '🇧🇲' },
  { id: 'flag-bn', name: 'flag-bn', names: ['flag-bn'], unicode: '🇧🇳' },
  { id: 'flag-bo', name: 'flag-bo', names: ['flag-bo'], unicode: '🇧🇴' },
  { id: 'flag-bq', name: 'flag-bq', names: ['flag-bq'], unicode: '🇧🇶' },
  { id: 'flag-br', name: 'flag-br', names: ['flag-br'], unicode: '🇧🇷' },
  { id: 'flag-bs', name: 'flag-bs', names: ['flag-bs'], unicode: '🇧🇸' },
  { id: 'flag-bt', name: 'flag-bt', names: ['flag-bt'], unicode: '🇧🇹' },
  { id: 'flag-bv', name: 'flag-bv', names: ['flag-bv'], unicode: '🇧🇻' },
  { id: 'flag-bw', name: 'flag-bw', names: ['flag-bw'], unicode: '🇧🇼' },
  { id: 'flag-by', name: 'flag-by', names: ['flag-by'], unicode: '🇧🇾' },
  { id: 'flag-bz', name: 'flag-bz', names: ['flag-bz'], unicode: '🇧🇿' },
  { id: 'flag-ca', name: 'flag-ca', names: ['flag-ca'], unicode: '🇨🇦' },
  { id: 'flag-cc', name: 'flag-cc', names: ['flag-cc'], unicode: '🇨🇨' },
  { id: 'flag-cd', name: 'flag-cd', names: ['flag-cd'], unicode: '🇨🇩' },
  { id: 'flag-cf', name: 'flag-cf', names: ['flag-cf'], unicode: '🇨🇫' },
  { id: 'flag-cg', name: 'flag-cg', names: ['flag-cg'], unicode: '🇨🇬' },
  { id: 'flag-ch', name: 'flag-ch', names: ['flag-ch'], unicode: '🇨🇭' },
  { id: 'flag-ci', name: 'flag-ci', names: ['flag-ci'], unicode: '🇨🇮' },
  { id: 'flag-ck', name: 'flag-ck', names: ['flag-ck'], unicode: '🇨🇰' },
  { id: 'flag-cl', name: 'flag-cl', names: ['flag-cl'], unicode: '🇨🇱' },
  { id: 'flag-cm', name: 'flag-cm', names: ['flag-cm'], unicode: '🇨🇲' },
  { id: 'flag-co', name: 'flag-co', names: ['flag-co'], unicode: '🇨🇴' },
  { id: 'flag-cp', name: 'flag-cp', names: ['flag-cp'], unicode: '🇨🇵' },
  { id: 'flag-cr', name: 'flag-cr', names: ['flag-cr'], unicode: '🇨🇷' },
  { id: 'flag-cu', name: 'flag-cu', names: ['flag-cu'], unicode: '🇨🇺' },
  { id: 'flag-cv', name: 'flag-cv', names: ['flag-cv'], unicode: '🇨🇻' },
  { id: 'flag-cw', name: 'flag-cw', names: ['flag-cw'], unicode: '🇨🇼' },
  { id: 'flag-cx', name: 'flag-cx', names: ['flag-cx'], unicode: '🇨🇽' },
  { id: 'flag-cy', name: 'flag-cy', names: ['flag-cy'], unicode: '🇨🇾' },
  { id: 'flag-cz', name: 'flag-cz', names: ['flag-cz'], unicode: '🇨🇿' },
  { id: 'flag-dg', name: 'flag-dg', names: ['flag-dg'], unicode: '🇩🇬' },
  { id: 'flag-dj', name: 'flag-dj', names: ['flag-dj'], unicode: '🇩🇯' },
  { id: 'flag-dk', name: 'flag-dk', names: ['flag-dk'], unicode: '🇩🇰' },
  { id: 'flag-dm', name: 'flag-dm', names: ['flag-dm'], unicode: '🇩🇲' },
  { id: 'flag-do', name: 'flag-do', names: ['flag-do'], unicode: '🇩🇴' },
  { id: 'flag-dz', name: 'flag-dz', names: ['flag-dz'], unicode: '🇩🇿' },
  { id: 'flag-ea', name: 'flag-ea', names: ['flag-ea'], unicode: '🇪🇦' },
  { id: 'flag-ec', name: 'flag-ec', names: ['flag-ec'], unicode: '🇪🇨' },
  { id: 'flag-ee', name: 'flag-ee', names: ['flag-ee'], unicode: '🇪🇪' },
  { id: 'flag-eg', name: 'flag-eg', names: ['flag-eg'], unicode: '🇪🇬' },
  { id: 'flag-eh', name: 'flag-eh', names: ['flag-eh'], unicode: '🇪🇭' },
  { id: 'flag-england', name: 'flag-england', names: ['flag-england'], unicode: '🏴󠁧󠁢󠁥󠁮󠁧󠁿' },
  { id: 'flag-er', name: 'flag-er', names: ['flag-er'], unicode: '🇪🇷' },
  { id: 'flag-et', name: 'flag-et', names: ['flag-et'], unicode: '🇪🇹' },
  { id: 'flag-eu', name: 'flag-eu', names: ['flag-eu'], unicode: '🇪🇺' },
  { id: 'flag-fi', name: 'flag-fi', names: ['flag-fi'], unicode: '🇫🇮' },
  { id: 'flag-fj', name: 'flag-fj', names: ['flag-fj'], unicode: '🇫🇯' },
  { id: 'flag-fk', name: 'flag-fk', names: ['flag-fk'], unicode: '🇫🇰' },
  { id: 'flag-fm', name: 'flag-fm', names: ['flag-fm'], unicode: '🇫🇲' },
  { id: 'flag-fo', name: 'flag-fo', names: ['flag-fo'], unicode: '🇫🇴' },
  { id: 'flag-ga', name: 'flag-ga', names: ['flag-ga'], unicode: '🇬🇦' },
  { id: 'flag-gd', name: 'flag-gd', names: ['flag-gd'], unicode: '🇬🇩' },
  { id: 'flag-ge', name: 'flag-ge', names: ['flag-ge'], unicode: '🇬🇪' },
  { id: 'flag-gf', name: 'flag-gf', names: ['flag-gf'], unicode: '🇬🇫' },
  { id: 'flag-gg', name: 'flag-gg', names: ['flag-gg'], unicode: '🇬🇬' },
  { id: 'flag-gh', name: 'flag-gh', names: ['flag-gh'], unicode: '🇬🇭' },
  { id: 'flag-gi', name: 'flag-gi', names: ['flag-gi'], unicode: '🇬🇮' },
  { id: 'flag-gl', name: 'flag-gl', names: ['flag-gl'], unicode: '🇬🇱' },
  { id: 'flag-gm', name: 'flag-gm', names: ['flag-gm'], unicode: '🇬🇲' },
  { id: 'flag-gn', name: 'flag-gn', names: ['flag-gn'], unicode: '🇬🇳' },
  { id: 'flag-gp', name: 'flag-gp', names: ['flag-gp'], unicode: '🇬🇵' },
  { id: 'flag-gq', name: 'flag-gq', names: ['flag-gq'], unicode: '🇬🇶' },
  { id: 'flag-gr', name: 'flag-gr', names: ['flag-gr'], unicode: '🇬🇷' },
  { id: 'flag-gs', name: 'flag-gs', names: ['flag-gs'], unicode: '🇬🇸' },
  { id: 'flag-gt', name: 'flag-gt', names: ['flag-gt'], unicode: '🇬🇹' },
  { id: 'flag-gu', name: 'flag-gu', names: ['flag-gu'], unicode: '🇬🇺' },
  { id: 'flag-gw', name: 'flag-gw', names: ['flag-gw'], unicode: '🇬🇼' },
  { id: 'flag-gy', name: 'flag-gy', names: ['flag-gy'], unicode: '🇬🇾' },
  { id: 'flag-hk', name: 'flag-hk', names: ['flag-hk'], unicode: '🇭🇰' },
  { id: 'flag-hm', name: 'flag-hm', names: ['flag-hm'], unicode: '🇭🇲' },
  { id: 'flag-hn', name: 'flag-hn', names: ['flag-hn'], unicode: '🇭🇳' },
  { id: 'flag-hr', name: 'flag-hr', names: ['flag-hr'], unicode: '🇭🇷' },
  { id: 'flag-ht', name: 'flag-ht', names: ['flag-ht'], unicode: '🇭🇹' },
  { id: 'flag-hu', name: 'flag-hu', names: ['flag-hu'], unicode: '🇭🇺' },
  { id: 'flag-ic', name: 'flag-ic', names: ['flag-ic'], unicode: '🇮🇨' },
  { id: 'flag-id', name: 'flag-id', names: ['flag-id'], unicode: '🇮🇩' },
  { id: 'flag-ie', name: 'flag-ie', names: ['flag-ie'], unicode: '🇮🇪' },
  { id: 'flag-il', name: 'flag-il', names: ['flag-il'], unicode: '🇮🇱' },
  { id: 'flag-im', name: 'flag-im', names: ['flag-im'], unicode: '🇮🇲' },
  { id: 'flag-in', name: 'flag-in', names: ['flag-in'], unicode: '🇮🇳' },
  { id: 'flag-io', name: 'flag-io', names: ['flag-io'], unicode: '🇮🇴' },
  { id: 'flag-iq', name: 'flag-iq', names: ['flag-iq'], unicode: '🇮🇶' },
  { id: 'flag-ir', name: 'flag-ir', names: ['flag-ir'], unicode: '🇮🇷' },
  { id: 'flag-is', name: 'flag-is', names: ['flag-is'], unicode: '🇮🇸' },
  { id: 'flag-je', name: 'flag-je', names: ['flag-je'], unicode: '🇯🇪' },
  { id: 'flag-jm', name: 'flag-jm', names: ['flag-jm'], unicode: '🇯🇲' },
  { id: 'flag-jo', name: 'flag-jo', names: ['flag-jo'], unicode: '🇯🇴' },
  { id: 'flag-ke', name: 'flag-ke', names: ['flag-ke'], unicode: '🇰🇪' },
  { id: 'flag-kg', name: 'flag-kg', names: ['flag-kg'], unicode: '🇰🇬' },
  { id: 'flag-kh', name: 'flag-kh', names: ['flag-kh'], unicode: '🇰🇭' },
  { id: 'flag-ki', name: 'flag-ki', names: ['flag-ki'], unicode: '🇰🇮' },
  { id: 'flag-km', name: 'flag-km', names: ['flag-km'], unicode: '🇰🇲' },
  { id: 'flag-kn', name: 'flag-kn', names: ['flag-kn'], unicode: '🇰🇳' },
  { id: 'flag-kp', name: 'flag-kp', names: ['flag-kp'], unicode: '🇰🇵' },
  { id: 'flag-kw', name: 'flag-kw', names: ['flag-kw'], unicode: '🇰🇼' },
  { id: 'flag-ky', name: 'flag-ky', names: ['flag-ky'], unicode: '🇰🇾' },
  { id: 'flag-kz', name: 'flag-kz', names: ['flag-kz'], unicode: '🇰🇿' },
  { id: 'flag-la', name: 'flag-la', names: ['flag-la'], unicode: '🇱🇦' },
  { id: 'flag-lb', name: 'flag-lb', names: ['flag-lb'], unicode: '🇱🇧' },
  { id: 'flag-lc', name: 'flag-lc', names: ['flag-lc'], unicode: '🇱🇨' },
  { id: 'flag-li', name: 'flag-li', names: ['flag-li'], unicode: '🇱🇮' },
  { id: 'flag-lk', name: 'flag-lk', names: ['flag-lk'], unicode: '🇱🇰' },
  { id: 'flag-lr', name: 'flag-lr', names: ['flag-lr'], unicode: '🇱🇷' },
  { id: 'flag-ls', name: 'flag-ls', names: ['flag-ls'], unicode: '🇱🇸' },
  { id: 'flag-lt', name: 'flag-lt', names: ['flag-lt'], unicode: '🇱🇹' },
  { id: 'flag-lu', name: 'flag-lu', names: ['flag-lu'], unicode: '🇱🇺' },
  { id: 'flag-lv', name: 'flag-lv', names: ['flag-lv'], unicode: '🇱🇻' },
  { id: 'flag-ly', name: 'flag-ly', names: ['flag-ly'], unicode: '🇱🇾' },
  { id: 'flag-ma', name: 'flag-ma', names: ['flag-ma'], unicode: '🇲🇦' },
  { id: 'flag-mc', name: 'flag-mc', names: ['flag-mc'], unicode: '🇲🇨' },
  { id: 'flag-md', name: 'flag-md', names: ['flag-md'], unicode: '🇲🇩' },
  { id: 'flag-me', name: 'flag-me', names: ['flag-me'], unicode: '🇲🇪' },
  { id: 'flag-mf', name: 'flag-mf', names: ['flag-mf'], unicode: '🇲🇫' },
  { id: 'flag-mg', name: 'flag-mg', names: ['flag-mg'], unicode: '🇲🇬' },
  { id: 'flag-mh', name: 'flag-mh', names: ['flag-mh'], unicode: '🇲🇭' },
  { id: 'flag-mk', name: 'flag-mk', names: ['flag-mk'], unicode: '🇲🇰' },
  { id: 'flag-ml', name: 'flag-ml', names: ['flag-ml'], unicode: '🇲🇱' },
  { id: 'flag-mm', name: 'flag-mm', names: ['flag-mm'], unicode: '🇲🇲' },
  { id: 'flag-mn', name: 'flag-mn', names: ['flag-mn'], unicode: '🇲🇳' },
  { id: 'flag-mo', name: 'flag-mo', names: ['flag-mo'], unicode: '🇲🇴' },
  { id: 'flag-mp', name: 'flag-mp', names: ['flag-mp'], unicode: '🇲🇵' },
  { id: 'flag-mq', name: 'flag-mq', names: ['flag-mq'], unicode: '🇲🇶' },
  { id: 'flag-mr', name: 'flag-mr', names: ['flag-mr'], unicode: '🇲🇷' },
  { id: 'flag-ms', name: 'flag-ms', names: ['flag-ms'], unicode: '🇲🇸' },
  { id: 'flag-mt', name: 'flag-mt', names: ['flag-mt'], unicode: '🇲🇹' },
  { id: 'flag-mu', name: 'flag-mu', names: ['flag-mu'], unicode: '🇲🇺' },
  { id: 'flag-mv', name: 'flag-mv', names: ['flag-mv'], unicode: '🇲🇻' },
  { id: 'flag-mw', name: 'flag-mw', names: ['flag-mw'], unicode: '🇲🇼' },
  { id: 'flag-mx', name: 'flag-mx', names: ['flag-mx'], unicode: '🇲🇽' },
  { id: 'flag-my', name: 'flag-my', names: ['flag-my'], unicode: '🇲🇾' },
  { id: 'flag-mz', name: 'flag-mz', names: ['flag-mz'], unicode: '🇲🇿' },
  { id: 'flag-na', name: 'flag-na', names: ['flag-na'], unicode: '🇳🇦' },
  { id: 'flag-nc', name: 'flag-nc', names: ['flag-nc'], unicode: '🇳🇨' },
  { id: 'flag-ne', name: 'flag-ne', names: ['flag-ne'], unicode: '🇳🇪' },
  { id: 'flag-nf', name: 'flag-nf', names: ['flag-nf'], unicode: '🇳🇫' },
  { id: 'flag-ng', name: 'flag-ng', names: ['flag-ng'], unicode: '🇳🇬' },
  { id: 'flag-ni', name: 'flag-ni', names: ['flag-ni'], unicode: '🇳🇮' },
  { id: 'flag-nl', name: 'flag-nl', names: ['flag-nl'], unicode: '🇳🇱' },
  { id: 'flag-no', name: 'flag-no', names: ['flag-no'], unicode: '🇳🇴' },
  { id: 'flag-np', name: 'flag-np', names: ['flag-np'], unicode: '🇳🇵' },
  { id: 'flag-nr', name: 'flag-nr', names: ['flag-nr'], unicode: '🇳🇷' },
  { id: 'flag-nu', name: 'flag-nu', names: ['flag-nu'], unicode: '🇳🇺' },
  { id: 'flag-nz', name: 'flag-nz', names: ['flag-nz'], unicode: '🇳🇿' },
  { id: 'flag-om', name: 'flag-om', names: ['flag-om'], unicode: '🇴🇲' },
  { id: 'flag-pa', name: 'flag-pa', names: ['flag-pa'], unicode: '🇵🇦' },
  { id: 'flag-pe', name: 'flag-pe', names: ['flag-pe'], unicode: '🇵🇪' },
  { id: 'flag-pf', name: 'flag-pf', names: ['flag-pf'], unicode: '🇵🇫' },
  { id: 'flag-pg', name: 'flag-pg', names: ['flag-pg'], unicode: '🇵🇬' },
  { id: 'flag-ph', name: 'flag-ph', names: ['flag-ph'], unicode: '🇵🇭' },
  { id: 'flag-pk', name: 'flag-pk', names: ['flag-pk'], unicode: '🇵🇰' },
  { id: 'flag-pl', name: 'flag-pl', names: ['flag-pl'], unicode: '🇵🇱' },
  { id: 'flag-pm', name: 'flag-pm', names: ['flag-pm'], unicode: '🇵🇲' },
  { id: 'flag-pn', name: 'flag-pn', names: ['flag-pn'], unicode: '🇵🇳' },
  { id: 'flag-pr', name: 'flag-pr', names: ['flag-pr'], unicode: '🇵🇷' },
  { id: 'flag-ps', name: 'flag-ps', names: ['flag-ps'], unicode: '🇵🇸' },
  { id: 'flag-pt', name: 'flag-pt', names: ['flag-pt'], unicode: '🇵🇹' },
  { id: 'flag-pw', name: 'flag-pw', names: ['flag-pw'], unicode: '🇵🇼' },
  { id: 'flag-py', name: 'flag-py', names: ['flag-py'], unicode: '🇵🇾' },
  { id: 'flag-qa', name: 'flag-qa', names: ['flag-qa'], unicode: '🇶🇦' },
  { id: 'flag-re', name: 'flag-re', names: ['flag-re'], unicode: '🇷🇪' },
  { id: 'flag-ro', name: 'flag-ro', names: ['flag-ro'], unicode: '🇷🇴' },
  { id: 'flag-rs', name: 'flag-rs', names: ['flag-rs'], unicode: '🇷🇸' },
  { id: 'flag-rw', name: 'flag-rw', names: ['flag-rw'], unicode: '🇷🇼' },
  { id: 'flag-sa', name: 'flag-sa', names: ['flag-sa'], unicode: '🇸🇦' },
  { id: 'flag-sb', name: 'flag-sb', names: ['flag-sb'], unicode: '🇸🇧' },
  { id: 'flag-sc', name: 'flag-sc', names: ['flag-sc'], unicode: '🇸🇨' },
  { id: 'flag-scotland', name: 'flag-scotland', names: ['flag-scotland'], unicode: '🏴󠁧󠁢󠁳󠁣󠁴󠁿' },
  { id: 'flag-sd', name: 'flag-sd', names: ['flag-sd'], unicode: '🇸🇩' },
  { id: 'flag-se', name: 'flag-se', names: ['flag-se'], unicode: '🇸🇪' },
  { id: 'flag-sg', name: 'flag-sg', names: ['flag-sg'], unicode: '🇸🇬' },
  { id: 'flag-sh', name: 'flag-sh', names: ['flag-sh'], unicode: '🇸🇭' },
  { id: 'flag-si', name: 'flag-si', names: ['flag-si'], unicode: '🇸🇮' },
  { id: 'flag-sj', name: 'flag-sj', names: ['flag-sj'], unicode: '🇸🇯' },
  { id: 'flag-sk', name: 'flag-sk', names: ['flag-sk'], unicode: '🇸🇰' },
  { id: 'flag-sl', name: 'flag-sl', names: ['flag-sl'], unicode: '🇸🇱' },
  { id: 'flag-sm', name: 'flag-sm', names: ['flag-sm'], unicode: '🇸🇲' },
  { id: 'flag-sn', name: 'flag-sn', names: ['flag-sn'], unicode: '🇸🇳' },
  { id: 'flag-so', name: 'flag-so', names: ['flag-so'], unicode: '🇸🇴' },
  { id: 'flag-sr', name: 'flag-sr', names: ['flag-sr'], unicode: '🇸🇷' },
  { id: 'flag-ss', name: 'flag-ss', names: ['flag-ss'], unicode: '🇸🇸' },
  { id: 'flag-st', name: 'flag-st', names: ['flag-st'], unicode: '🇸🇹' },
  { id: 'flag-sv', name: 'flag-sv', names: ['flag-sv'], unicode: '🇸🇻' },
  { id: 'flag-sx', name: 'flag-sx', names: ['flag-sx'], unicode: '🇸🇽' },
  { id: 'flag-sy', name: 'flag-sy', names: ['flag-sy'], unicode: '🇸🇾' },
  { id: 'flag-sz', name: 'flag-sz', names: ['flag-sz'], unicode: '🇸🇿' },
  { id: 'flag-ta', name: 'flag-ta', names: ['flag-ta'], unicode: '🇹🇦' },
  { id: 'flag-tc', name: 'flag-tc', names: ['flag-tc'], unicode: '🇹🇨' },
  { id: 'flag-td', name: 'flag-td', names: ['flag-td'], unicode: '🇹🇩' },
  { id: 'flag-tf', name: 'flag-tf', names: ['flag-tf'], unicode: '🇹🇫' },
  { id: 'flag-tg', name: 'flag-tg', names: ['flag-tg'], unicode: '🇹🇬' },
  { id: 'flag-th', name: 'flag-th', names: ['flag-th'], unicode: '🇹🇭' },
  { id: 'flag-tj', name: 'flag-tj', names: ['flag-tj'], unicode: '🇹🇯' },
  { id: 'flag-tk', name: 'flag-tk', names: ['flag-tk'], unicode: '🇹🇰' },
  { id: 'flag-tl', name: 'flag-tl', names: ['flag-tl'], unicode: '🇹🇱' },
  { id: 'flag-tm', name: 'flag-tm', names: ['flag-tm'], unicode: '🇹🇲' },
  { id: 'flag-tn', name: 'flag-tn', names: ['flag-tn'], unicode: '🇹🇳' },
  { id: 'flag-to', name: 'flag-to', names: ['flag-to'], unicode: '🇹🇴' },
  { id: 'flag-tr', name: 'flag-tr', names: ['flag-tr'], unicode: '🇹🇷' },
  { id: 'flag-tt', name: 'flag-tt', names: ['flag-tt'], unicode: '🇹🇹' },
  { id: 'flag-tv', name: 'flag-tv', names: ['flag-tv'], unicode: '🇹🇻' },
  { id: 'flag-tw', name: 'flag-tw', names: ['flag-tw'], unicode: '🇹🇼' },
  { id: 'flag-tz', name: 'flag-tz', names: ['flag-tz'], unicode: '🇹🇿' },
  { id: 'flag-ua', name: 'flag-ua', names: ['flag-ua'], unicode: '🇺🇦' },
  { id: 'flag-ug', name: 'flag-ug', names: ['flag-ug'], unicode: '🇺🇬' },
  { id: 'flag-um', name: 'flag-um', names: ['flag-um'], unicode: '🇺🇲' },
  { id: 'flag-un', name: 'flag-un', names: ['flag-un'], unicode: '🇺🇳' },
  { id: 'flag-uy', name: 'flag-uy', names: ['flag-uy'], unicode: '🇺🇾' },
  { id: 'flag-uz', name: 'flag-uz', names: ['flag-uz'], unicode: '🇺🇿' },
  { id: 'flag-va', name: 'flag-va', names: ['flag-va'], unicode: '🇻🇦' },
  { id: 'flag-vc', name: 'flag-vc', names: ['flag-vc'], unicode: '🇻🇨' },
  { id: 'flag-ve', name: 'flag-ve', names: ['flag-ve'], unicode: '🇻🇪' },
  { id: 'flag-vg', name: 'flag-vg', names: ['flag-vg'], unicode: '🇻🇬' },
  { id: 'flag-vi', name: 'flag-vi', names: ['flag-vi'], unicode: '🇻🇮' },
  { id: 'flag-vn', name: 'flag-vn', names: ['flag-vn'], unicode: '🇻🇳' },
  { id: 'flag-vu', name: 'flag-vu', names: ['flag-vu'], unicode: '🇻🇺' },
  { id: 'flag-wales', name: 'flag-wales', names: ['flag-wales'], unicode: '🏴󠁧󠁢󠁷󠁬󠁳󠁿' },
  { id: 'flag-wf', name: 'flag-wf', names: ['flag-wf'], unicode: '🇼🇫' },
  { id: 'flag-ws', name: 'flag-ws', names: ['flag-ws'], unicode: '🇼🇸' },
  { id: 'flag-xk', name: 'flag-xk', names: ['flag-xk'], unicode: '🇽🇰' },
  { id: 'flag-ye', name: 'flag-ye', names: ['flag-ye'], unicode: '🇾🇪' },
  { id: 'flag-yt', name: 'flag-yt', names: ['flag-yt'], unicode: '🇾🇹' },
  { id: 'flag-za', name: 'flag-za', names: ['flag-za'], unicode: '🇿🇦' },
  { id: 'flag-zm', name: 'flag-zm', names: ['flag-zm'], unicode: '🇿🇲' },
  { id: 'flag-zw', name: 'flag-zw', names: ['flag-zw'], unicode: '🇿🇼' },
  { id: 'flags', name: 'flags', names: ['flags'], unicode: '🎏' },
  { id: 'flamingo', name: 'flamingo', names: ['flamingo'], unicode: '🦩' },
  { id: 'flashlight', name: 'flashlight', names: ['flashlight'], unicode: '🔦' },
  { id: 'flatbread', name: 'flatbread', names: ['flatbread'], unicode: '🫓' },
  { id: 'fleur_de_lis', name: 'fleur_de_lis', names: ['fleur_de_lis'], unicode: '⚜️' },
  { id: 'floppy_disk', name: 'floppy_disk', names: ['floppy_disk'], unicode: '💾' },
  {
    id: 'flower_playing_cards',
    name: 'flower_playing_cards',
    names: ['flower_playing_cards'],
    unicode: '🎴',
  },
  { id: 'flushed', name: 'flushed', names: ['flushed'], unicode: '😳' },
  { id: 'flute', name: 'flute', names: ['flute'], unicode: '🪈' },
  { id: 'fly', name: 'fly', names: ['fly'], unicode: '🪰' },
  { id: 'flying_disc', name: 'flying_disc', names: ['flying_disc'], unicode: '🥏' },
  { id: 'flying_saucer', name: 'flying_saucer', names: ['flying_saucer'], unicode: '🛸' },
  { id: 'fog', name: 'fog', names: ['fog'], unicode: '🌫️' },
  { id: 'foggy', name: 'foggy', names: ['foggy'], unicode: '🌁' },
  { id: 'folding_hand_fan', name: 'folding_hand_fan', names: ['folding_hand_fan'], unicode: '🪭' },
  { id: 'fondue', name: 'fondue', names: ['fondue'], unicode: '🫕' },
  {
    id: 'foot',
    name: 'foot',
    names: ['foot'],
    skins: ['🦶🏻', '🦶🏼', '🦶🏽', '🦶🏾', '🦶🏿'],
    unicode: '🦶',
  },
  { id: 'football', name: 'football', names: ['football'], unicode: '🏈' },
  { id: 'footprints', name: 'footprints', names: ['footprints'], unicode: '👣' },
  { id: 'fork_and_knife', name: 'fork_and_knife', names: ['fork_and_knife'], unicode: '🍴' },
  { id: 'fortune_cookie', name: 'fortune_cookie', names: ['fortune_cookie'], unicode: '🥠' },
  { id: 'fountain', name: 'fountain', names: ['fountain'], unicode: '⛲' },
  { id: 'four', name: 'four', names: ['four'], unicode: '4️⃣' },
  { id: 'four_leaf_clover', name: 'four_leaf_clover', names: ['four_leaf_clover'], unicode: '🍀' },
  { id: 'fox_face', name: 'fox_face', names: ['fox_face'], unicode: '🦊' },
  { id: 'fr', name: 'fr', names: ['fr', 'flag-fr'], unicode: '🇫🇷' },
  {
    id: 'frame_with_picture',
    name: 'frame_with_picture',
    names: ['frame_with_picture'],
    unicode: '🖼️',
  },
  { id: 'free', name: 'free', names: ['free'], unicode: '🆓' },
  { id: 'fried_egg', name: 'fried_egg', names: ['fried_egg', 'cooking'], unicode: '🍳' },
  { id: 'fried_shrimp', name: 'fried_shrimp', names: ['fried_shrimp'], unicode: '🍤' },
  { id: 'fries', name: 'fries', names: ['fries'], unicode: '🍟' },
  { id: 'frog', name: 'frog', names: ['frog'], unicode: '🐸' },
  { id: 'frowning', name: 'frowning', names: ['frowning'], unicode: '😦' },
  { id: 'fuelpump', name: 'fuelpump', names: ['fuelpump'], unicode: '⛽' },
  { id: 'full_moon', name: 'full_moon', names: ['full_moon'], unicode: '🌕' },
  {
    id: 'full_moon_with_face',
    name: 'full_moon_with_face',
    names: ['full_moon_with_face'],
    unicode: '🌝',
  },
  { id: 'funeral_urn', name: 'funeral_urn', names: ['funeral_urn'], unicode: '⚱️' },
  { id: 'game_die', name: 'game_die', names: ['game_die'], unicode: '🎲' },
  { id: 'garlic', name: 'garlic', names: ['garlic'], unicode: '🧄' },
  { id: 'gb', name: 'gb', names: ['gb', 'uk', 'flag-gb'], unicode: '🇬🇧' },
  { id: 'gear', name: 'gear', names: ['gear'], unicode: '⚙️' },
  { id: 'gem', name: 'gem', names: ['gem'], unicode: '💎' },
  { id: 'gemini', name: 'gemini', names: ['gemini'], unicode: '♊' },
  { id: 'genie', name: 'genie', names: ['genie'], unicode: '🧞' },
  { id: 'ghost', name: 'ghost', names: ['ghost'], unicode: '👻' },
  { id: 'gift', name: 'gift', names: ['gift'], unicode: '🎁' },
  { id: 'gift_heart', name: 'gift_heart', names: ['gift_heart'], unicode: '💝' },
  { id: 'ginger_root', name: 'ginger_root', names: ['ginger_root'], unicode: '🫚' },
  { id: 'giraffe_face', name: 'giraffe_face', names: ['giraffe_face'], unicode: '🦒' },
  {
    id: 'girl',
    name: 'girl',
    names: ['girl'],
    skins: ['👧🏻', '👧🏼', '👧🏽', '👧🏾', '👧🏿'],
    unicode: '👧',
  },
  { id: 'glass_of_milk', name: 'glass_of_milk', names: ['glass_of_milk'], unicode: '🥛' },
  {
    id: 'globe_with_meridians',
    name: 'globe_with_meridians',
    names: ['globe_with_meridians'],
    unicode: '🌐',
  },
  { id: 'gloves', name: 'gloves', names: ['gloves'], unicode: '🧤' },
  { id: 'goal_net', name: 'goal_net', names: ['goal_net'], unicode: '🥅' },
  { id: 'goat', name: 'goat', names: ['goat'], unicode: '🐐' },
  { id: 'goggles', name: 'goggles', names: ['goggles'], unicode: '🥽' },
  { id: 'golf', name: 'golf', names: ['golf'], unicode: '⛳' },
  {
    id: 'golfer',
    name: 'golfer',
    names: ['golfer'],
    skins: ['🏌🏻', '🏌🏼', '🏌🏽', '🏌🏾', '🏌🏿'],
    unicode: '🏌️',
  },
  { id: 'goose', name: 'goose', names: ['goose'], unicode: '🪿' },
  { id: 'gorilla', name: 'gorilla', names: ['gorilla'], unicode: '🦍' },
  { id: 'grapes', name: 'grapes', names: ['grapes'], unicode: '🍇' },
  { id: 'green_apple', name: 'green_apple', names: ['green_apple'], unicode: '🍏' },
  { id: 'green_book', name: 'green_book', names: ['green_book'], unicode: '📗' },
  { id: 'green_heart', name: 'green_heart', names: ['green_heart'], unicode: '💚' },
  { id: 'green_salad', name: 'green_salad', names: ['green_salad'], unicode: '🥗' },
  { id: 'grey_exclamation', name: 'grey_exclamation', names: ['grey_exclamation'], unicode: '❕' },
  { id: 'grey_heart', name: 'grey_heart', names: ['grey_heart'], unicode: '🩶' },
  { id: 'grey_question', name: 'grey_question', names: ['grey_question'], unicode: '❔' },
  { id: 'grimacing', name: 'grimacing', names: ['grimacing'], unicode: '😬' },
  { id: 'grin', name: 'grin', names: ['grin'], unicode: '😁' },
  { id: 'grinning', name: 'grinning', names: ['grinning'], unicode: '😀' },
  {
    id: 'guardsman',
    name: 'guardsman',
    names: ['guardsman'],
    skins: ['💂🏻', '💂🏼', '💂🏽', '💂🏾', '💂🏿'],
    unicode: '💂',
  },
  { id: 'guide_dog', name: 'guide_dog', names: ['guide_dog'], unicode: '🦮' },
  { id: 'guitar', name: 'guitar', names: ['guitar'], unicode: '🎸' },
  { id: 'gun', name: 'gun', names: ['gun'], unicode: '🔫' },
  { id: 'hair_pick', name: 'hair_pick', names: ['hair_pick'], unicode: '🪮' },
  {
    id: 'haircut',
    name: 'haircut',
    names: ['haircut'],
    skins: ['💇🏻', '💇🏼', '💇🏽', '💇🏾', '💇🏿'],
    unicode: '💇',
  },
  { id: 'hamburger', name: 'hamburger', names: ['hamburger'], unicode: '🍔' },
  { id: 'hammer', name: 'hammer', names: ['hammer'], unicode: '🔨' },
  { id: 'hammer_and_pick', name: 'hammer_and_pick', names: ['hammer_and_pick'], unicode: '⚒️' },
  {
    id: 'hammer_and_wrench',
    name: 'hammer_and_wrench',
    names: ['hammer_and_wrench'],
    unicode: '🛠️',
  },
  { id: 'hamsa', name: 'hamsa', names: ['hamsa'], unicode: '🪬' },
  { id: 'hamster', name: 'hamster', names: ['hamster'], unicode: '🐹' },
  {
    id: 'hand',
    name: 'hand',
    names: ['hand', 'raised_hand'],
    skins: ['✋🏻', '✋🏼', '✋🏽', '✋🏾', '✋🏿'],
    unicode: '✋',
  },
  {
    id: 'hand_with_index_finger_and_thumb_crossed',
    name: 'hand_with_index_finger_and_thumb_crossed',
    names: ['hand_with_index_finger_and_thumb_crossed'],
    skins: ['🫰🏻', '🫰🏼', '🫰🏽', '🫰🏾', '🫰🏿'],
    unicode: '🫰',
  },
  { id: 'handbag', name: 'handbag', names: ['handbag'], unicode: '👜' },
  {
    id: 'handball',
    name: 'handball',
    names: ['handball'],
    skins: ['🤾🏻', '🤾🏼', '🤾🏽', '🤾🏾', '🤾🏿'],
    unicode: '🤾',
  },
  {
    id: 'handshake',
    name: 'handshake',
    names: ['handshake'],
    skins: [
      '🤝🏻',
      '🤝🏼',
      '🤝🏽',
      '🤝🏾',
      '🤝🏿',
      '🫱🏻‍🫲🏼',
      '🫱🏻‍🫲🏽',
      '🫱🏻‍🫲🏾',
      '🫱🏻‍🫲🏿',
      '🫱🏼‍🫲🏻',
      '🫱🏼‍🫲🏽',
      '🫱🏼‍🫲🏾',
      '🫱🏼‍🫲🏿',
      '🫱🏽‍🫲🏻',
      '🫱🏽‍🫲🏼',
      '🫱🏽‍🫲🏾',
      '🫱🏽‍🫲🏿',
      '🫱🏾‍🫲🏻',
      '🫱🏾‍🫲🏼',
      '🫱🏾‍🫲🏽',
      '🫱🏾‍🫲🏿',
      '🫱🏿‍🫲🏻',
      '🫱🏿‍🫲🏼',
      '🫱🏿‍🫲🏽',
      '🫱🏿‍🫲🏾',
    ],
    unicode: '🤝',
  },
  { id: 'hankey', name: 'hankey', names: ['hankey', 'poop', 'shit'], unicode: '💩' },
  { id: 'hash', name: 'hash', names: ['hash'], unicode: '#️⃣' },
  { id: 'hatched_chick', name: 'hatched_chick', names: ['hatched_chick'], unicode: '🐥' },
  { id: 'hatching_chick', name: 'hatching_chick', names: ['hatching_chick'], unicode: '🐣' },
  {
    id: 'head_shaking_horizontally',
    name: 'head_shaking_horizontally',
    names: ['head_shaking_horizontally'],
    unicode: '🙂‍↔️',
  },
  {
    id: 'head_shaking_vertically',
    name: 'head_shaking_vertically',
    names: ['head_shaking_vertically'],
    unicode: '🙂‍↕️',
  },
  { id: 'headphones', name: 'headphones', names: ['headphones'], unicode: '🎧' },
  { id: 'headstone', name: 'headstone', names: ['headstone'], unicode: '🪦' },
  {
    id: 'health_worker',
    name: 'health_worker',
    names: ['health_worker'],
    skins: ['🧑🏻‍⚕️', '🧑🏼‍⚕️', '🧑🏽‍⚕️', '🧑🏾‍⚕️', '🧑🏿‍⚕️'],
    unicode: '🧑‍⚕️',
  },
  { id: 'hear_no_evil', name: 'hear_no_evil', names: ['hear_no_evil'], unicode: '🙉' },
  { id: 'heart', name: 'heart', names: ['heart'], unicode: '❤️' },
  { id: 'heart_decoration', name: 'heart_decoration', names: ['heart_decoration'], unicode: '💟' },
  { id: 'heart_eyes', name: 'heart_eyes', names: ['heart_eyes'], unicode: '😍' },
  { id: 'heart_eyes_cat', name: 'heart_eyes_cat', names: ['heart_eyes_cat'], unicode: '😻' },
  {
    id: 'heart_hands',
    name: 'heart_hands',
    names: ['heart_hands'],
    skins: ['🫶🏻', '🫶🏼', '🫶🏽', '🫶🏾', '🫶🏿'],
    unicode: '🫶',
  },
  { id: 'heart_on_fire', name: 'heart_on_fire', names: ['heart_on_fire'], unicode: '❤️‍🔥' },
  { id: 'heartbeat', name: 'heartbeat', names: ['heartbeat'], unicode: '💓' },
  { id: 'heartpulse', name: 'heartpulse', names: ['heartpulse'], unicode: '💗' },
  { id: 'hearts', name: 'hearts', names: ['hearts'], unicode: '♥️' },
  { id: 'heavy_check_mark', name: 'heavy_check_mark', names: ['heavy_check_mark'], unicode: '✔️' },
  {
    id: 'heavy_division_sign',
    name: 'heavy_division_sign',
    names: ['heavy_division_sign'],
    unicode: '➗',
  },
  {
    id: 'heavy_dollar_sign',
    name: 'heavy_dollar_sign',
    names: ['heavy_dollar_sign'],
    unicode: '💲',
  },
  {
    id: 'heavy_equals_sign',
    name: 'heavy_equals_sign',
    names: ['heavy_equals_sign'],
    unicode: '🟰',
  },
  {
    id: 'heavy_heart_exclamation_mark_ornament',
    name: 'heavy_heart_exclamation_mark_ornament',
    names: ['heavy_heart_exclamation_mark_ornament'],
    unicode: '❣️',
  },
  { id: 'heavy_minus_sign', name: 'heavy_minus_sign', names: ['heavy_minus_sign'], unicode: '➖' },
  {
    id: 'heavy_multiplication_x',
    name: 'heavy_multiplication_x',
    names: ['heavy_multiplication_x'],
    unicode: '✖️',
  },
  { id: 'heavy_plus_sign', name: 'heavy_plus_sign', names: ['heavy_plus_sign'], unicode: '➕' },
  { id: 'hedgehog', name: 'hedgehog', names: ['hedgehog'], unicode: '🦔' },
  { id: 'helicopter', name: 'helicopter', names: ['helicopter'], unicode: '🚁' },
  {
    id: 'helmet_with_white_cross',
    name: 'helmet_with_white_cross',
    names: ['helmet_with_white_cross'],
    unicode: '⛑️',
  },
  { id: 'herb', name: 'herb', names: ['herb'], unicode: '🌿' },
  { id: 'hibiscus', name: 'hibiscus', names: ['hibiscus'], unicode: '🌺' },
  { id: 'high_brightness', name: 'high_brightness', names: ['high_brightness'], unicode: '🔆' },
  { id: 'high_heel', name: 'high_heel', names: ['high_heel'], unicode: '👠' },
  { id: 'hiking_boot', name: 'hiking_boot', names: ['hiking_boot'], unicode: '🥾' },
  { id: 'hindu_temple', name: 'hindu_temple', names: ['hindu_temple'], unicode: '🛕' },
  { id: 'hippopotamus', name: 'hippopotamus', names: ['hippopotamus'], unicode: '🦛' },
  { id: 'hocho', name: 'hocho', names: ['hocho', 'knife'], unicode: '🔪' },
  { id: 'hole', name: 'hole', names: ['hole'], unicode: '🕳️' },
  { id: 'honey_pot', name: 'honey_pot', names: ['honey_pot'], unicode: '🍯' },
  { id: 'hook', name: 'hook', names: ['hook'], unicode: '🪝' },
  { id: 'horse', name: 'horse', names: ['horse'], unicode: '🐴' },
  {
    id: 'horse_racing',
    name: 'horse_racing',
    names: ['horse_racing'],
    skins: ['🏇🏻', '🏇🏼', '🏇🏽', '🏇🏾', '🏇🏿'],
    unicode: '🏇',
  },
  { id: 'hospital', name: 'hospital', names: ['hospital'], unicode: '🏥' },
  { id: 'hot_face', name: 'hot_face', names: ['hot_face'], unicode: '🥵' },
  { id: 'hot_pepper', name: 'hot_pepper', names: ['hot_pepper'], unicode: '🌶️' },
  { id: 'hotdog', name: 'hotdog', names: ['hotdog'], unicode: '🌭' },
  { id: 'hotel', name: 'hotel', names: ['hotel'], unicode: '🏨' },
  { id: 'hotsprings', name: 'hotsprings', names: ['hotsprings'], unicode: '♨️' },
  { id: 'hourglass', name: 'hourglass', names: ['hourglass'], unicode: '⌛' },
  {
    id: 'hourglass_flowing_sand',
    name: 'hourglass_flowing_sand',
    names: ['hourglass_flowing_sand'],
    unicode: '⏳',
  },
  { id: 'house', name: 'house', names: ['house'], unicode: '🏠' },
  { id: 'house_buildings', name: 'house_buildings', names: ['house_buildings'], unicode: '🏘️' },
  {
    id: 'house_with_garden',
    name: 'house_with_garden',
    names: ['house_with_garden'],
    unicode: '🏡',
  },
  { id: 'hugging_face', name: 'hugging_face', names: ['hugging_face'], unicode: '🤗' },
  { id: 'hushed', name: 'hushed', names: ['hushed'], unicode: '😯' },
  { id: 'hut', name: 'hut', names: ['hut'], unicode: '🛖' },
  { id: 'hyacinth', name: 'hyacinth', names: ['hyacinth'], unicode: '🪻' },
  {
    id: 'i_love_you_hand_sign',
    name: 'i_love_you_hand_sign',
    names: ['i_love_you_hand_sign'],
    skins: ['🤟🏻', '🤟🏼', '🤟🏽', '🤟🏾', '🤟🏿'],
    unicode: '🤟',
  },
  { id: 'ice_cream', name: 'ice_cream', names: ['ice_cream'], unicode: '🍨' },
  { id: 'ice_cube', name: 'ice_cube', names: ['ice_cube'], unicode: '🧊' },
  {
    id: 'ice_hockey_stick_and_puck',
    name: 'ice_hockey_stick_and_puck',
    names: ['ice_hockey_stick_and_puck'],
    unicode: '🏒',
  },
  { id: 'ice_skate', name: 'ice_skate', names: ['ice_skate'], unicode: '⛸️' },
  { id: 'icecream', name: 'icecream', names: ['icecream'], unicode: '🍦' },
  { id: 'id', name: 'id', names: ['id'], unicode: '🆔' },
  {
    id: 'identification_card',
    name: 'identification_card',
    names: ['identification_card'],
    unicode: '🪪',
  },
  {
    id: 'ideograph_advantage',
    name: 'ideograph_advantage',
    names: ['ideograph_advantage'],
    unicode: '🉐',
  },
  { id: 'imp', name: 'imp', names: ['imp'], unicode: '👿' },
  { id: 'inbox_tray', name: 'inbox_tray', names: ['inbox_tray'], unicode: '📥' },
  {
    id: 'incoming_envelope',
    name: 'incoming_envelope',
    names: ['incoming_envelope'],
    unicode: '📨',
  },
  {
    id: 'index_pointing_at_the_viewer',
    name: 'index_pointing_at_the_viewer',
    names: ['index_pointing_at_the_viewer'],
    skins: ['🫵🏻', '🫵🏼', '🫵🏽', '🫵🏾', '🫵🏿'],
    unicode: '🫵',
  },
  { id: 'infinity', name: 'infinity', names: ['infinity'], unicode: '♾️' },
  {
    id: 'information_desk_person',
    name: 'information_desk_person',
    names: ['information_desk_person'],
    skins: ['💁🏻', '💁🏼', '💁🏽', '💁🏾', '💁🏿'],
    unicode: '💁',
  },
  {
    id: 'information_source',
    name: 'information_source',
    names: ['information_source'],
    unicode: 'ℹ️',
  },
  { id: 'innocent', name: 'innocent', names: ['innocent'], unicode: '😇' },
  { id: 'interrobang', name: 'interrobang', names: ['interrobang'], unicode: '⁉️' },
  { id: 'iphone', name: 'iphone', names: ['iphone'], unicode: '📱' },
  { id: 'it', name: 'it', names: ['it', 'flag-it'], unicode: '🇮🇹' },
  {
    id: 'izakaya_lantern',
    name: 'izakaya_lantern',
    names: ['izakaya_lantern', 'lantern'],
    unicode: '🏮',
  },
  { id: 'jack_o_lantern', name: 'jack_o_lantern', names: ['jack_o_lantern'], unicode: '🎃' },
  { id: 'japan', name: 'japan', names: ['japan'], unicode: '🗾' },
  { id: 'japanese_castle', name: 'japanese_castle', names: ['japanese_castle'], unicode: '🏯' },
  { id: 'japanese_goblin', name: 'japanese_goblin', names: ['japanese_goblin'], unicode: '👺' },
  { id: 'japanese_ogre', name: 'japanese_ogre', names: ['japanese_ogre'], unicode: '👹' },
  { id: 'jar', name: 'jar', names: ['jar'], unicode: '🫙' },
  { id: 'jeans', name: 'jeans', names: ['jeans'], unicode: '👖' },
  { id: 'jellyfish', name: 'jellyfish', names: ['jellyfish'], unicode: '🪼' },
  { id: 'jigsaw', name: 'jigsaw', names: ['jigsaw'], unicode: '🧩' },
  { id: 'joy', name: 'joy', names: ['joy'], unicode: '😂' },
  { id: 'joy_cat', name: 'joy_cat', names: ['joy_cat'], unicode: '😹' },
  { id: 'joystick', name: 'joystick', names: ['joystick'], unicode: '🕹️' },
  { id: 'jp', name: 'jp', names: ['jp', 'flag-jp'], unicode: '🇯🇵' },
  {
    id: 'judge',
    name: 'judge',
    names: ['judge'],
    skins: ['🧑🏻‍⚖️', '🧑🏼‍⚖️', '🧑🏽‍⚖️', '🧑🏾‍⚖️', '🧑🏿‍⚖️'],
    unicode: '🧑‍⚖️',
  },
  {
    id: 'juggling',
    name: 'juggling',
    names: ['juggling'],
    skins: ['🤹🏻', '🤹🏼', '🤹🏽', '🤹🏾', '🤹🏿'],
    unicode: '🤹',
  },
  { id: 'kaaba', name: 'kaaba', names: ['kaaba'], unicode: '🕋' },
  { id: 'kangaroo', name: 'kangaroo', names: ['kangaroo'], unicode: '🦘' },
  { id: 'key', name: 'key', names: ['key'], unicode: '🔑' },
  { id: 'keyboard', name: 'keyboard', names: ['keyboard'], unicode: '⌨️' },
  { id: 'keycap_star', name: 'keycap_star', names: ['keycap_star'], unicode: '*️⃣' },
  { id: 'keycap_ten', name: 'keycap_ten', names: ['keycap_ten'], unicode: '🔟' },
  { id: 'khanda', name: 'khanda', names: ['khanda'], unicode: '🪯' },
  { id: 'kimono', name: 'kimono', names: ['kimono'], unicode: '👘' },
  { id: 'kiss', name: 'kiss', names: ['kiss'], unicode: '💋' },
  { id: 'kissing', name: 'kissing', names: ['kissing'], unicode: '😗' },
  { id: 'kissing_cat', name: 'kissing_cat', names: ['kissing_cat'], unicode: '😽' },
  {
    id: 'kissing_closed_eyes',
    name: 'kissing_closed_eyes',
    names: ['kissing_closed_eyes'],
    unicode: '😚',
  },
  { id: 'kissing_heart', name: 'kissing_heart', names: ['kissing_heart'], unicode: '😘' },
  {
    id: 'kissing_smiling_eyes',
    name: 'kissing_smiling_eyes',
    names: ['kissing_smiling_eyes'],
    unicode: '😙',
  },
  { id: 'kite', name: 'kite', names: ['kite'], unicode: '🪁' },
  { id: 'kiwifruit', name: 'kiwifruit', names: ['kiwifruit'], unicode: '🥝' },
  {
    id: 'kneeling_person',
    name: 'kneeling_person',
    names: ['kneeling_person'],
    skins: ['🧎🏻', '🧎🏼', '🧎🏽', '🧎🏾', '🧎🏿'],
    unicode: '🧎',
  },
  { id: 'knife_fork_plate', name: 'knife_fork_plate', names: ['knife_fork_plate'], unicode: '🍽️' },
  { id: 'knot', name: 'knot', names: ['knot'], unicode: '🪢' },
  { id: 'koala', name: 'koala', names: ['koala'], unicode: '🐨' },
  { id: 'koko', name: 'koko', names: ['koko'], unicode: '🈁' },
  { id: 'kr', name: 'kr', names: ['kr', 'flag-kr'], unicode: '🇰🇷' },
  { id: 'lab_coat', name: 'lab_coat', names: ['lab_coat'], unicode: '🥼' },
  { id: 'label', name: 'label', names: ['label'], unicode: '🏷️' },
  { id: 'lacrosse', name: 'lacrosse', names: ['lacrosse'], unicode: '🥍' },
  { id: 'ladder', name: 'ladder', names: ['ladder'], unicode: '🪜' },
  { id: 'ladybug', name: 'ladybug', names: ['ladybug', 'lady_beetle'], unicode: '🐞' },
  {
    id: 'large_blue_circle',
    name: 'large_blue_circle',
    names: ['large_blue_circle'],
    unicode: '🔵',
  },
  {
    id: 'large_blue_diamond',
    name: 'large_blue_diamond',
    names: ['large_blue_diamond'],
    unicode: '🔷',
  },
  {
    id: 'large_blue_square',
    name: 'large_blue_square',
    names: ['large_blue_square'],
    unicode: '🟦',
  },
  {
    id: 'large_brown_circle',
    name: 'large_brown_circle',
    names: ['large_brown_circle'],
    unicode: '🟤',
  },
  {
    id: 'large_brown_square',
    name: 'large_brown_square',
    names: ['large_brown_square'],
    unicode: '🟫',
  },
  {
    id: 'large_green_circle',
    name: 'large_green_circle',
    names: ['large_green_circle'],
    unicode: '🟢',
  },
  {
    id: 'large_green_square',
    name: 'large_green_square',
    names: ['large_green_square'],
    unicode: '🟩',
  },
  {
    id: 'large_orange_circle',
    name: 'large_orange_circle',
    names: ['large_orange_circle'],
    unicode: '🟠',
  },
  {
    id: 'large_orange_diamond',
    name: 'large_orange_diamond',
    names: ['large_orange_diamond'],
    unicode: '🔶',
  },
  {
    id: 'large_orange_square',
    name: 'large_orange_square',
    names: ['large_orange_square'],
    unicode: '🟧',
  },
  {
    id: 'large_purple_circle',
    name: 'large_purple_circle',
    names: ['large_purple_circle'],
    unicode: '🟣',
  },
  {
    id: 'large_purple_square',
    name: 'large_purple_square',
    names: ['large_purple_square'],
    unicode: '🟪',
  },
  { id: 'large_red_square', name: 'large_red_square', names: ['large_red_square'], unicode: '🟥' },
  {
    id: 'large_yellow_circle',
    name: 'large_yellow_circle',
    names: ['large_yellow_circle'],
    unicode: '🟡',
  },
  {
    id: 'large_yellow_square',
    name: 'large_yellow_square',
    names: ['large_yellow_square'],
    unicode: '🟨',
  },
  {
    id: 'last_quarter_moon',
    name: 'last_quarter_moon',
    names: ['last_quarter_moon'],
    unicode: '🌗',
  },
  {
    id: 'last_quarter_moon_with_face',
    name: 'last_quarter_moon_with_face',
    names: ['last_quarter_moon_with_face'],
    unicode: '🌜',
  },
  { id: 'latin_cross', name: 'latin_cross', names: ['latin_cross'], unicode: '✝️' },
  { id: 'laughing', name: 'laughing', names: ['laughing', 'satisfied'], unicode: '😆' },
  { id: 'leafy_green', name: 'leafy_green', names: ['leafy_green'], unicode: '🥬' },
  { id: 'leaves', name: 'leaves', names: ['leaves'], unicode: '🍃' },
  { id: 'ledger', name: 'ledger', names: ['ledger'], unicode: '📒' },
  {
    id: 'left-facing_fist',
    name: 'left-facing_fist',
    names: ['left-facing_fist'],
    skins: ['🤛🏻', '🤛🏼', '🤛🏽', '🤛🏾', '🤛🏿'],
    unicode: '🤛',
  },
  { id: 'left_luggage', name: 'left_luggage', names: ['left_luggage'], unicode: '🛅' },
  { id: 'left_right_arrow', name: 'left_right_arrow', names: ['left_right_arrow'], unicode: '↔️' },
  {
    id: 'left_speech_bubble',
    name: 'left_speech_bubble',
    names: ['left_speech_bubble'],
    unicode: '🗨️',
  },
  {
    id: 'leftwards_arrow_with_hook',
    name: 'leftwards_arrow_with_hook',
    names: ['leftwards_arrow_with_hook'],
    unicode: '↩️',
  },
  {
    id: 'leftwards_hand',
    name: 'leftwards_hand',
    names: ['leftwards_hand'],
    skins: ['🫲🏻', '🫲🏼', '🫲🏽', '🫲🏾', '🫲🏿'],
    unicode: '🫲',
  },
  {
    id: 'leftwards_pushing_hand',
    name: 'leftwards_pushing_hand',
    names: ['leftwards_pushing_hand'],
    skins: ['🫷🏻', '🫷🏼', '🫷🏽', '🫷🏾', '🫷🏿'],
    unicode: '🫷',
  },
  { id: 'leg', name: 'leg', names: ['leg'], skins: ['🦵🏻', '🦵🏼', '🦵🏽', '🦵🏾', '🦵🏿'], unicode: '🦵' },
  { id: 'lemon', name: 'lemon', names: ['lemon'], unicode: '🍋' },
  { id: 'leo', name: 'leo', names: ['leo'], unicode: '♌' },
  { id: 'leopard', name: 'leopard', names: ['leopard'], unicode: '🐆' },
  { id: 'level_slider', name: 'level_slider', names: ['level_slider'], unicode: '🎚️' },
  { id: 'libra', name: 'libra', names: ['libra'], unicode: '♎' },
  { id: 'light_blue_heart', name: 'light_blue_heart', names: ['light_blue_heart'], unicode: '🩵' },
  { id: 'light_rail', name: 'light_rail', names: ['light_rail'], unicode: '🚈' },
  { id: 'lightning', name: 'lightning', names: ['lightning', 'lightning_cloud'], unicode: '🌩️' },
  { id: 'lime', name: 'lime', names: ['lime'], unicode: '🍋‍🟩' },
  { id: 'link', name: 'link', names: ['link'], unicode: '🔗' },
  {
    id: 'linked_paperclips',
    name: 'linked_paperclips',
    names: ['linked_paperclips'],
    unicode: '🖇️',
  },
  { id: 'lion_face', name: 'lion_face', names: ['lion_face'], unicode: '🦁' },
  { id: 'lips', name: 'lips', names: ['lips'], unicode: '👄' },
  { id: 'lipstick', name: 'lipstick', names: ['lipstick'], unicode: '💄' },
  { id: 'lizard', name: 'lizard', names: ['lizard'], unicode: '🦎' },
  { id: 'llama', name: 'llama', names: ['llama'], unicode: '🦙' },
  { id: 'lobster', name: 'lobster', names: ['lobster'], unicode: '🦞' },
  { id: 'lock', name: 'lock', names: ['lock'], unicode: '🔒' },
  {
    id: 'lock_with_ink_pen',
    name: 'lock_with_ink_pen',
    names: ['lock_with_ink_pen'],
    unicode: '🔏',
  },
  { id: 'lollipop', name: 'lollipop', names: ['lollipop'], unicode: '🍭' },
  { id: 'long_drum', name: 'long_drum', names: ['long_drum'], unicode: '🪘' },
  { id: 'loop', name: 'loop', names: ['loop'], unicode: '➿' },
  { id: 'lotion_bottle', name: 'lotion_bottle', names: ['lotion_bottle'], unicode: '🧴' },
  { id: 'lotus', name: 'lotus', names: ['lotus'], unicode: '🪷' },
  { id: 'loud_sound', name: 'loud_sound', names: ['loud_sound'], unicode: '🔊' },
  { id: 'loudspeaker', name: 'loudspeaker', names: ['loudspeaker'], unicode: '📢' },
  { id: 'love_hotel', name: 'love_hotel', names: ['love_hotel'], unicode: '🏩' },
  { id: 'love_letter', name: 'love_letter', names: ['love_letter'], unicode: '💌' },
  { id: 'low_battery', name: 'low_battery', names: ['low_battery'], unicode: '🪫' },
  { id: 'low_brightness', name: 'low_brightness', names: ['low_brightness'], unicode: '🔅' },
  {
    id: 'lower_left_ballpoint_pen',
    name: 'lower_left_ballpoint_pen',
    names: ['lower_left_ballpoint_pen'],
    unicode: '🖊️',
  },
  {
    id: 'lower_left_crayon',
    name: 'lower_left_crayon',
    names: ['lower_left_crayon'],
    unicode: '🖍️',
  },
  {
    id: 'lower_left_fountain_pen',
    name: 'lower_left_fountain_pen',
    names: ['lower_left_fountain_pen'],
    unicode: '🖋️',
  },
  {
    id: 'lower_left_paintbrush',
    name: 'lower_left_paintbrush',
    names: ['lower_left_paintbrush'],
    unicode: '🖌️',
  },
  { id: 'luggage', name: 'luggage', names: ['luggage'], unicode: '🧳' },
  { id: 'lungs', name: 'lungs', names: ['lungs'], unicode: '🫁' },
  { id: 'lying_face', name: 'lying_face', names: ['lying_face'], unicode: '🤥' },
  { id: 'm', name: 'm', names: ['m'], unicode: 'Ⓜ️' },
  { id: 'mag', name: 'mag', names: ['mag'], unicode: '🔍' },
  { id: 'mag_right', name: 'mag_right', names: ['mag_right'], unicode: '🔎' },
  {
    id: 'mage',
    name: 'mage',
    names: ['mage'],
    skins: ['🧙🏻', '🧙🏼', '🧙🏽', '🧙🏾', '🧙🏿'],
    unicode: '🧙',
  },
  { id: 'magic_wand', name: 'magic_wand', names: ['magic_wand'], unicode: '🪄' },
  { id: 'magnet', name: 'magnet', names: ['magnet'], unicode: '🧲' },
  { id: 'mahjong', name: 'mahjong', names: ['mahjong'], unicode: '🀄' },
  { id: 'mailbox', name: 'mailbox', names: ['mailbox'], unicode: '📫' },
  { id: 'mailbox_closed', name: 'mailbox_closed', names: ['mailbox_closed'], unicode: '📪' },
  {
    id: 'mailbox_with_mail',
    name: 'mailbox_with_mail',
    names: ['mailbox_with_mail'],
    unicode: '📬',
  },
  {
    id: 'mailbox_with_no_mail',
    name: 'mailbox_with_no_mail',
    names: ['mailbox_with_no_mail'],
    unicode: '📭',
  },
  {
    id: 'male-artist',
    name: 'male-artist',
    names: ['male-artist'],
    skins: ['👨🏻‍🎨', '👨🏼‍🎨', '👨🏽‍🎨', '👨🏾‍🎨', '👨🏿‍🎨'],
    unicode: '👨‍🎨',
  },
  {
    id: 'male-astronaut',
    name: 'male-astronaut',
    names: ['male-astronaut'],
    skins: ['👨🏻‍🚀', '👨🏼‍🚀', '👨🏽‍🚀', '👨🏾‍🚀', '👨🏿‍🚀'],
    unicode: '👨‍🚀',
  },
  {
    id: 'male-construction-worker',
    name: 'male-construction-worker',
    names: ['male-construction-worker'],
    skins: ['👷🏻‍♂️', '👷🏼‍♂️', '👷🏽‍♂️', '👷🏾‍♂️', '👷🏿‍♂️'],
    unicode: '👷‍♂️',
  },
  {
    id: 'male-cook',
    name: 'male-cook',
    names: ['male-cook'],
    skins: ['👨🏻‍🍳', '👨🏼‍🍳', '👨🏽‍🍳', '👨🏾‍🍳', '👨🏿‍🍳'],
    unicode: '👨‍🍳',
  },
  {
    id: 'male-detective',
    name: 'male-detective',
    names: ['male-detective'],
    skins: ['🕵🏻‍♂️', '🕵🏼‍♂️', '🕵🏽‍♂️', '🕵🏾‍♂️', '🕵🏿‍♂️'],
    unicode: '🕵️‍♂️',
  },
  {
    id: 'male-doctor',
    name: 'male-doctor',
    names: ['male-doctor'],
    skins: ['👨🏻‍⚕️', '👨🏼‍⚕️', '👨🏽‍⚕️', '👨🏾‍⚕️', '👨🏿‍⚕️'],
    unicode: '👨‍⚕️',
  },
  {
    id: 'male-factory-worker',
    name: 'male-factory-worker',
    names: ['male-factory-worker'],
    skins: ['👨🏻‍🏭', '👨🏼‍🏭', '👨🏽‍🏭', '👨🏾‍🏭', '👨🏿‍🏭'],
    unicode: '👨‍🏭',
  },
  {
    id: 'male-farmer',
    name: 'male-farmer',
    names: ['male-farmer'],
    skins: ['👨🏻‍🌾', '👨🏼‍🌾', '👨🏽‍🌾', '👨🏾‍🌾', '👨🏿‍🌾'],
    unicode: '👨‍🌾',
  },
  {
    id: 'male-firefighter',
    name: 'male-firefighter',
    names: ['male-firefighter'],
    skins: ['👨🏻‍🚒', '👨🏼‍🚒', '👨🏽‍🚒', '👨🏾‍🚒', '👨🏿‍🚒'],
    unicode: '👨‍🚒',
  },
  {
    id: 'male-guard',
    name: 'male-guard',
    names: ['male-guard'],
    skins: ['💂🏻‍♂️', '💂🏼‍♂️', '💂🏽‍♂️', '💂🏾‍♂️', '💂🏿‍♂️'],
    unicode: '💂‍♂️',
  },
  {
    id: 'male-judge',
    name: 'male-judge',
    names: ['male-judge'],
    skins: ['👨🏻‍⚖️', '👨🏼‍⚖️', '👨🏽‍⚖️', '👨🏾‍⚖️', '👨🏿‍⚖️'],
    unicode: '👨‍⚖️',
  },
  {
    id: 'male-mechanic',
    name: 'male-mechanic',
    names: ['male-mechanic'],
    skins: ['👨🏻‍🔧', '👨🏼‍🔧', '👨🏽‍🔧', '👨🏾‍🔧', '👨🏿‍🔧'],
    unicode: '👨‍🔧',
  },
  {
    id: 'male-office-worker',
    name: 'male-office-worker',
    names: ['male-office-worker'],
    skins: ['👨🏻‍💼', '👨🏼‍💼', '👨🏽‍💼', '👨🏾‍💼', '👨🏿‍💼'],
    unicode: '👨‍💼',
  },
  {
    id: 'male-pilot',
    name: 'male-pilot',
    names: ['male-pilot'],
    skins: ['👨🏻‍✈️', '👨🏼‍✈️', '👨🏽‍✈️', '👨🏾‍✈️', '👨🏿‍✈️'],
    unicode: '👨‍✈️',
  },
  {
    id: 'male-police-officer',
    name: 'male-police-officer',
    names: ['male-police-officer'],
    skins: ['👮🏻‍♂️', '👮🏼‍♂️', '👮🏽‍♂️', '👮🏾‍♂️', '👮🏿‍♂️'],
    unicode: '👮‍♂️',
  },
  {
    id: 'male-scientist',
    name: 'male-scientist',
    names: ['male-scientist'],
    skins: ['👨🏻‍🔬', '👨🏼‍🔬', '👨🏽‍🔬', '👨🏾‍🔬', '👨🏿‍🔬'],
    unicode: '👨‍🔬',
  },
  {
    id: 'male-singer',
    name: 'male-singer',
    names: ['male-singer'],
    skins: ['👨🏻‍🎤', '👨🏼‍🎤', '👨🏽‍🎤', '👨🏾‍🎤', '👨🏿‍🎤'],
    unicode: '👨‍🎤',
  },
  {
    id: 'male-student',
    name: 'male-student',
    names: ['male-student'],
    skins: ['👨🏻‍🎓', '👨🏼‍🎓', '👨🏽‍🎓', '👨🏾‍🎓', '👨🏿‍🎓'],
    unicode: '👨‍🎓',
  },
  {
    id: 'male-teacher',
    name: 'male-teacher',
    names: ['male-teacher'],
    skins: ['👨🏻‍🏫', '👨🏼‍🏫', '👨🏽‍🏫', '👨🏾‍🏫', '👨🏿‍🏫'],
    unicode: '👨‍🏫',
  },
  {
    id: 'male-technologist',
    name: 'male-technologist',
    names: ['male-technologist'],
    skins: ['👨🏻‍💻', '👨🏼‍💻', '👨🏽‍💻', '👨🏾‍💻', '👨🏿‍💻'],
    unicode: '👨‍💻',
  },
  {
    id: 'male_elf',
    name: 'male_elf',
    names: ['male_elf'],
    skins: ['🧝🏻‍♂️', '🧝🏼‍♂️', '🧝🏽‍♂️', '🧝🏾‍♂️', '🧝🏿‍♂️'],
    unicode: '🧝‍♂️',
  },
  {
    id: 'male_fairy',
    name: 'male_fairy',
    names: ['male_fairy'],
    skins: ['🧚🏻‍♂️', '🧚🏼‍♂️', '🧚🏽‍♂️', '🧚🏾‍♂️', '🧚🏿‍♂️'],
    unicode: '🧚‍♂️',
  },
  { id: 'male_genie', name: 'male_genie', names: ['male_genie'], unicode: '🧞‍♂️' },
  {
    id: 'male_mage',
    name: 'male_mage',
    names: ['male_mage'],
    skins: ['🧙🏻‍♂️', '🧙🏼‍♂️', '🧙🏽‍♂️', '🧙🏾‍♂️', '🧙🏿‍♂️'],
    unicode: '🧙‍♂️',
  },
  { id: 'male_sign', name: 'male_sign', names: ['male_sign'], unicode: '♂️' },
  {
    id: 'male_superhero',
    name: 'male_superhero',
    names: ['male_superhero'],
    skins: ['🦸🏻‍♂️', '🦸🏼‍♂️', '🦸🏽‍♂️', '🦸🏾‍♂️', '🦸🏿‍♂️'],
    unicode: '🦸‍♂️',
  },
  {
    id: 'male_supervillain',
    name: 'male_supervillain',
    names: ['male_supervillain'],
    skins: ['🦹🏻‍♂️', '🦹🏼‍♂️', '🦹🏽‍♂️', '🦹🏾‍♂️', '🦹🏿‍♂️'],
    unicode: '🦹‍♂️',
  },
  {
    id: 'male_vampire',
    name: 'male_vampire',
    names: ['male_vampire'],
    skins: ['🧛🏻‍♂️', '🧛🏼‍♂️', '🧛🏽‍♂️', '🧛🏾‍♂️', '🧛🏿‍♂️'],
    unicode: '🧛‍♂️',
  },
  { id: 'male_zombie', name: 'male_zombie', names: ['male_zombie'], unicode: '🧟‍♂️' },
  { id: 'mammoth', name: 'mammoth', names: ['mammoth'], unicode: '🦣' },
  { id: 'man', name: 'man', names: ['man'], skins: ['👨🏻', '👨🏼', '👨🏽', '👨🏾', '👨🏿'], unicode: '👨' },
  {
    id: 'man-biking',
    name: 'man-biking',
    names: ['man-biking'],
    skins: ['🚴🏻‍♂️', '🚴🏼‍♂️', '🚴🏽‍♂️', '🚴🏾‍♂️', '🚴🏿‍♂️'],
    unicode: '🚴‍♂️',
  },
  {
    id: 'man-bouncing-ball',
    name: 'man-bouncing-ball',
    names: ['man-bouncing-ball'],
    skins: ['⛹🏻‍♂️', '⛹🏼‍♂️', '⛹🏽‍♂️', '⛹🏾‍♂️', '⛹🏿‍♂️'],
    unicode: '⛹️‍♂️',
  },
  {
    id: 'man-bowing',
    name: 'man-bowing',
    names: ['man-bowing'],
    skins: ['🙇🏻‍♂️', '🙇🏼‍♂️', '🙇🏽‍♂️', '🙇🏾‍♂️', '🙇🏿‍♂️'],
    unicode: '🙇‍♂️',
  },
  { id: 'man-boy', name: 'man-boy', names: ['man-boy'], unicode: '👨‍👦' },
  { id: 'man-boy-boy', name: 'man-boy-boy', names: ['man-boy-boy'], unicode: '👨‍👦‍👦' },
  {
    id: 'man-cartwheeling',
    name: 'man-cartwheeling',
    names: ['man-cartwheeling'],
    skins: ['🤸🏻‍♂️', '🤸🏼‍♂️', '🤸🏽‍♂️', '🤸🏾‍♂️', '🤸🏿‍♂️'],
    unicode: '🤸‍♂️',
  },
  {
    id: 'man-facepalming',
    name: 'man-facepalming',
    names: ['man-facepalming'],
    skins: ['🤦🏻‍♂️', '🤦🏼‍♂️', '🤦🏽‍♂️', '🤦🏾‍♂️', '🤦🏿‍♂️'],
    unicode: '🤦‍♂️',
  },
  {
    id: 'man-frowning',
    name: 'man-frowning',
    names: ['man-frowning'],
    skins: ['🙍🏻‍♂️', '🙍🏼‍♂️', '🙍🏽‍♂️', '🙍🏾‍♂️', '🙍🏿‍♂️'],
    unicode: '🙍‍♂️',
  },
  {
    id: 'man-gesturing-no',
    name: 'man-gesturing-no',
    names: ['man-gesturing-no'],
    skins: ['🙅🏻‍♂️', '🙅🏼‍♂️', '🙅🏽‍♂️', '🙅🏾‍♂️', '🙅🏿‍♂️'],
    unicode: '🙅‍♂️',
  },
  {
    id: 'man-gesturing-ok',
    name: 'man-gesturing-ok',
    names: ['man-gesturing-ok'],
    skins: ['🙆🏻‍♂️', '🙆🏼‍♂️', '🙆🏽‍♂️', '🙆🏾‍♂️', '🙆🏿‍♂️'],
    unicode: '🙆‍♂️',
  },
  {
    id: 'man-getting-haircut',
    name: 'man-getting-haircut',
    names: ['man-getting-haircut'],
    skins: ['💇🏻‍♂️', '💇🏼‍♂️', '💇🏽‍♂️', '💇🏾‍♂️', '💇🏿‍♂️'],
    unicode: '💇‍♂️',
  },
  {
    id: 'man-getting-massage',
    name: 'man-getting-massage',
    names: ['man-getting-massage'],
    skins: ['💆🏻‍♂️', '💆🏼‍♂️', '💆🏽‍♂️', '💆🏾‍♂️', '💆🏿‍♂️'],
    unicode: '💆‍♂️',
  },
  { id: 'man-girl', name: 'man-girl', names: ['man-girl'], unicode: '👨‍👧' },
  { id: 'man-girl-boy', name: 'man-girl-boy', names: ['man-girl-boy'], unicode: '👨‍👧‍👦' },
  { id: 'man-girl-girl', name: 'man-girl-girl', names: ['man-girl-girl'], unicode: '👨‍👧‍👧' },
  {
    id: 'man-golfing',
    name: 'man-golfing',
    names: ['man-golfing'],
    skins: ['🏌🏻‍♂️', '🏌🏼‍♂️', '🏌🏽‍♂️', '🏌🏾‍♂️', '🏌🏿‍♂️'],
    unicode: '🏌️‍♂️',
  },
  {
    id: 'man-heart-man',
    name: 'man-heart-man',
    names: ['man-heart-man'],
    skins: [
      '👨🏻‍❤️‍👨🏻',
      '👨🏻‍❤️‍👨🏼',
      '👨🏻‍❤️‍👨🏽',
      '👨🏻‍❤️‍👨🏾',
      '👨🏻‍❤️‍👨🏿',
      '👨🏼‍❤️‍👨🏻',
      '👨🏼‍❤️‍👨🏼',
      '👨🏼‍❤️‍👨🏽',
      '👨🏼‍❤️‍👨🏾',
      '👨🏼‍❤️‍👨🏿',
      '👨🏽‍❤️‍👨🏻',
      '👨🏽‍❤️‍👨🏼',
      '👨🏽‍❤️‍👨🏽',
      '👨🏽‍❤️‍👨🏾',
      '👨🏽‍❤️‍👨🏿',
      '👨🏾‍❤️‍👨🏻',
      '👨🏾‍❤️‍👨🏼',
      '👨🏾‍❤️‍👨🏽',
      '👨🏾‍❤️‍👨🏾',
      '👨🏾‍❤️‍👨🏿',
      '👨🏿‍❤️‍👨🏻',
      '👨🏿‍❤️‍👨🏼',
      '👨🏿‍❤️‍👨🏽',
      '👨🏿‍❤️‍👨🏾',
      '👨🏿‍❤️‍👨🏿',
    ],
    unicode: '👨‍❤️‍👨',
  },
  {
    id: 'man-juggling',
    name: 'man-juggling',
    names: ['man-juggling'],
    skins: ['🤹🏻‍♂️', '🤹🏼‍♂️', '🤹🏽‍♂️', '🤹🏾‍♂️', '🤹🏿‍♂️'],
    unicode: '🤹‍♂️',
  },
  {
    id: 'man-kiss-man',
    name: 'man-kiss-man',
    names: ['man-kiss-man'],
    skins: [
      '👨🏻‍❤️‍💋‍👨🏻',
      '👨🏻‍❤️‍💋‍👨🏼',
      '👨🏻‍❤️‍💋‍👨🏽',
      '👨🏻‍❤️‍💋‍👨🏾',
      '👨🏻‍❤️‍💋‍👨🏿',
      '👨🏼‍❤️‍💋‍👨🏻',
      '👨🏼‍❤️‍💋‍👨🏼',
      '👨🏼‍❤️‍💋‍👨🏽',
      '👨🏼‍❤️‍💋‍👨🏾',
      '👨🏼‍❤️‍💋‍👨🏿',
      '👨🏽‍❤️‍💋‍👨🏻',
      '👨🏽‍❤️‍💋‍👨🏼',
      '👨🏽‍❤️‍💋‍👨🏽',
      '👨🏽‍❤️‍💋‍👨🏾',
      '👨🏽‍❤️‍💋‍👨🏿',
      '👨🏾‍❤️‍💋‍👨🏻',
      '👨🏾‍❤️‍💋‍👨🏼',
      '👨🏾‍❤️‍💋‍👨🏽',
      '👨🏾‍❤️‍💋‍👨🏾',
      '👨🏾‍❤️‍💋‍👨🏿',
      '👨🏿‍❤️‍💋‍👨🏻',
      '👨🏿‍❤️‍💋‍👨🏼',
      '👨🏿‍❤️‍💋‍👨🏽',
      '👨🏿‍❤️‍💋‍👨🏾',
      '👨🏿‍❤️‍💋‍👨🏿',
    ],
    unicode: '👨‍❤️‍💋‍👨',
  },
  {
    id: 'man-lifting-weights',
    name: 'man-lifting-weights',
    names: ['man-lifting-weights'],
    skins: ['🏋🏻‍♂️', '🏋🏼‍♂️', '🏋🏽‍♂️', '🏋🏾‍♂️', '🏋🏿‍♂️'],
    unicode: '🏋️‍♂️',
  },
  { id: 'man-man-boy', name: 'man-man-boy', names: ['man-man-boy'], unicode: '👨‍👨‍👦' },
  { id: 'man-man-boy-boy', name: 'man-man-boy-boy', names: ['man-man-boy-boy'], unicode: '👨‍👨‍👦‍👦' },
  { id: 'man-man-girl', name: 'man-man-girl', names: ['man-man-girl'], unicode: '👨‍👨‍👧' },
  { id: 'man-man-girl-boy', name: 'man-man-girl-boy', names: ['man-man-girl-boy'], unicode: '👨‍👨‍👧‍👦' },
  {
    id: 'man-man-girl-girl',
    name: 'man-man-girl-girl',
    names: ['man-man-girl-girl'],
    unicode: '👨‍👨‍👧‍👧',
  },
  {
    id: 'man-mountain-biking',
    name: 'man-mountain-biking',
    names: ['man-mountain-biking'],
    skins: ['🚵🏻‍♂️', '🚵🏼‍♂️', '🚵🏽‍♂️', '🚵🏾‍♂️', '🚵🏿‍♂️'],
    unicode: '🚵‍♂️',
  },
  {
    id: 'man-playing-handball',
    name: 'man-playing-handball',
    names: ['man-playing-handball'],
    skins: ['🤾🏻‍♂️', '🤾🏼‍♂️', '🤾🏽‍♂️', '🤾🏾‍♂️', '🤾🏿‍♂️'],
    unicode: '🤾‍♂️',
  },
  {
    id: 'man-playing-water-polo',
    name: 'man-playing-water-polo',
    names: ['man-playing-water-polo'],
    skins: ['🤽🏻‍♂️', '🤽🏼‍♂️', '🤽🏽‍♂️', '🤽🏾‍♂️', '🤽🏿‍♂️'],
    unicode: '🤽‍♂️',
  },
  {
    id: 'man-pouting',
    name: 'man-pouting',
    names: ['man-pouting'],
    skins: ['🙎🏻‍♂️', '🙎🏼‍♂️', '🙎🏽‍♂️', '🙎🏾‍♂️', '🙎🏿‍♂️'],
    unicode: '🙎‍♂️',
  },
  {
    id: 'man-raising-hand',
    name: 'man-raising-hand',
    names: ['man-raising-hand'],
    skins: ['🙋🏻‍♂️', '🙋🏼‍♂️', '🙋🏽‍♂️', '🙋🏾‍♂️', '🙋🏿‍♂️'],
    unicode: '🙋‍♂️',
  },
  {
    id: 'man-rowing-boat',
    name: 'man-rowing-boat',
    names: ['man-rowing-boat'],
    skins: ['🚣🏻‍♂️', '🚣🏼‍♂️', '🚣🏽‍♂️', '🚣🏾‍♂️', '🚣🏿‍♂️'],
    unicode: '🚣‍♂️',
  },
  {
    id: 'man-running',
    name: 'man-running',
    names: ['man-running'],
    skins: ['🏃🏻‍♂️', '🏃🏼‍♂️', '🏃🏽‍♂️', '🏃🏾‍♂️', '🏃🏿‍♂️'],
    unicode: '🏃‍♂️',
  },
  {
    id: 'man-shrugging',
    name: 'man-shrugging',
    names: ['man-shrugging'],
    skins: ['🤷🏻‍♂️', '🤷🏼‍♂️', '🤷🏽‍♂️', '🤷🏾‍♂️', '🤷🏿‍♂️'],
    unicode: '🤷‍♂️',
  },
  {
    id: 'man-surfing',
    name: 'man-surfing',
    names: ['man-surfing'],
    skins: ['🏄🏻‍♂️', '🏄🏼‍♂️', '🏄🏽‍♂️', '🏄🏾‍♂️', '🏄🏿‍♂️'],
    unicode: '🏄‍♂️',
  },
  {
    id: 'man-swimming',
    name: 'man-swimming',
    names: ['man-swimming'],
    skins: ['🏊🏻‍♂️', '🏊🏼‍♂️', '🏊🏽‍♂️', '🏊🏾‍♂️', '🏊🏿‍♂️'],
    unicode: '🏊‍♂️',
  },
  {
    id: 'man-tipping-hand',
    name: 'man-tipping-hand',
    names: ['man-tipping-hand'],
    skins: ['💁🏻‍♂️', '💁🏼‍♂️', '💁🏽‍♂️', '💁🏾‍♂️', '💁🏿‍♂️'],
    unicode: '💁‍♂️',
  },
  {
    id: 'man-walking',
    name: 'man-walking',
    names: ['man-walking'],
    skins: ['🚶🏻‍♂️', '🚶🏼‍♂️', '🚶🏽‍♂️', '🚶🏾‍♂️', '🚶🏿‍♂️'],
    unicode: '🚶‍♂️',
  },
  {
    id: 'man-wearing-turban',
    name: 'man-wearing-turban',
    names: ['man-wearing-turban'],
    skins: ['👳🏻‍♂️', '👳🏼‍♂️', '👳🏽‍♂️', '👳🏾‍♂️', '👳🏿‍♂️'],
    unicode: '👳‍♂️',
  },
  { id: 'man-woman-boy', name: 'man-woman-boy', names: ['man-woman-boy'], unicode: '👨‍👩‍👦' },
  {
    id: 'man-woman-boy-boy',
    name: 'man-woman-boy-boy',
    names: ['man-woman-boy-boy'],
    unicode: '👨‍👩‍👦‍👦',
  },
  { id: 'man-woman-girl', name: 'man-woman-girl', names: ['man-woman-girl'], unicode: '👨‍👩‍👧' },
  {
    id: 'man-woman-girl-boy',
    name: 'man-woman-girl-boy',
    names: ['man-woman-girl-boy'],
    unicode: '👨‍👩‍👧‍👦',
  },
  {
    id: 'man-woman-girl-girl',
    name: 'man-woman-girl-girl',
    names: ['man-woman-girl-girl'],
    unicode: '👨‍👩‍👧‍👧',
  },
  { id: 'man-wrestling', name: 'man-wrestling', names: ['man-wrestling'], unicode: '🤼‍♂️' },
  {
    id: 'man_and_woman_holding_hands',
    name: 'man_and_woman_holding_hands',
    names: ['man_and_woman_holding_hands', 'woman_and_man_holding_hands', 'couple'],
    skins: [
      '👫🏻',
      '👫🏼',
      '👫🏽',
      '👫🏾',
      '👫🏿',
      '👩🏻‍🤝‍👨🏼',
      '👩🏻‍🤝‍👨🏽',
      '👩🏻‍🤝‍👨🏾',
      '👩🏻‍🤝‍👨🏿',
      '👩🏼‍🤝‍👨🏻',
      '👩🏼‍🤝‍👨🏽',
      '👩🏼‍🤝‍👨🏾',
      '👩🏼‍🤝‍👨🏿',
      '👩🏽‍🤝‍👨🏻',
      '👩🏽‍🤝‍👨🏼',
      '👩🏽‍🤝‍👨🏾',
      '👩🏽‍🤝‍👨🏿',
      '👩🏾‍🤝‍👨🏻',
      '👩🏾‍🤝‍👨🏼',
      '👩🏾‍🤝‍👨🏽',
      '👩🏾‍🤝‍👨🏿',
      '👩🏿‍🤝‍👨🏻',
      '👩🏿‍🤝‍👨🏼',
      '👩🏿‍🤝‍👨🏽',
      '👩🏿‍🤝‍👨🏾',
    ],
    unicode: '👫',
  },
  {
    id: 'man_climbing',
    name: 'man_climbing',
    names: ['man_climbing'],
    skins: ['🧗🏻‍♂️', '🧗🏼‍♂️', '🧗🏽‍♂️', '🧗🏾‍♂️', '🧗🏿‍♂️'],
    unicode: '🧗‍♂️',
  },
  {
    id: 'man_dancing',
    name: 'man_dancing',
    names: ['man_dancing'],
    skins: ['🕺🏻', '🕺🏼', '🕺🏽', '🕺🏾', '🕺🏿'],
    unicode: '🕺',
  },
  {
    id: 'man_feeding_baby',
    name: 'man_feeding_baby',
    names: ['man_feeding_baby'],
    skins: ['👨🏻‍🍼', '👨🏼‍🍼', '👨🏽‍🍼', '👨🏾‍🍼', '👨🏿‍🍼'],
    unicode: '👨‍🍼',
  },
  {
    id: 'man_in_business_suit_levitating',
    name: 'man_in_business_suit_levitating',
    names: ['man_in_business_suit_levitating'],
    skins: ['🕴🏻', '🕴🏼', '🕴🏽', '🕴🏾', '🕴🏿'],
    unicode: '🕴️',
  },
  {
    id: 'man_in_lotus_position',
    name: 'man_in_lotus_position',
    names: ['man_in_lotus_position'],
    skins: ['🧘🏻‍♂️', '🧘🏼‍♂️', '🧘🏽‍♂️', '🧘🏾‍♂️', '🧘🏿‍♂️'],
    unicode: '🧘‍♂️',
  },
  {
    id: 'man_in_manual_wheelchair',
    name: 'man_in_manual_wheelchair',
    names: ['man_in_manual_wheelchair'],
    skins: ['👨🏻‍🦽', '👨🏼‍🦽', '👨🏽‍🦽', '👨🏾‍🦽', '👨🏿‍🦽'],
    unicode: '👨‍🦽',
  },
  {
    id: 'man_in_manual_wheelchair_facing_right',
    name: 'man_in_manual_wheelchair_facing_right',
    names: ['man_in_manual_wheelchair_facing_right'],
    skins: ['👨🏻‍🦽‍➡️', '👨🏼‍🦽‍➡️', '👨🏽‍🦽‍➡️', '👨🏾‍🦽‍➡️', '👨🏿‍🦽‍➡️'],
    unicode: '👨‍🦽‍➡️',
  },
  {
    id: 'man_in_motorized_wheelchair',
    name: 'man_in_motorized_wheelchair',
    names: ['man_in_motorized_wheelchair'],
    skins: ['👨🏻‍🦼', '👨🏼‍🦼', '👨🏽‍🦼', '👨🏾‍🦼', '👨🏿‍🦼'],
    unicode: '👨‍🦼',
  },
  {
    id: 'man_in_motorized_wheelchair_facing_right',
    name: 'man_in_motorized_wheelchair_facing_right',
    names: ['man_in_motorized_wheelchair_facing_right'],
    skins: ['👨🏻‍🦼‍➡️', '👨🏼‍🦼‍➡️', '👨🏽‍🦼‍➡️', '👨🏾‍🦼‍➡️', '👨🏿‍🦼‍➡️'],
    unicode: '👨‍🦼‍➡️',
  },
  {
    id: 'man_in_steamy_room',
    name: 'man_in_steamy_room',
    names: ['man_in_steamy_room'],
    skins: ['🧖🏻‍♂️', '🧖🏼‍♂️', '🧖🏽‍♂️', '🧖🏾‍♂️', '🧖🏿‍♂️'],
    unicode: '🧖‍♂️',
  },
  {
    id: 'man_in_tuxedo',
    name: 'man_in_tuxedo',
    names: ['man_in_tuxedo'],
    skins: ['🤵🏻‍♂️', '🤵🏼‍♂️', '🤵🏽‍♂️', '🤵🏾‍♂️', '🤵🏿‍♂️'],
    unicode: '🤵‍♂️',
  },
  {
    id: 'man_kneeling',
    name: 'man_kneeling',
    names: ['man_kneeling'],
    skins: ['🧎🏻‍♂️', '🧎🏼‍♂️', '🧎🏽‍♂️', '🧎🏾‍♂️', '🧎🏿‍♂️'],
    unicode: '🧎‍♂️',
  },
  {
    id: 'man_kneeling_facing_right',
    name: 'man_kneeling_facing_right',
    names: ['man_kneeling_facing_right'],
    skins: ['🧎🏻‍♂️‍➡️', '🧎🏼‍♂️‍➡️', '🧎🏽‍♂️‍➡️', '🧎🏾‍♂️‍➡️', '🧎🏿‍♂️‍➡️'],
    unicode: '🧎‍♂️‍➡️',
  },
  {
    id: 'man_running_facing_right',
    name: 'man_running_facing_right',
    names: ['man_running_facing_right'],
    skins: ['🏃🏻‍♂️‍➡️', '🏃🏼‍♂️‍➡️', '🏃🏽‍♂️‍➡️', '🏃🏾‍♂️‍➡️', '🏃🏿‍♂️‍➡️'],
    unicode: '🏃‍♂️‍➡️',
  },
  {
    id: 'man_standing',
    name: 'man_standing',
    names: ['man_standing'],
    skins: ['🧍🏻‍♂️', '🧍🏼‍♂️', '🧍🏽‍♂️', '🧍🏾‍♂️', '🧍🏿‍♂️'],
    unicode: '🧍‍♂️',
  },
  {
    id: 'man_walking_facing_right',
    name: 'man_walking_facing_right',
    names: ['man_walking_facing_right'],
    skins: ['🚶🏻‍♂️‍➡️', '🚶🏼‍♂️‍➡️', '🚶🏽‍♂️‍➡️', '🚶🏾‍♂️‍➡️', '🚶🏿‍♂️‍➡️'],
    unicode: '🚶‍♂️‍➡️',
  },
  {
    id: 'man_with_beard',
    name: 'man_with_beard',
    names: ['man_with_beard'],
    skins: ['🧔🏻‍♂️', '🧔🏼‍♂️', '🧔🏽‍♂️', '🧔🏾‍♂️', '🧔🏿‍♂️'],
    unicode: '🧔‍♂️',
  },
  {
    id: 'man_with_gua_pi_mao',
    name: 'man_with_gua_pi_mao',
    names: ['man_with_gua_pi_mao'],
    skins: ['👲🏻', '👲🏼', '👲🏽', '👲🏾', '👲🏿'],
    unicode: '👲',
  },
  {
    id: 'man_with_probing_cane',
    name: 'man_with_probing_cane',
    names: ['man_with_probing_cane'],
    skins: ['👨🏻‍🦯', '👨🏼‍🦯', '👨🏽‍🦯', '👨🏾‍🦯', '👨🏿‍🦯'],
    unicode: '👨‍🦯',
  },
  {
    id: 'man_with_turban',
    name: 'man_with_turban',
    names: ['man_with_turban'],
    skins: ['👳🏻', '👳🏼', '👳🏽', '👳🏾', '👳🏿'],
    unicode: '👳',
  },
  {
    id: 'man_with_veil',
    name: 'man_with_veil',
    names: ['man_with_veil'],
    skins: ['👰🏻‍♂️', '👰🏼‍♂️', '👰🏽‍♂️', '👰🏾‍♂️', '👰🏿‍♂️'],
    unicode: '👰‍♂️',
  },
  {
    id: 'man_with_white_cane_facing_right',
    name: 'man_with_white_cane_facing_right',
    names: ['man_with_white_cane_facing_right'],
    skins: ['👨🏻‍🦯‍➡️', '👨🏼‍🦯‍➡️', '👨🏽‍🦯‍➡️', '👨🏾‍🦯‍➡️', '👨🏿‍🦯‍➡️'],
    unicode: '👨‍🦯‍➡️',
  },
  { id: 'mango', name: 'mango', names: ['mango'], unicode: '🥭' },
  { id: 'mans_shoe', name: 'mans_shoe', names: ['mans_shoe', 'shoe'], unicode: '👞' },
  {
    id: 'mantelpiece_clock',
    name: 'mantelpiece_clock',
    names: ['mantelpiece_clock'],
    unicode: '🕰️',
  },
  {
    id: 'manual_wheelchair',
    name: 'manual_wheelchair',
    names: ['manual_wheelchair'],
    unicode: '🦽',
  },
  { id: 'maple_leaf', name: 'maple_leaf', names: ['maple_leaf'], unicode: '🍁' },
  { id: 'maracas', name: 'maracas', names: ['maracas'], unicode: '🪇' },
  {
    id: 'martial_arts_uniform',
    name: 'martial_arts_uniform',
    names: ['martial_arts_uniform'],
    unicode: '🥋',
  },
  { id: 'mask', name: 'mask', names: ['mask'], unicode: '😷' },
  {
    id: 'massage',
    name: 'massage',
    names: ['massage'],
    skins: ['💆🏻', '💆🏼', '💆🏽', '💆🏾', '💆🏿'],
    unicode: '💆',
  },
  { id: 'mate_drink', name: 'mate_drink', names: ['mate_drink'], unicode: '🧉' },
  { id: 'meat_on_bone', name: 'meat_on_bone', names: ['meat_on_bone'], unicode: '🍖' },
  {
    id: 'mechanic',
    name: 'mechanic',
    names: ['mechanic'],
    skins: ['🧑🏻‍🔧', '🧑🏼‍🔧', '🧑🏽‍🔧', '🧑🏾‍🔧', '🧑🏿‍🔧'],
    unicode: '🧑‍🔧',
  },
  { id: 'mechanical_arm', name: 'mechanical_arm', names: ['mechanical_arm'], unicode: '🦾' },
  { id: 'mechanical_leg', name: 'mechanical_leg', names: ['mechanical_leg'], unicode: '🦿' },
  { id: 'medal', name: 'medal', names: ['medal'], unicode: '🎖️' },
  {
    id: 'medical_symbol',
    name: 'medical_symbol',
    names: ['medical_symbol', 'staff_of_aesculapius'],
    unicode: '⚕️',
  },
  { id: 'mega', name: 'mega', names: ['mega'], unicode: '📣' },
  { id: 'melon', name: 'melon', names: ['melon'], unicode: '🍈' },
  { id: 'melting_face', name: 'melting_face', names: ['melting_face'], unicode: '🫠' },
  { id: 'memo', name: 'memo', names: ['memo', 'pencil'], unicode: '📝' },
  {
    id: 'men-with-bunny-ears-partying',
    name: 'men-with-bunny-ears-partying',
    names: ['men-with-bunny-ears-partying', 'man-with-bunny-ears-partying'],
    unicode: '👯‍♂️',
  },
  { id: 'mending_heart', name: 'mending_heart', names: ['mending_heart'], unicode: '❤️‍🩹' },
  {
    id: 'menorah_with_nine_branches',
    name: 'menorah_with_nine_branches',
    names: ['menorah_with_nine_branches'],
    unicode: '🕎',
  },
  { id: 'mens', name: 'mens', names: ['mens'], unicode: '🚹' },
  {
    id: 'mermaid',
    name: 'mermaid',
    names: ['mermaid'],
    skins: ['🧜🏻‍♀️', '🧜🏼‍♀️', '🧜🏽‍♀️', '🧜🏾‍♀️', '🧜🏿‍♀️'],
    unicode: '🧜‍♀️',
  },
  {
    id: 'merman',
    name: 'merman',
    names: ['merman'],
    skins: ['🧜🏻‍♂️', '🧜🏼‍♂️', '🧜🏽‍♂️', '🧜🏾‍♂️', '🧜🏿‍♂️'],
    unicode: '🧜‍♂️',
  },
  {
    id: 'merperson',
    name: 'merperson',
    names: ['merperson'],
    skins: ['🧜🏻', '🧜🏼', '🧜🏽', '🧜🏾', '🧜🏿'],
    unicode: '🧜',
  },
  { id: 'metro', name: 'metro', names: ['metro'], unicode: '🚇' },
  { id: 'microbe', name: 'microbe', names: ['microbe'], unicode: '🦠' },
  { id: 'microphone', name: 'microphone', names: ['microphone'], unicode: '🎤' },
  { id: 'microscope', name: 'microscope', names: ['microscope'], unicode: '🔬' },
  {
    id: 'middle_finger',
    name: 'middle_finger',
    names: ['middle_finger', 'reversed_hand_with_middle_finger_extended'],
    skins: ['🖕🏻', '🖕🏼', '🖕🏽', '🖕🏾', '🖕🏿'],
    unicode: '🖕',
  },
  { id: 'military_helmet', name: 'military_helmet', names: ['military_helmet'], unicode: '🪖' },
  { id: 'milky_way', name: 'milky_way', names: ['milky_way'], unicode: '🌌' },
  { id: 'minibus', name: 'minibus', names: ['minibus'], unicode: '🚐' },
  { id: 'minidisc', name: 'minidisc', names: ['minidisc'], unicode: '💽' },
  { id: 'mirror', name: 'mirror', names: ['mirror'], unicode: '🪞' },
  { id: 'mirror_ball', name: 'mirror_ball', names: ['mirror_ball'], unicode: '🪩' },
  { id: 'mobile_phone_off', name: 'mobile_phone_off', names: ['mobile_phone_off'], unicode: '📴' },
  { id: 'money_mouth_face', name: 'money_mouth_face', names: ['money_mouth_face'], unicode: '🤑' },
  { id: 'money_with_wings', name: 'money_with_wings', names: ['money_with_wings'], unicode: '💸' },
  { id: 'moneybag', name: 'moneybag', names: ['moneybag'], unicode: '💰' },
  { id: 'monkey', name: 'monkey', names: ['monkey'], unicode: '🐒' },
  { id: 'monkey_face', name: 'monkey_face', names: ['monkey_face'], unicode: '🐵' },
  { id: 'monorail', name: 'monorail', names: ['monorail'], unicode: '🚝' },
  { id: 'moon', name: 'moon', names: ['moon', 'waxing_gibbous_moon'], unicode: '🌔' },
  { id: 'moon_cake', name: 'moon_cake', names: ['moon_cake'], unicode: '🥮' },
  { id: 'moose', name: 'moose', names: ['moose'], unicode: '🫎' },
  { id: 'mortar_board', name: 'mortar_board', names: ['mortar_board'], unicode: '🎓' },
  { id: 'mosque', name: 'mosque', names: ['mosque'], unicode: '🕌' },
  { id: 'mosquito', name: 'mosquito', names: ['mosquito'], unicode: '🦟' },
  {
    id: 'mostly_sunny',
    name: 'mostly_sunny',
    names: ['mostly_sunny', 'sun_small_cloud'],
    unicode: '🌤️',
  },
  { id: 'motor_boat', name: 'motor_boat', names: ['motor_boat'], unicode: '🛥️' },
  { id: 'motor_scooter', name: 'motor_scooter', names: ['motor_scooter'], unicode: '🛵' },
  {
    id: 'motorized_wheelchair',
    name: 'motorized_wheelchair',
    names: ['motorized_wheelchair'],
    unicode: '🦼',
  },
  { id: 'motorway', name: 'motorway', names: ['motorway'], unicode: '🛣️' },
  { id: 'mount_fuji', name: 'mount_fuji', names: ['mount_fuji'], unicode: '🗻' },
  { id: 'mountain', name: 'mountain', names: ['mountain'], unicode: '⛰️' },
  {
    id: 'mountain_bicyclist',
    name: 'mountain_bicyclist',
    names: ['mountain_bicyclist'],
    skins: ['🚵🏻', '🚵🏼', '🚵🏽', '🚵🏾', '🚵🏿'],
    unicode: '🚵',
  },
  {
    id: 'mountain_cableway',
    name: 'mountain_cableway',
    names: ['mountain_cableway'],
    unicode: '🚠',
  },
  { id: 'mountain_railway', name: 'mountain_railway', names: ['mountain_railway'], unicode: '🚞' },
  { id: 'mouse', name: 'mouse', names: ['mouse'], unicode: '🐭' },
  { id: 'mouse2', name: 'mouse2', names: ['mouse2'], unicode: '🐁' },
  { id: 'mouse_trap', name: 'mouse_trap', names: ['mouse_trap'], unicode: '🪤' },
  { id: 'movie_camera', name: 'movie_camera', names: ['movie_camera'], unicode: '🎥' },
  { id: 'moyai', name: 'moyai', names: ['moyai'], unicode: '🗿' },
  {
    id: 'mrs_claus',
    name: 'mrs_claus',
    names: ['mrs_claus', 'mother_christmas'],
    skins: ['🤶🏻', '🤶🏼', '🤶🏽', '🤶🏾', '🤶🏿'],
    unicode: '🤶',
  },
  {
    id: 'muscle',
    name: 'muscle',
    names: ['muscle'],
    skins: ['💪🏻', '💪🏼', '💪🏽', '💪🏾', '💪🏿'],
    unicode: '💪',
  },
  { id: 'mushroom', name: 'mushroom', names: ['mushroom'], unicode: '🍄' },
  { id: 'musical_keyboard', name: 'musical_keyboard', names: ['musical_keyboard'], unicode: '🎹' },
  { id: 'musical_note', name: 'musical_note', names: ['musical_note'], unicode: '🎵' },
  { id: 'musical_score', name: 'musical_score', names: ['musical_score'], unicode: '🎼' },
  { id: 'mute', name: 'mute', names: ['mute'], unicode: '🔇' },
  {
    id: 'mx_claus',
    name: 'mx_claus',
    names: ['mx_claus'],
    skins: ['🧑🏻‍🎄', '🧑🏼‍🎄', '🧑🏽‍🎄', '🧑🏾‍🎄', '🧑🏿‍🎄'],
    unicode: '🧑‍🎄',
  },
  {
    id: 'nail_care',
    name: 'nail_care',
    names: ['nail_care'],
    skins: ['💅🏻', '💅🏼', '💅🏽', '💅🏾', '💅🏿'],
    unicode: '💅',
  },
  { id: 'name_badge', name: 'name_badge', names: ['name_badge'], unicode: '📛' },
  { id: 'national_park', name: 'national_park', names: ['national_park'], unicode: '🏞️' },
  { id: 'nauseated_face', name: 'nauseated_face', names: ['nauseated_face'], unicode: '🤢' },
  { id: 'nazar_amulet', name: 'nazar_amulet', names: ['nazar_amulet'], unicode: '🧿' },
  { id: 'necktie', name: 'necktie', names: ['necktie'], unicode: '👔' },
  {
    id: 'negative_squared_cross_mark',
    name: 'negative_squared_cross_mark',
    names: ['negative_squared_cross_mark'],
    unicode: '❎',
  },
  { id: 'nerd_face', name: 'nerd_face', names: ['nerd_face'], unicode: '🤓' },
  { id: 'nest_with_eggs', name: 'nest_with_eggs', names: ['nest_with_eggs'], unicode: '🪺' },
  { id: 'nesting_dolls', name: 'nesting_dolls', names: ['nesting_dolls'], unicode: '🪆' },
  { id: 'neutral_face', name: 'neutral_face', names: ['neutral_face'], unicode: '😐' },
  { id: 'new', name: 'new', names: ['new'], unicode: '🆕' },
  { id: 'new_moon', name: 'new_moon', names: ['new_moon'], unicode: '🌑' },
  {
    id: 'new_moon_with_face',
    name: 'new_moon_with_face',
    names: ['new_moon_with_face'],
    unicode: '🌚',
  },
  { id: 'newspaper', name: 'newspaper', names: ['newspaper'], unicode: '📰' },
  { id: 'ng', name: 'ng', names: ['ng'], unicode: '🆖' },
  { id: 'night_with_stars', name: 'night_with_stars', names: ['night_with_stars'], unicode: '🌃' },
  { id: 'nine', name: 'nine', names: ['nine'], unicode: '9️⃣' },
  {
    id: 'ninja',
    name: 'ninja',
    names: ['ninja'],
    skins: ['🥷🏻', '🥷🏼', '🥷🏽', '🥷🏾', '🥷🏿'],
    unicode: '🥷',
  },
  { id: 'no_bell', name: 'no_bell', names: ['no_bell'], unicode: '🔕' },
  { id: 'no_bicycles', name: 'no_bicycles', names: ['no_bicycles'], unicode: '🚳' },
  { id: 'no_entry', name: 'no_entry', names: ['no_entry'], unicode: '⛔' },
  { id: 'no_entry_sign', name: 'no_entry_sign', names: ['no_entry_sign'], unicode: '🚫' },
  {
    id: 'no_good',
    name: 'no_good',
    names: ['no_good'],
    skins: ['🙅🏻', '🙅🏼', '🙅🏽', '🙅🏾', '🙅🏿'],
    unicode: '🙅',
  },
  { id: 'no_mobile_phones', name: 'no_mobile_phones', names: ['no_mobile_phones'], unicode: '📵' },
  { id: 'no_mouth', name: 'no_mouth', names: ['no_mouth'], unicode: '😶' },
  { id: 'no_pedestrians', name: 'no_pedestrians', names: ['no_pedestrians'], unicode: '🚷' },
  { id: 'no_smoking', name: 'no_smoking', names: ['no_smoking'], unicode: '🚭' },
  {
    id: 'non-potable_water',
    name: 'non-potable_water',
    names: ['non-potable_water'],
    unicode: '🚱',
  },
  {
    id: 'nose',
    name: 'nose',
    names: ['nose'],
    skins: ['👃🏻', '👃🏼', '👃🏽', '👃🏾', '👃🏿'],
    unicode: '👃',
  },
  { id: 'notebook', name: 'notebook', names: ['notebook'], unicode: '📓' },
  {
    id: 'notebook_with_decorative_cover',
    name: 'notebook_with_decorative_cover',
    names: ['notebook_with_decorative_cover'],
    unicode: '📔',
  },
  { id: 'notes', name: 'notes', names: ['notes'], unicode: '🎶' },
  { id: 'nut_and_bolt', name: 'nut_and_bolt', names: ['nut_and_bolt'], unicode: '🔩' },
  { id: 'o', name: 'o', names: ['o'], unicode: '⭕' },
  { id: 'o2', name: 'o2', names: ['o2'], unicode: '🅾️' },
  { id: 'ocean', name: 'ocean', names: ['ocean'], unicode: '🌊' },
  { id: 'octagonal_sign', name: 'octagonal_sign', names: ['octagonal_sign'], unicode: '🛑' },
  { id: 'octopus', name: 'octopus', names: ['octopus'], unicode: '🐙' },
  { id: 'oden', name: 'oden', names: ['oden'], unicode: '🍢' },
  { id: 'office', name: 'office', names: ['office'], unicode: '🏢' },
  {
    id: 'office_worker',
    name: 'office_worker',
    names: ['office_worker'],
    skins: ['🧑🏻‍💼', '🧑🏼‍💼', '🧑🏽‍💼', '🧑🏾‍💼', '🧑🏿‍💼'],
    unicode: '🧑‍💼',
  },
  { id: 'oil_drum', name: 'oil_drum', names: ['oil_drum'], unicode: '🛢️' },
  { id: 'ok', name: 'ok', names: ['ok'], unicode: '🆗' },
  {
    id: 'ok_hand',
    name: 'ok_hand',
    names: ['ok_hand'],
    skins: ['👌🏻', '👌🏼', '👌🏽', '👌🏾', '👌🏿'],
    unicode: '👌',
  },
  {
    id: 'ok_woman',
    name: 'ok_woman',
    names: ['ok_woman'],
    skins: ['🙆🏻', '🙆🏼', '🙆🏽', '🙆🏾', '🙆🏿'],
    unicode: '🙆',
  },
  { id: 'old_key', name: 'old_key', names: ['old_key'], unicode: '🗝️' },
  {
    id: 'older_adult',
    name: 'older_adult',
    names: ['older_adult'],
    skins: ['🧓🏻', '🧓🏼', '🧓🏽', '🧓🏾', '🧓🏿'],
    unicode: '🧓',
  },
  {
    id: 'older_man',
    name: 'older_man',
    names: ['older_man'],
    skins: ['👴🏻', '👴🏼', '👴🏽', '👴🏾', '👴🏿'],
    unicode: '👴',
  },
  {
    id: 'older_woman',
    name: 'older_woman',
    names: ['older_woman'],
    skins: ['👵🏻', '👵🏼', '👵🏽', '👵🏾', '👵🏿'],
    unicode: '👵',
  },
  { id: 'olive', name: 'olive', names: ['olive'], unicode: '🫒' },
  { id: 'om_symbol', name: 'om_symbol', names: ['om_symbol'], unicode: '🕉️' },
  { id: 'on', name: 'on', names: ['on'], unicode: '🔛' },
  {
    id: 'oncoming_automobile',
    name: 'oncoming_automobile',
    names: ['oncoming_automobile'],
    unicode: '🚘',
  },
  { id: 'oncoming_bus', name: 'oncoming_bus', names: ['oncoming_bus'], unicode: '🚍' },
  {
    id: 'oncoming_police_car',
    name: 'oncoming_police_car',
    names: ['oncoming_police_car'],
    unicode: '🚔',
  },
  { id: 'oncoming_taxi', name: 'oncoming_taxi', names: ['oncoming_taxi'], unicode: '🚖' },
  { id: 'one', name: 'one', names: ['one'], unicode: '1️⃣' },
  {
    id: 'one-piece_swimsuit',
    name: 'one-piece_swimsuit',
    names: ['one-piece_swimsuit'],
    unicode: '🩱',
  },
  { id: 'onion', name: 'onion', names: ['onion'], unicode: '🧅' },
  { id: 'open_file_folder', name: 'open_file_folder', names: ['open_file_folder'], unicode: '📂' },
  {
    id: 'open_hands',
    name: 'open_hands',
    names: ['open_hands'],
    skins: ['👐🏻', '👐🏼', '👐🏽', '👐🏾', '👐🏿'],
    unicode: '👐',
  },
  { id: 'open_mouth', name: 'open_mouth', names: ['open_mouth'], unicode: '😮' },
  { id: 'ophiuchus', name: 'ophiuchus', names: ['ophiuchus'], unicode: '⛎' },
  { id: 'orange_book', name: 'orange_book', names: ['orange_book'], unicode: '📙' },
  { id: 'orange_heart', name: 'orange_heart', names: ['orange_heart'], unicode: '🧡' },
  { id: 'orangutan', name: 'orangutan', names: ['orangutan'], unicode: '🦧' },
  { id: 'orthodox_cross', name: 'orthodox_cross', names: ['orthodox_cross'], unicode: '☦️' },
  { id: 'otter', name: 'otter', names: ['otter'], unicode: '🦦' },
  { id: 'outbox_tray', name: 'outbox_tray', names: ['outbox_tray'], unicode: '📤' },
  { id: 'owl', name: 'owl', names: ['owl'], unicode: '🦉' },
  { id: 'ox', name: 'ox', names: ['ox'], unicode: '🐂' },
  { id: 'oyster', name: 'oyster', names: ['oyster'], unicode: '🦪' },
  { id: 'package', name: 'package', names: ['package'], unicode: '📦' },
  { id: 'page_facing_up', name: 'page_facing_up', names: ['page_facing_up'], unicode: '📄' },
  { id: 'page_with_curl', name: 'page_with_curl', names: ['page_with_curl'], unicode: '📃' },
  { id: 'pager', name: 'pager', names: ['pager'], unicode: '📟' },
  {
    id: 'palm_down_hand',
    name: 'palm_down_hand',
    names: ['palm_down_hand'],
    skins: ['🫳🏻', '🫳🏼', '🫳🏽', '🫳🏾', '🫳🏿'],
    unicode: '🫳',
  },
  { id: 'palm_tree', name: 'palm_tree', names: ['palm_tree'], unicode: '🌴' },
  {
    id: 'palm_up_hand',
    name: 'palm_up_hand',
    names: ['palm_up_hand'],
    skins: ['🫴🏻', '🫴🏼', '🫴🏽', '🫴🏾', '🫴🏿'],
    unicode: '🫴',
  },
  {
    id: 'palms_up_together',
    name: 'palms_up_together',
    names: ['palms_up_together'],
    skins: ['🤲🏻', '🤲🏼', '🤲🏽', '🤲🏾', '🤲🏿'],
    unicode: '🤲',
  },
  { id: 'pancakes', name: 'pancakes', names: ['pancakes'], unicode: '🥞' },
  { id: 'panda_face', name: 'panda_face', names: ['panda_face'], unicode: '🐼' },
  { id: 'paperclip', name: 'paperclip', names: ['paperclip'], unicode: '📎' },
  { id: 'parachute', name: 'parachute', names: ['parachute'], unicode: '🪂' },
  { id: 'parking', name: 'parking', names: ['parking'], unicode: '🅿️' },
  { id: 'parrot', name: 'parrot', names: ['parrot'], unicode: '🦜' },
  {
    id: 'part_alternation_mark',
    name: 'part_alternation_mark',
    names: ['part_alternation_mark'],
    unicode: '〽️',
  },
  { id: 'partly_sunny', name: 'partly_sunny', names: ['partly_sunny'], unicode: '⛅' },
  {
    id: 'partly_sunny_rain',
    name: 'partly_sunny_rain',
    names: ['partly_sunny_rain', 'sun_behind_rain_cloud'],
    unicode: '🌦️',
  },
  { id: 'partying_face', name: 'partying_face', names: ['partying_face'], unicode: '🥳' },
  { id: 'passenger_ship', name: 'passenger_ship', names: ['passenger_ship'], unicode: '🛳️' },
  { id: 'passport_control', name: 'passport_control', names: ['passport_control'], unicode: '🛂' },
  { id: 'pea_pod', name: 'pea_pod', names: ['pea_pod'], unicode: '🫛' },
  { id: 'peace_symbol', name: 'peace_symbol', names: ['peace_symbol'], unicode: '☮️' },
  { id: 'peach', name: 'peach', names: ['peach'], unicode: '🍑' },
  { id: 'peacock', name: 'peacock', names: ['peacock'], unicode: '🦚' },
  { id: 'peanuts', name: 'peanuts', names: ['peanuts'], unicode: '🥜' },
  { id: 'pear', name: 'pear', names: ['pear'], unicode: '🍐' },
  { id: 'pencil2', name: 'pencil2', names: ['pencil2'], unicode: '✏️' },
  { id: 'penguin', name: 'penguin', names: ['penguin'], unicode: '🐧' },
  { id: 'pensive', name: 'pensive', names: ['pensive'], unicode: '😔' },
  {
    id: 'people_holding_hands',
    name: 'people_holding_hands',
    names: ['people_holding_hands'],
    skins: [
      '🧑🏻‍🤝‍🧑🏻',
      '🧑🏻‍🤝‍🧑🏼',
      '🧑🏻‍🤝‍🧑🏽',
      '🧑🏻‍🤝‍🧑🏾',
      '🧑🏻‍🤝‍🧑🏿',
      '🧑🏼‍🤝‍🧑🏻',
      '🧑🏼‍🤝‍🧑🏼',
      '🧑🏼‍🤝‍🧑🏽',
      '🧑🏼‍🤝‍🧑🏾',
      '🧑🏼‍🤝‍🧑🏿',
      '🧑🏽‍🤝‍🧑🏻',
      '🧑🏽‍🤝‍🧑🏼',
      '🧑🏽‍🤝‍🧑🏽',
      '🧑🏽‍🤝‍🧑🏾',
      '🧑🏽‍🤝‍🧑🏿',
      '🧑🏾‍🤝‍🧑🏻',
      '🧑🏾‍🤝‍🧑🏼',
      '🧑🏾‍🤝‍🧑🏽',
      '🧑🏾‍🤝‍🧑🏾',
      '🧑🏾‍🤝‍🧑🏿',
      '🧑🏿‍🤝‍🧑🏻',
      '🧑🏿‍🤝‍🧑🏼',
      '🧑🏿‍🤝‍🧑🏽',
      '🧑🏿‍🤝‍🧑🏾',
      '🧑🏿‍🤝‍🧑🏿',
    ],
    unicode: '🧑‍🤝‍🧑',
  },
  { id: 'people_hugging', name: 'people_hugging', names: ['people_hugging'], unicode: '🫂' },
  { id: 'performing_arts', name: 'performing_arts', names: ['performing_arts'], unicode: '🎭' },
  { id: 'persevere', name: 'persevere', names: ['persevere'], unicode: '😣' },
  {
    id: 'person_climbing',
    name: 'person_climbing',
    names: ['person_climbing'],
    skins: ['🧗🏻', '🧗🏼', '🧗🏽', '🧗🏾', '🧗🏿'],
    unicode: '🧗',
  },
  {
    id: 'person_doing_cartwheel',
    name: 'person_doing_cartwheel',
    names: ['person_doing_cartwheel'],
    skins: ['🤸🏻', '🤸🏼', '🤸🏽', '🤸🏾', '🤸🏿'],
    unicode: '🤸',
  },
  {
    id: 'person_feeding_baby',
    name: 'person_feeding_baby',
    names: ['person_feeding_baby'],
    skins: ['🧑🏻‍🍼', '🧑🏼‍🍼', '🧑🏽‍🍼', '🧑🏾‍🍼', '🧑🏿‍🍼'],
    unicode: '🧑‍🍼',
  },
  {
    id: 'person_frowning',
    name: 'person_frowning',
    names: ['person_frowning'],
    skins: ['🙍🏻', '🙍🏼', '🙍🏽', '🙍🏾', '🙍🏿'],
    unicode: '🙍',
  },
  {
    id: 'person_in_lotus_position',
    name: 'person_in_lotus_position',
    names: ['person_in_lotus_position'],
    skins: ['🧘🏻', '🧘🏼', '🧘🏽', '🧘🏾', '🧘🏿'],
    unicode: '🧘',
  },
  {
    id: 'person_in_manual_wheelchair',
    name: 'person_in_manual_wheelchair',
    names: ['person_in_manual_wheelchair'],
    skins: ['🧑🏻‍🦽', '🧑🏼‍🦽', '🧑🏽‍🦽', '🧑🏾‍🦽', '🧑🏿‍🦽'],
    unicode: '🧑‍🦽',
  },
  {
    id: 'person_in_manual_wheelchair_facing_right',
    name: 'person_in_manual_wheelchair_facing_right',
    names: ['person_in_manual_wheelchair_facing_right'],
    skins: ['🧑🏻‍🦽‍➡️', '🧑🏼‍🦽‍➡️', '🧑🏽‍🦽‍➡️', '🧑🏾‍🦽‍➡️', '🧑🏿‍🦽‍➡️'],
    unicode: '🧑‍🦽‍➡️',
  },
  {
    id: 'person_in_motorized_wheelchair',
    name: 'person_in_motorized_wheelchair',
    names: ['person_in_motorized_wheelchair'],
    skins: ['🧑🏻‍🦼', '🧑🏼‍🦼', '🧑🏽‍🦼', '🧑🏾‍🦼', '🧑🏿‍🦼'],
    unicode: '🧑‍🦼',
  },
  {
    id: 'person_in_motorized_wheelchair_facing_right',
    name: 'person_in_motorized_wheelchair_facing_right',
    names: ['person_in_motorized_wheelchair_facing_right'],
    skins: ['🧑🏻‍🦼‍➡️', '🧑🏼‍🦼‍➡️', '🧑🏽‍🦼‍➡️', '🧑🏾‍🦼‍➡️', '🧑🏿‍🦼‍➡️'],
    unicode: '🧑‍🦼‍➡️',
  },
  {
    id: 'person_in_steamy_room',
    name: 'person_in_steamy_room',
    names: ['person_in_steamy_room'],
    skins: ['🧖🏻', '🧖🏼', '🧖🏽', '🧖🏾', '🧖🏿'],
    unicode: '🧖',
  },
  {
    id: 'person_in_tuxedo',
    name: 'person_in_tuxedo',
    names: ['person_in_tuxedo'],
    skins: ['🤵🏻', '🤵🏼', '🤵🏽', '🤵🏾', '🤵🏿'],
    unicode: '🤵',
  },
  {
    id: 'person_kneeling_facing_right',
    name: 'person_kneeling_facing_right',
    names: ['person_kneeling_facing_right'],
    skins: ['🧎🏻‍➡️', '🧎🏼‍➡️', '🧎🏽‍➡️', '🧎🏾‍➡️', '🧎🏿‍➡️'],
    unicode: '🧎‍➡️',
  },
  {
    id: 'person_running_facing_right',
    name: 'person_running_facing_right',
    names: ['person_running_facing_right'],
    skins: ['🏃🏻‍➡️', '🏃🏼‍➡️', '🏃🏽‍➡️', '🏃🏾‍➡️', '🏃🏿‍➡️'],
    unicode: '🏃‍➡️',
  },
  {
    id: 'person_walking_facing_right',
    name: 'person_walking_facing_right',
    names: ['person_walking_facing_right'],
    skins: ['🚶🏻‍➡️', '🚶🏼‍➡️', '🚶🏽‍➡️', '🚶🏾‍➡️', '🚶🏿‍➡️'],
    unicode: '🚶‍➡️',
  },
  {
    id: 'person_with_ball',
    name: 'person_with_ball',
    names: ['person_with_ball'],
    skins: ['⛹🏻', '⛹🏼', '⛹🏽', '⛹🏾', '⛹🏿'],
    unicode: '⛹️',
  },
  {
    id: 'person_with_blond_hair',
    name: 'person_with_blond_hair',
    names: ['person_with_blond_hair'],
    skins: ['👱🏻', '👱🏼', '👱🏽', '👱🏾', '👱🏿'],
    unicode: '👱',
  },
  {
    id: 'person_with_crown',
    name: 'person_with_crown',
    names: ['person_with_crown'],
    skins: ['🫅🏻', '🫅🏼', '🫅🏽', '🫅🏾', '🫅🏿'],
    unicode: '🫅',
  },
  {
    id: 'person_with_headscarf',
    name: 'person_with_headscarf',
    names: ['person_with_headscarf'],
    skins: ['🧕🏻', '🧕🏼', '🧕🏽', '🧕🏾', '🧕🏿'],
    unicode: '🧕',
  },
  {
    id: 'person_with_pouting_face',
    name: 'person_with_pouting_face',
    names: ['person_with_pouting_face'],
    skins: ['🙎🏻', '🙎🏼', '🙎🏽', '🙎🏾', '🙎🏿'],
    unicode: '🙎',
  },
  {
    id: 'person_with_probing_cane',
    name: 'person_with_probing_cane',
    names: ['person_with_probing_cane'],
    skins: ['🧑🏻‍🦯', '🧑🏼‍🦯', '🧑🏽‍🦯', '🧑🏾‍🦯', '🧑🏿‍🦯'],
    unicode: '🧑‍🦯',
  },
  {
    id: 'person_with_white_cane_facing_right',
    name: 'person_with_white_cane_facing_right',
    names: ['person_with_white_cane_facing_right'],
    skins: ['🧑🏻‍🦯‍➡️', '🧑🏼‍🦯‍➡️', '🧑🏽‍🦯‍➡️', '🧑🏾‍🦯‍➡️', '🧑🏿‍🦯‍➡️'],
    unicode: '🧑‍🦯‍➡️',
  },
  { id: 'petri_dish', name: 'petri_dish', names: ['petri_dish'], unicode: '🧫' },
  { id: 'phoenix', name: 'phoenix', names: ['phoenix'], unicode: '🐦‍🔥' },
  { id: 'phone', name: 'phone', names: ['phone', 'telephone'], unicode: '☎️' },
  { id: 'pick', name: 'pick', names: ['pick'], unicode: '⛏️' },
  { id: 'pickup_truck', name: 'pickup_truck', names: ['pickup_truck'], unicode: '🛻' },
  { id: 'pie', name: 'pie', names: ['pie'], unicode: '🥧' },
  { id: 'pig', name: 'pig', names: ['pig'], unicode: '🐷' },
  { id: 'pig2', name: 'pig2', names: ['pig2'], unicode: '🐖' },
  { id: 'pig_nose', name: 'pig_nose', names: ['pig_nose'], unicode: '🐽' },
  { id: 'pill', name: 'pill', names: ['pill'], unicode: '💊' },
  {
    id: 'pilot',
    name: 'pilot',
    names: ['pilot'],
    skins: ['🧑🏻‍✈️', '🧑🏼‍✈️', '🧑🏽‍✈️', '🧑🏾‍✈️', '🧑🏿‍✈️'],
    unicode: '🧑‍✈️',
  },
  { id: 'pinata', name: 'pinata', names: ['pinata'], unicode: '🪅' },
  {
    id: 'pinched_fingers',
    name: 'pinched_fingers',
    names: ['pinched_fingers'],
    skins: ['🤌🏻', '🤌🏼', '🤌🏽', '🤌🏾', '🤌🏿'],
    unicode: '🤌',
  },
  {
    id: 'pinching_hand',
    name: 'pinching_hand',
    names: ['pinching_hand'],
    skins: ['🤏🏻', '🤏🏼', '🤏🏽', '🤏🏾', '🤏🏿'],
    unicode: '🤏',
  },
  { id: 'pineapple', name: 'pineapple', names: ['pineapple'], unicode: '🍍' },
  { id: 'pink_heart', name: 'pink_heart', names: ['pink_heart'], unicode: '🩷' },
  { id: 'pirate_flag', name: 'pirate_flag', names: ['pirate_flag'], unicode: '🏴‍☠️' },
  { id: 'pisces', name: 'pisces', names: ['pisces'], unicode: '♓' },
  { id: 'pizza', name: 'pizza', names: ['pizza'], unicode: '🍕' },
  { id: 'placard', name: 'placard', names: ['placard'], unicode: '🪧' },
  { id: 'place_of_worship', name: 'place_of_worship', names: ['place_of_worship'], unicode: '🛐' },
  { id: 'playground_slide', name: 'playground_slide', names: ['playground_slide'], unicode: '🛝' },
  { id: 'pleading_face', name: 'pleading_face', names: ['pleading_face'], unicode: '🥺' },
  { id: 'plunger', name: 'plunger', names: ['plunger'], unicode: '🪠' },
  {
    id: 'point_down',
    name: 'point_down',
    names: ['point_down'],
    skins: ['👇🏻', '👇🏼', '👇🏽', '👇🏾', '👇🏿'],
    unicode: '👇',
  },
  {
    id: 'point_left',
    name: 'point_left',
    names: ['point_left'],
    skins: ['👈🏻', '👈🏼', '👈🏽', '👈🏾', '👈🏿'],
    unicode: '👈',
  },
  {
    id: 'point_right',
    name: 'point_right',
    names: ['point_right'],
    skins: ['👉🏻', '👉🏼', '👉🏽', '👉🏾', '👉🏿'],
    unicode: '👉',
  },
  {
    id: 'point_up',
    name: 'point_up',
    names: ['point_up'],
    skins: ['☝🏻', '☝🏼', '☝🏽', '☝🏾', '☝🏿'],
    unicode: '☝️',
  },
  {
    id: 'point_up_2',
    name: 'point_up_2',
    names: ['point_up_2'],
    skins: ['👆🏻', '👆🏼', '👆🏽', '👆🏾', '👆🏿'],
    unicode: '👆',
  },
  { id: 'polar_bear', name: 'polar_bear', names: ['polar_bear'], unicode: '🐻‍❄️' },
  { id: 'police_car', name: 'police_car', names: ['police_car'], unicode: '🚓' },
  { id: 'poodle', name: 'poodle', names: ['poodle'], unicode: '🐩' },
  { id: 'popcorn', name: 'popcorn', names: ['popcorn'], unicode: '🍿' },
  { id: 'post_office', name: 'post_office', names: ['post_office'], unicode: '🏣' },
  { id: 'postal_horn', name: 'postal_horn', names: ['postal_horn'], unicode: '📯' },
  { id: 'postbox', name: 'postbox', names: ['postbox'], unicode: '📮' },
  { id: 'potable_water', name: 'potable_water', names: ['potable_water'], unicode: '🚰' },
  { id: 'potato', name: 'potato', names: ['potato'], unicode: '🥔' },
  { id: 'potted_plant', name: 'potted_plant', names: ['potted_plant'], unicode: '🪴' },
  { id: 'pouch', name: 'pouch', names: ['pouch'], unicode: '👝' },
  { id: 'poultry_leg', name: 'poultry_leg', names: ['poultry_leg'], unicode: '🍗' },
  { id: 'pound', name: 'pound', names: ['pound'], unicode: '💷' },
  { id: 'pouring_liquid', name: 'pouring_liquid', names: ['pouring_liquid'], unicode: '🫗' },
  { id: 'pouting_cat', name: 'pouting_cat', names: ['pouting_cat'], unicode: '😾' },
  {
    id: 'pray',
    name: 'pray',
    names: ['pray'],
    skins: ['🙏🏻', '🙏🏼', '🙏🏽', '🙏🏾', '🙏🏿'],
    unicode: '🙏',
  },
  { id: 'prayer_beads', name: 'prayer_beads', names: ['prayer_beads'], unicode: '📿' },
  {
    id: 'pregnant_man',
    name: 'pregnant_man',
    names: ['pregnant_man'],
    skins: ['🫃🏻', '🫃🏼', '🫃🏽', '🫃🏾', '🫃🏿'],
    unicode: '🫃',
  },
  {
    id: 'pregnant_person',
    name: 'pregnant_person',
    names: ['pregnant_person'],
    skins: ['🫄🏻', '🫄🏼', '🫄🏽', '🫄🏾', '🫄🏿'],
    unicode: '🫄',
  },
  {
    id: 'pregnant_woman',
    name: 'pregnant_woman',
    names: ['pregnant_woman'],
    skins: ['🤰🏻', '🤰🏼', '🤰🏽', '🤰🏾', '🤰🏿'],
    unicode: '🤰',
  },
  { id: 'pretzel', name: 'pretzel', names: ['pretzel'], unicode: '🥨' },
  {
    id: 'prince',
    name: 'prince',
    names: ['prince'],
    skins: ['🤴🏻', '🤴🏼', '🤴🏽', '🤴🏾', '🤴🏿'],
    unicode: '🤴',
  },
  {
    id: 'princess',
    name: 'princess',
    names: ['princess'],
    skins: ['👸🏻', '👸🏼', '👸🏽', '👸🏾', '👸🏿'],
    unicode: '👸',
  },
  { id: 'printer', name: 'printer', names: ['printer'], unicode: '🖨️' },
  { id: 'probing_cane', name: 'probing_cane', names: ['probing_cane'], unicode: '🦯' },
  { id: 'purple_heart', name: 'purple_heart', names: ['purple_heart'], unicode: '💜' },
  { id: 'purse', name: 'purse', names: ['purse'], unicode: '👛' },
  { id: 'pushpin', name: 'pushpin', names: ['pushpin'], unicode: '📌' },
  {
    id: 'put_litter_in_its_place',
    name: 'put_litter_in_its_place',
    names: ['put_litter_in_its_place'],
    unicode: '🚮',
  },
  { id: 'question', name: 'question', names: ['question'], unicode: '❓' },
  { id: 'rabbit', name: 'rabbit', names: ['rabbit'], unicode: '🐰' },
  { id: 'rabbit2', name: 'rabbit2', names: ['rabbit2'], unicode: '🐇' },
  { id: 'raccoon', name: 'raccoon', names: ['raccoon'], unicode: '🦝' },
  { id: 'racehorse', name: 'racehorse', names: ['racehorse'], unicode: '🐎' },
  { id: 'racing_car', name: 'racing_car', names: ['racing_car'], unicode: '🏎️' },
  {
    id: 'racing_motorcycle',
    name: 'racing_motorcycle',
    names: ['racing_motorcycle'],
    unicode: '🏍️',
  },
  { id: 'radio', name: 'radio', names: ['radio'], unicode: '📻' },
  { id: 'radio_button', name: 'radio_button', names: ['radio_button'], unicode: '🔘' },
  { id: 'radioactive_sign', name: 'radioactive_sign', names: ['radioactive_sign'], unicode: '☢️' },
  { id: 'rage', name: 'rage', names: ['rage'], unicode: '😡' },
  { id: 'railway_car', name: 'railway_car', names: ['railway_car'], unicode: '🚃' },
  { id: 'railway_track', name: 'railway_track', names: ['railway_track'], unicode: '🛤️' },
  { id: 'rain_cloud', name: 'rain_cloud', names: ['rain_cloud'], unicode: '🌧️' },
  { id: 'rainbow', name: 'rainbow', names: ['rainbow'], unicode: '🌈' },
  { id: 'rainbow-flag', name: 'rainbow-flag', names: ['rainbow-flag'], unicode: '🏳️‍🌈' },
  {
    id: 'raised_back_of_hand',
    name: 'raised_back_of_hand',
    names: ['raised_back_of_hand'],
    skins: ['🤚🏻', '🤚🏼', '🤚🏽', '🤚🏾', '🤚🏿'],
    unicode: '🤚',
  },
  {
    id: 'raised_hand_with_fingers_splayed',
    name: 'raised_hand_with_fingers_splayed',
    names: ['raised_hand_with_fingers_splayed'],
    skins: ['🖐🏻', '🖐🏼', '🖐🏽', '🖐🏾', '🖐🏿'],
    unicode: '🖐️',
  },
  {
    id: 'raised_hands',
    name: 'raised_hands',
    names: ['raised_hands'],
    skins: ['🙌🏻', '🙌🏼', '🙌🏽', '🙌🏾', '🙌🏿'],
    unicode: '🙌',
  },
  {
    id: 'raising_hand',
    name: 'raising_hand',
    names: ['raising_hand'],
    skins: ['🙋🏻', '🙋🏼', '🙋🏽', '🙋🏾', '🙋🏿'],
    unicode: '🙋',
  },
  { id: 'ram', name: 'ram', names: ['ram'], unicode: '🐏' },
  { id: 'ramen', name: 'ramen', names: ['ramen'], unicode: '🍜' },
  { id: 'rat', name: 'rat', names: ['rat'], unicode: '🐀' },
  { id: 'razor', name: 'razor', names: ['razor'], unicode: '🪒' },
  { id: 'receipt', name: 'receipt', names: ['receipt'], unicode: '🧾' },
  { id: 'recycle', name: 'recycle', names: ['recycle'], unicode: '♻️' },
  { id: 'red_circle', name: 'red_circle', names: ['red_circle'], unicode: '🔴' },
  { id: 'red_envelope', name: 'red_envelope', names: ['red_envelope'], unicode: '🧧' },
  {
    id: 'red_haired_man',
    name: 'red_haired_man',
    names: ['red_haired_man'],
    skins: ['👨🏻‍🦰', '👨🏼‍🦰', '👨🏽‍🦰', '👨🏾‍🦰', '👨🏿‍🦰'],
    unicode: '👨‍🦰',
  },
  {
    id: 'red_haired_person',
    name: 'red_haired_person',
    names: ['red_haired_person'],
    skins: ['🧑🏻‍🦰', '🧑🏼‍🦰', '🧑🏽‍🦰', '🧑🏾‍🦰', '🧑🏿‍🦰'],
    unicode: '🧑‍🦰',
  },
  {
    id: 'red_haired_woman',
    name: 'red_haired_woman',
    names: ['red_haired_woman'],
    skins: ['👩🏻‍🦰', '👩🏼‍🦰', '👩🏽‍🦰', '👩🏾‍🦰', '👩🏿‍🦰'],
    unicode: '👩‍🦰',
  },
  { id: 'registered', name: 'registered', names: ['registered'], unicode: '®️' },
  { id: 'relaxed', name: 'relaxed', names: ['relaxed'], unicode: '☺️' },
  { id: 'relieved', name: 'relieved', names: ['relieved'], unicode: '😌' },
  { id: 'reminder_ribbon', name: 'reminder_ribbon', names: ['reminder_ribbon'], unicode: '🎗️' },
  { id: 'repeat', name: 'repeat', names: ['repeat'], unicode: '🔁' },
  { id: 'repeat_one', name: 'repeat_one', names: ['repeat_one'], unicode: '🔂' },
  { id: 'restroom', name: 'restroom', names: ['restroom'], unicode: '🚻' },
  { id: 'revolving_hearts', name: 'revolving_hearts', names: ['revolving_hearts'], unicode: '💞' },
  { id: 'rewind', name: 'rewind', names: ['rewind'], unicode: '⏪' },
  { id: 'rhinoceros', name: 'rhinoceros', names: ['rhinoceros'], unicode: '🦏' },
  { id: 'ribbon', name: 'ribbon', names: ['ribbon'], unicode: '🎀' },
  { id: 'rice', name: 'rice', names: ['rice'], unicode: '🍚' },
  { id: 'rice_ball', name: 'rice_ball', names: ['rice_ball'], unicode: '🍙' },
  { id: 'rice_cracker', name: 'rice_cracker', names: ['rice_cracker'], unicode: '🍘' },
  { id: 'rice_scene', name: 'rice_scene', names: ['rice_scene'], unicode: '🎑' },
  {
    id: 'right-facing_fist',
    name: 'right-facing_fist',
    names: ['right-facing_fist'],
    skins: ['🤜🏻', '🤜🏼', '🤜🏽', '🤜🏾', '🤜🏿'],
    unicode: '🤜',
  },
  {
    id: 'right_anger_bubble',
    name: 'right_anger_bubble',
    names: ['right_anger_bubble'],
    unicode: '🗯️',
  },
  {
    id: 'rightwards_hand',
    name: 'rightwards_hand',
    names: ['rightwards_hand'],
    skins: ['🫱🏻', '🫱🏼', '🫱🏽', '🫱🏾', '🫱🏿'],
    unicode: '🫱',
  },
  {
    id: 'rightwards_pushing_hand',
    name: 'rightwards_pushing_hand',
    names: ['rightwards_pushing_hand'],
    skins: ['🫸🏻', '🫸🏼', '🫸🏽', '🫸🏾', '🫸🏿'],
    unicode: '🫸',
  },
  { id: 'ring', name: 'ring', names: ['ring'], unicode: '💍' },
  { id: 'ring_buoy', name: 'ring_buoy', names: ['ring_buoy'], unicode: '🛟' },
  { id: 'ringed_planet', name: 'ringed_planet', names: ['ringed_planet'], unicode: '🪐' },
  { id: 'robot_face', name: 'robot_face', names: ['robot_face'], unicode: '🤖' },
  { id: 'rock', name: 'rock', names: ['rock'], unicode: '🪨' },
  { id: 'rocket', name: 'rocket', names: ['rocket'], unicode: '🚀' },
  { id: 'roll_of_paper', name: 'roll_of_paper', names: ['roll_of_paper'], unicode: '🧻' },
  {
    id: 'rolled_up_newspaper',
    name: 'rolled_up_newspaper',
    names: ['rolled_up_newspaper'],
    unicode: '🗞️',
  },
  { id: 'roller_coaster', name: 'roller_coaster', names: ['roller_coaster'], unicode: '🎢' },
  { id: 'roller_skate', name: 'roller_skate', names: ['roller_skate'], unicode: '🛼' },
  {
    id: 'rolling_on_the_floor_laughing',
    name: 'rolling_on_the_floor_laughing',
    names: ['rolling_on_the_floor_laughing'],
    unicode: '🤣',
  },
  { id: 'rooster', name: 'rooster', names: ['rooster'], unicode: '🐓' },
  { id: 'rose', name: 'rose', names: ['rose'], unicode: '🌹' },
  { id: 'rosette', name: 'rosette', names: ['rosette'], unicode: '🏵️' },
  { id: 'rotating_light', name: 'rotating_light', names: ['rotating_light'], unicode: '🚨' },
  { id: 'round_pushpin', name: 'round_pushpin', names: ['round_pushpin'], unicode: '📍' },
  {
    id: 'rowboat',
    name: 'rowboat',
    names: ['rowboat'],
    skins: ['🚣🏻', '🚣🏼', '🚣🏽', '🚣🏾', '🚣🏿'],
    unicode: '🚣',
  },
  { id: 'ru', name: 'ru', names: ['ru', 'flag-ru'], unicode: '🇷🇺' },
  { id: 'rugby_football', name: 'rugby_football', names: ['rugby_football'], unicode: '🏉' },
  {
    id: 'runner',
    name: 'runner',
    names: ['runner', 'running'],
    skins: ['🏃🏻', '🏃🏼', '🏃🏽', '🏃🏾', '🏃🏿'],
    unicode: '🏃',
  },
  {
    id: 'running_shirt_with_sash',
    name: 'running_shirt_with_sash',
    names: ['running_shirt_with_sash'],
    unicode: '🎽',
  },
  { id: 'sa', name: 'sa', names: ['sa'], unicode: '🈂️' },
  { id: 'safety_pin', name: 'safety_pin', names: ['safety_pin'], unicode: '🧷' },
  { id: 'safety_vest', name: 'safety_vest', names: ['safety_vest'], unicode: '🦺' },
  { id: 'sagittarius', name: 'sagittarius', names: ['sagittarius'], unicode: '♐' },
  { id: 'sake', name: 'sake', names: ['sake'], unicode: '🍶' },
  { id: 'salt', name: 'salt', names: ['salt'], unicode: '🧂' },
  { id: 'saluting_face', name: 'saluting_face', names: ['saluting_face'], unicode: '🫡' },
  { id: 'sandal', name: 'sandal', names: ['sandal'], unicode: '👡' },
  { id: 'sandwich', name: 'sandwich', names: ['sandwich'], unicode: '🥪' },
  {
    id: 'santa',
    name: 'santa',
    names: ['santa'],
    skins: ['🎅🏻', '🎅🏼', '🎅🏽', '🎅🏾', '🎅🏿'],
    unicode: '🎅',
  },
  { id: 'sari', name: 'sari', names: ['sari'], unicode: '🥻' },
  { id: 'satellite', name: 'satellite', names: ['satellite'], unicode: '🛰️' },
  {
    id: 'satellite_antenna',
    name: 'satellite_antenna',
    names: ['satellite_antenna'],
    unicode: '📡',
  },
  { id: 'sauropod', name: 'sauropod', names: ['sauropod'], unicode: '🦕' },
  { id: 'saxophone', name: 'saxophone', names: ['saxophone'], unicode: '🎷' },
  { id: 'scales', name: 'scales', names: ['scales'], unicode: '⚖️' },
  { id: 'scarf', name: 'scarf', names: ['scarf'], unicode: '🧣' },
  { id: 'school', name: 'school', names: ['school'], unicode: '🏫' },
  { id: 'school_satchel', name: 'school_satchel', names: ['school_satchel'], unicode: '🎒' },
  {
    id: 'scientist',
    name: 'scientist',
    names: ['scientist'],
    skins: ['🧑🏻‍🔬', '🧑🏼‍🔬', '🧑🏽‍🔬', '🧑🏾‍🔬', '🧑🏿‍🔬'],
    unicode: '🧑‍🔬',
  },
  { id: 'scissors', name: 'scissors', names: ['scissors'], unicode: '✂️' },
  { id: 'scooter', name: 'scooter', names: ['scooter'], unicode: '🛴' },
  { id: 'scorpion', name: 'scorpion', names: ['scorpion'], unicode: '🦂' },
  { id: 'scorpius', name: 'scorpius', names: ['scorpius'], unicode: '♏' },
  { id: 'scream', name: 'scream', names: ['scream'], unicode: '😱' },
  { id: 'scream_cat', name: 'scream_cat', names: ['scream_cat'], unicode: '🙀' },
  { id: 'screwdriver', name: 'screwdriver', names: ['screwdriver'], unicode: '🪛' },
  { id: 'scroll', name: 'scroll', names: ['scroll'], unicode: '📜' },
  { id: 'seal', name: 'seal', names: ['seal'], unicode: '🦭' },
  { id: 'seat', name: 'seat', names: ['seat'], unicode: '💺' },
  {
    id: 'second_place_medal',
    name: 'second_place_medal',
    names: ['second_place_medal'],
    unicode: '🥈',
  },
  { id: 'secret', name: 'secret', names: ['secret'], unicode: '㊙️' },
  { id: 'see_no_evil', name: 'see_no_evil', names: ['see_no_evil'], unicode: '🙈' },
  { id: 'seedling', name: 'seedling', names: ['seedling'], unicode: '🌱' },
  {
    id: 'selfie',
    name: 'selfie',
    names: ['selfie'],
    skins: ['🤳🏻', '🤳🏼', '🤳🏽', '🤳🏾', '🤳🏿'],
    unicode: '🤳',
  },
  { id: 'service_dog', name: 'service_dog', names: ['service_dog'], unicode: '🐕‍🦺' },
  { id: 'seven', name: 'seven', names: ['seven'], unicode: '7️⃣' },
  { id: 'sewing_needle', name: 'sewing_needle', names: ['sewing_needle'], unicode: '🪡' },
  { id: 'shaking_face', name: 'shaking_face', names: ['shaking_face'], unicode: '🫨' },
  {
    id: 'shallow_pan_of_food',
    name: 'shallow_pan_of_food',
    names: ['shallow_pan_of_food'],
    unicode: '🥘',
  },
  { id: 'shamrock', name: 'shamrock', names: ['shamrock'], unicode: '☘️' },
  { id: 'shark', name: 'shark', names: ['shark'], unicode: '🦈' },
  { id: 'shaved_ice', name: 'shaved_ice', names: ['shaved_ice'], unicode: '🍧' },
  { id: 'sheep', name: 'sheep', names: ['sheep'], unicode: '🐑' },
  { id: 'shell', name: 'shell', names: ['shell'], unicode: '🐚' },
  { id: 'shield', name: 'shield', names: ['shield'], unicode: '🛡️' },
  { id: 'shinto_shrine', name: 'shinto_shrine', names: ['shinto_shrine'], unicode: '⛩️' },
  { id: 'ship', name: 'ship', names: ['ship'], unicode: '🚢' },
  { id: 'shirt', name: 'shirt', names: ['shirt', 'tshirt'], unicode: '👕' },
  { id: 'shopping_bags', name: 'shopping_bags', names: ['shopping_bags'], unicode: '🛍️' },
  { id: 'shopping_trolley', name: 'shopping_trolley', names: ['shopping_trolley'], unicode: '🛒' },
  { id: 'shorts', name: 'shorts', names: ['shorts'], unicode: '🩳' },
  { id: 'shower', name: 'shower', names: ['shower'], unicode: '🚿' },
  { id: 'shrimp', name: 'shrimp', names: ['shrimp'], unicode: '🦐' },
  {
    id: 'shrug',
    name: 'shrug',
    names: ['shrug'],
    skins: ['🤷🏻', '🤷🏼', '🤷🏽', '🤷🏾', '🤷🏿'],
    unicode: '🤷',
  },
  {
    id: 'shushing_face',
    name: 'shushing_face',
    names: ['shushing_face', 'face_with_finger_covering_closed_lips'],
    unicode: '🤫',
  },
  { id: 'signal_strength', name: 'signal_strength', names: ['signal_strength'], unicode: '📶' },
  {
    id: 'singer',
    name: 'singer',
    names: ['singer'],
    skins: ['🧑🏻‍🎤', '🧑🏼‍🎤', '🧑🏽‍🎤', '🧑🏾‍🎤', '🧑🏿‍🎤'],
    unicode: '🧑‍🎤',
  },
  { id: 'six', name: 'six', names: ['six'], unicode: '6️⃣' },
  { id: 'six_pointed_star', name: 'six_pointed_star', names: ['six_pointed_star'], unicode: '🔯' },
  { id: 'skateboard', name: 'skateboard', names: ['skateboard'], unicode: '🛹' },
  { id: 'ski', name: 'ski', names: ['ski'], unicode: '🎿' },
  { id: 'skier', name: 'skier', names: ['skier'], unicode: '⛷️' },
  { id: 'skin-tone-2', name: 'skin-tone-2', names: ['skin-tone-2'], unicode: '🏻' },
  { id: 'skin-tone-3', name: 'skin-tone-3', names: ['skin-tone-3'], unicode: '🏼' },
  { id: 'skin-tone-4', name: 'skin-tone-4', names: ['skin-tone-4'], unicode: '🏽' },
  { id: 'skin-tone-5', name: 'skin-tone-5', names: ['skin-tone-5'], unicode: '🏾' },
  { id: 'skin-tone-6', name: 'skin-tone-6', names: ['skin-tone-6'], unicode: '🏿' },
  { id: 'skull', name: 'skull', names: ['skull'], unicode: '💀' },
  {
    id: 'skull_and_crossbones',
    name: 'skull_and_crossbones',
    names: ['skull_and_crossbones'],
    unicode: '☠️',
  },
  { id: 'skunk', name: 'skunk', names: ['skunk'], unicode: '🦨' },
  { id: 'sled', name: 'sled', names: ['sled'], unicode: '🛷' },
  { id: 'sleeping', name: 'sleeping', names: ['sleeping'], unicode: '😴' },
  {
    id: 'sleeping_accommodation',
    name: 'sleeping_accommodation',
    names: ['sleeping_accommodation'],
    skins: ['🛌🏻', '🛌🏼', '🛌🏽', '🛌🏾', '🛌🏿'],
    unicode: '🛌',
  },
  { id: 'sleepy', name: 'sleepy', names: ['sleepy'], unicode: '😪' },
  {
    id: 'sleuth_or_spy',
    name: 'sleuth_or_spy',
    names: ['sleuth_or_spy'],
    skins: ['🕵🏻', '🕵🏼', '🕵🏽', '🕵🏾', '🕵🏿'],
    unicode: '🕵️',
  },
  {
    id: 'slightly_frowning_face',
    name: 'slightly_frowning_face',
    names: ['slightly_frowning_face'],
    unicode: '🙁',
  },
  {
    id: 'slightly_smiling_face',
    name: 'slightly_smiling_face',
    names: ['slightly_smiling_face'],
    unicode: '🙂',
  },
  { id: 'slot_machine', name: 'slot_machine', names: ['slot_machine'], unicode: '🎰' },
  { id: 'sloth', name: 'sloth', names: ['sloth'], unicode: '🦥' },
  { id: 'small_airplane', name: 'small_airplane', names: ['small_airplane'], unicode: '🛩️' },
  {
    id: 'small_blue_diamond',
    name: 'small_blue_diamond',
    names: ['small_blue_diamond'],
    unicode: '🔹',
  },
  {
    id: 'small_orange_diamond',
    name: 'small_orange_diamond',
    names: ['small_orange_diamond'],
    unicode: '🔸',
  },
  {
    id: 'small_red_triangle',
    name: 'small_red_triangle',
    names: ['small_red_triangle'],
    unicode: '🔺',
  },
  {
    id: 'small_red_triangle_down',
    name: 'small_red_triangle_down',
    names: ['small_red_triangle_down'],
    unicode: '🔻',
  },
  { id: 'smile', name: 'smile', names: ['smile'], unicode: '😄' },
  { id: 'smile_cat', name: 'smile_cat', names: ['smile_cat'], unicode: '😸' },
  { id: 'smiley', name: 'smiley', names: ['smiley'], unicode: '😃' },
  { id: 'smiley_cat', name: 'smiley_cat', names: ['smiley_cat'], unicode: '😺' },
  {
    id: 'smiling_face_with_3_hearts',
    name: 'smiling_face_with_3_hearts',
    names: ['smiling_face_with_3_hearts'],
    unicode: '🥰',
  },
  {
    id: 'smiling_face_with_tear',
    name: 'smiling_face_with_tear',
    names: ['smiling_face_with_tear'],
    unicode: '🥲',
  },
  { id: 'smiling_imp', name: 'smiling_imp', names: ['smiling_imp'], unicode: '😈' },
  { id: 'smirk', name: 'smirk', names: ['smirk'], unicode: '😏' },
  { id: 'smirk_cat', name: 'smirk_cat', names: ['smirk_cat'], unicode: '😼' },
  { id: 'smoking', name: 'smoking', names: ['smoking'], unicode: '🚬' },
  { id: 'snail', name: 'snail', names: ['snail'], unicode: '🐌' },
  { id: 'snake', name: 'snake', names: ['snake'], unicode: '🐍' },
  { id: 'sneezing_face', name: 'sneezing_face', names: ['sneezing_face'], unicode: '🤧' },
  {
    id: 'snow_capped_mountain',
    name: 'snow_capped_mountain',
    names: ['snow_capped_mountain'],
    unicode: '🏔️',
  },
  { id: 'snow_cloud', name: 'snow_cloud', names: ['snow_cloud'], unicode: '🌨️' },
  {
    id: 'snowboarder',
    name: 'snowboarder',
    names: ['snowboarder'],
    skins: ['🏂🏻', '🏂🏼', '🏂🏽', '🏂🏾', '🏂🏿'],
    unicode: '🏂',
  },
  { id: 'snowflake', name: 'snowflake', names: ['snowflake'], unicode: '❄️' },
  { id: 'snowman', name: 'snowman', names: ['snowman'], unicode: '☃️' },
  {
    id: 'snowman_without_snow',
    name: 'snowman_without_snow',
    names: ['snowman_without_snow'],
    unicode: '⛄',
  },
  { id: 'soap', name: 'soap', names: ['soap'], unicode: '🧼' },
  { id: 'sob', name: 'sob', names: ['sob'], unicode: '😭' },
  { id: 'soccer', name: 'soccer', names: ['soccer'], unicode: '⚽' },
  { id: 'socks', name: 'socks', names: ['socks'], unicode: '🧦' },
  { id: 'softball', name: 'softball', names: ['softball'], unicode: '🥎' },
  { id: 'soon', name: 'soon', names: ['soon'], unicode: '🔜' },
  { id: 'sos', name: 'sos', names: ['sos'], unicode: '🆘' },
  { id: 'sound', name: 'sound', names: ['sound'], unicode: '🔉' },
  { id: 'space_invader', name: 'space_invader', names: ['space_invader'], unicode: '👾' },
  { id: 'spades', name: 'spades', names: ['spades'], unicode: '♠️' },
  { id: 'spaghetti', name: 'spaghetti', names: ['spaghetti'], unicode: '🍝' },
  { id: 'sparkle', name: 'sparkle', names: ['sparkle'], unicode: '❇️' },
  { id: 'sparkler', name: 'sparkler', names: ['sparkler'], unicode: '🎇' },
  { id: 'sparkles', name: 'sparkles', names: ['sparkles'], unicode: '✨' },
  { id: 'sparkling_heart', name: 'sparkling_heart', names: ['sparkling_heart'], unicode: '💖' },
  { id: 'speak_no_evil', name: 'speak_no_evil', names: ['speak_no_evil'], unicode: '🙊' },
  { id: 'speaker', name: 'speaker', names: ['speaker'], unicode: '🔈' },
  {
    id: 'speaking_head_in_silhouette',
    name: 'speaking_head_in_silhouette',
    names: ['speaking_head_in_silhouette'],
    unicode: '🗣️',
  },
  { id: 'speech_balloon', name: 'speech_balloon', names: ['speech_balloon'], unicode: '💬' },
  { id: 'speedboat', name: 'speedboat', names: ['speedboat'], unicode: '🚤' },
  { id: 'spider', name: 'spider', names: ['spider'], unicode: '🕷️' },
  { id: 'spider_web', name: 'spider_web', names: ['spider_web'], unicode: '🕸️' },
  {
    id: 'spiral_calendar_pad',
    name: 'spiral_calendar_pad',
    names: ['spiral_calendar_pad'],
    unicode: '🗓️',
  },
  { id: 'spiral_note_pad', name: 'spiral_note_pad', names: ['spiral_note_pad'], unicode: '🗒️' },
  {
    id: 'spock-hand',
    name: 'spock-hand',
    names: ['spock-hand'],
    skins: ['🖖🏻', '🖖🏼', '🖖🏽', '🖖🏾', '🖖🏿'],
    unicode: '🖖',
  },
  { id: 'sponge', name: 'sponge', names: ['sponge'], unicode: '🧽' },
  { id: 'spoon', name: 'spoon', names: ['spoon'], unicode: '🥄' },
  { id: 'sports_medal', name: 'sports_medal', names: ['sports_medal'], unicode: '🏅' },
  { id: 'squid', name: 'squid', names: ['squid'], unicode: '🦑' },
  { id: 'stadium', name: 'stadium', names: ['stadium'], unicode: '🏟️' },
  {
    id: 'standing_person',
    name: 'standing_person',
    names: ['standing_person'],
    skins: ['🧍🏻', '🧍🏼', '🧍🏽', '🧍🏾', '🧍🏿'],
    unicode: '🧍',
  },
  { id: 'star', name: 'star', names: ['star'], unicode: '⭐' },
  {
    id: 'star-struck',
    name: 'star-struck',
    names: ['star-struck', 'grinning_face_with_star_eyes'],
    unicode: '🤩',
  },
  { id: 'star2', name: 'star2', names: ['star2'], unicode: '🌟' },
  {
    id: 'star_and_crescent',
    name: 'star_and_crescent',
    names: ['star_and_crescent'],
    unicode: '☪️',
  },
  { id: 'star_of_david', name: 'star_of_david', names: ['star_of_david'], unicode: '✡️' },
  { id: 'stars', name: 'stars', names: ['stars'], unicode: '🌠' },
  { id: 'station', name: 'station', names: ['station'], unicode: '🚉' },
  {
    id: 'statue_of_liberty',
    name: 'statue_of_liberty',
    names: ['statue_of_liberty'],
    unicode: '🗽',
  },
  { id: 'steam_locomotive', name: 'steam_locomotive', names: ['steam_locomotive'], unicode: '🚂' },
  { id: 'stethoscope', name: 'stethoscope', names: ['stethoscope'], unicode: '🩺' },
  { id: 'stew', name: 'stew', names: ['stew'], unicode: '🍲' },
  { id: 'stopwatch', name: 'stopwatch', names: ['stopwatch'], unicode: '⏱️' },
  { id: 'straight_ruler', name: 'straight_ruler', names: ['straight_ruler'], unicode: '📏' },
  { id: 'strawberry', name: 'strawberry', names: ['strawberry'], unicode: '🍓' },
  { id: 'stuck_out_tongue', name: 'stuck_out_tongue', names: ['stuck_out_tongue'], unicode: '😛' },
  {
    id: 'stuck_out_tongue_closed_eyes',
    name: 'stuck_out_tongue_closed_eyes',
    names: ['stuck_out_tongue_closed_eyes'],
    unicode: '😝',
  },
  {
    id: 'stuck_out_tongue_winking_eye',
    name: 'stuck_out_tongue_winking_eye',
    names: ['stuck_out_tongue_winking_eye'],
    unicode: '😜',
  },
  {
    id: 'student',
    name: 'student',
    names: ['student'],
    skins: ['🧑🏻‍🎓', '🧑🏼‍🎓', '🧑🏽‍🎓', '🧑🏾‍🎓', '🧑🏿‍🎓'],
    unicode: '🧑‍🎓',
  },
  {
    id: 'studio_microphone',
    name: 'studio_microphone',
    names: ['studio_microphone'],
    unicode: '🎙️',
  },
  {
    id: 'stuffed_flatbread',
    name: 'stuffed_flatbread',
    names: ['stuffed_flatbread'],
    unicode: '🥙',
  },
  { id: 'sun_with_face', name: 'sun_with_face', names: ['sun_with_face'], unicode: '🌞' },
  { id: 'sunflower', name: 'sunflower', names: ['sunflower'], unicode: '🌻' },
  { id: 'sunglasses', name: 'sunglasses', names: ['sunglasses'], unicode: '😎' },
  { id: 'sunny', name: 'sunny', names: ['sunny'], unicode: '☀️' },
  { id: 'sunrise', name: 'sunrise', names: ['sunrise'], unicode: '🌅' },
  {
    id: 'sunrise_over_mountains',
    name: 'sunrise_over_mountains',
    names: ['sunrise_over_mountains'],
    unicode: '🌄',
  },
  {
    id: 'superhero',
    name: 'superhero',
    names: ['superhero'],
    skins: ['🦸🏻', '🦸🏼', '🦸🏽', '🦸🏾', '🦸🏿'],
    unicode: '🦸',
  },
  {
    id: 'supervillain',
    name: 'supervillain',
    names: ['supervillain'],
    skins: ['🦹🏻', '🦹🏼', '🦹🏽', '🦹🏾', '🦹🏿'],
    unicode: '🦹',
  },
  {
    id: 'surfer',
    name: 'surfer',
    names: ['surfer'],
    skins: ['🏄🏻', '🏄🏼', '🏄🏽', '🏄🏾', '🏄🏿'],
    unicode: '🏄',
  },
  { id: 'sushi', name: 'sushi', names: ['sushi'], unicode: '🍣' },
  {
    id: 'suspension_railway',
    name: 'suspension_railway',
    names: ['suspension_railway'],
    unicode: '🚟',
  },
  { id: 'swan', name: 'swan', names: ['swan'], unicode: '🦢' },
  { id: 'sweat', name: 'sweat', names: ['sweat'], unicode: '😓' },
  { id: 'sweat_drops', name: 'sweat_drops', names: ['sweat_drops'], unicode: '💦' },
  { id: 'sweat_smile', name: 'sweat_smile', names: ['sweat_smile'], unicode: '😅' },
  { id: 'sweet_potato', name: 'sweet_potato', names: ['sweet_potato'], unicode: '🍠' },
  {
    id: 'swimmer',
    name: 'swimmer',
    names: ['swimmer'],
    skins: ['🏊🏻', '🏊🏼', '🏊🏽', '🏊🏾', '🏊🏿'],
    unicode: '🏊',
  },
  { id: 'symbols', name: 'symbols', names: ['symbols'], unicode: '🔣' },
  { id: 'synagogue', name: 'synagogue', names: ['synagogue'], unicode: '🕍' },
  { id: 'syringe', name: 'syringe', names: ['syringe'], unicode: '💉' },
  { id: 't-rex', name: 't-rex', names: ['t-rex'], unicode: '🦖' },
  {
    id: 'table_tennis_paddle_and_ball',
    name: 'table_tennis_paddle_and_ball',
    names: ['table_tennis_paddle_and_ball'],
    unicode: '🏓',
  },
  { id: 'taco', name: 'taco', names: ['taco'], unicode: '🌮' },
  { id: 'tada', name: 'tada', names: ['tada'], unicode: '🎉' },
  { id: 'takeout_box', name: 'takeout_box', names: ['takeout_box'], unicode: '🥡' },
  { id: 'tamale', name: 'tamale', names: ['tamale'], unicode: '🫔' },
  { id: 'tanabata_tree', name: 'tanabata_tree', names: ['tanabata_tree'], unicode: '🎋' },
  { id: 'tangerine', name: 'tangerine', names: ['tangerine'], unicode: '🍊' },
  { id: 'taurus', name: 'taurus', names: ['taurus'], unicode: '♉' },
  { id: 'taxi', name: 'taxi', names: ['taxi'], unicode: '🚕' },
  { id: 'tea', name: 'tea', names: ['tea'], unicode: '🍵' },
  {
    id: 'teacher',
    name: 'teacher',
    names: ['teacher'],
    skins: ['🧑🏻‍🏫', '🧑🏼‍🏫', '🧑🏽‍🏫', '🧑🏾‍🏫', '🧑🏿‍🏫'],
    unicode: '🧑‍🏫',
  },
  { id: 'teapot', name: 'teapot', names: ['teapot'], unicode: '🫖' },
  {
    id: 'technologist',
    name: 'technologist',
    names: ['technologist'],
    skins: ['🧑🏻‍💻', '🧑🏼‍💻', '🧑🏽‍💻', '🧑🏾‍💻', '🧑🏿‍💻'],
    unicode: '🧑‍💻',
  },
  { id: 'teddy_bear', name: 'teddy_bear', names: ['teddy_bear'], unicode: '🧸' },
  {
    id: 'telephone_receiver',
    name: 'telephone_receiver',
    names: ['telephone_receiver'],
    unicode: '📞',
  },
  { id: 'telescope', name: 'telescope', names: ['telescope'], unicode: '🔭' },
  { id: 'tennis', name: 'tennis', names: ['tennis'], unicode: '🎾' },
  { id: 'tent', name: 'tent', names: ['tent'], unicode: '⛺' },
  { id: 'test_tube', name: 'test_tube', names: ['test_tube'], unicode: '🧪' },
  {
    id: 'the_horns',
    name: 'the_horns',
    names: ['the_horns', 'sign_of_the_horns'],
    skins: ['🤘🏻', '🤘🏼', '🤘🏽', '🤘🏾', '🤘🏿'],
    unicode: '🤘',
  },
  { id: 'thermometer', name: 'thermometer', names: ['thermometer'], unicode: '🌡️' },
  { id: 'thinking_face', name: 'thinking_face', names: ['thinking_face'], unicode: '🤔' },
  {
    id: 'third_place_medal',
    name: 'third_place_medal',
    names: ['third_place_medal'],
    unicode: '🥉',
  },
  { id: 'thong_sandal', name: 'thong_sandal', names: ['thong_sandal'], unicode: '🩴' },
  { id: 'thought_balloon', name: 'thought_balloon', names: ['thought_balloon'], unicode: '💭' },
  { id: 'thread', name: 'thread', names: ['thread'], unicode: '🧵' },
  { id: 'three', name: 'three', names: ['three'], unicode: '3️⃣' },
  {
    id: 'three_button_mouse',
    name: 'three_button_mouse',
    names: ['three_button_mouse'],
    unicode: '🖱️',
  },
  {
    id: 'thunder_cloud_and_rain',
    name: 'thunder_cloud_and_rain',
    names: ['thunder_cloud_and_rain'],
    unicode: '⛈️',
  },
  { id: 'ticket', name: 'ticket', names: ['ticket'], unicode: '🎫' },
  { id: 'tiger', name: 'tiger', names: ['tiger'], unicode: '🐯' },
  { id: 'tiger2', name: 'tiger2', names: ['tiger2'], unicode: '🐅' },
  { id: 'timer_clock', name: 'timer_clock', names: ['timer_clock'], unicode: '⏲️' },
  { id: 'tired_face', name: 'tired_face', names: ['tired_face'], unicode: '😫' },
  { id: 'tm', name: 'tm', names: ['tm'], unicode: '™️' },
  { id: 'toilet', name: 'toilet', names: ['toilet'], unicode: '🚽' },
  { id: 'tokyo_tower', name: 'tokyo_tower', names: ['tokyo_tower'], unicode: '🗼' },
  { id: 'tomato', name: 'tomato', names: ['tomato'], unicode: '🍅' },
  { id: 'tongue', name: 'tongue', names: ['tongue'], unicode: '👅' },
  { id: 'toolbox', name: 'toolbox', names: ['toolbox'], unicode: '🧰' },
  { id: 'tooth', name: 'tooth', names: ['tooth'], unicode: '🦷' },
  { id: 'toothbrush', name: 'toothbrush', names: ['toothbrush'], unicode: '🪥' },
  { id: 'top', name: 'top', names: ['top'], unicode: '🔝' },
  { id: 'tophat', name: 'tophat', names: ['tophat'], unicode: '🎩' },
  { id: 'tornado', name: 'tornado', names: ['tornado', 'tornado_cloud'], unicode: '🌪️' },
  { id: 'trackball', name: 'trackball', names: ['trackball'], unicode: '🖲️' },
  { id: 'tractor', name: 'tractor', names: ['tractor'], unicode: '🚜' },
  { id: 'traffic_light', name: 'traffic_light', names: ['traffic_light'], unicode: '🚥' },
  { id: 'train', name: 'train', names: ['train'], unicode: '🚋' },
  { id: 'train2', name: 'train2', names: ['train2'], unicode: '🚆' },
  { id: 'tram', name: 'tram', names: ['tram'], unicode: '🚊' },
  {
    id: 'transgender_flag',
    name: 'transgender_flag',
    names: ['transgender_flag'],
    unicode: '🏳️‍⚧️',
  },
  {
    id: 'transgender_symbol',
    name: 'transgender_symbol',
    names: ['transgender_symbol'],
    unicode: '⚧️',
  },
  {
    id: 'triangular_flag_on_post',
    name: 'triangular_flag_on_post',
    names: ['triangular_flag_on_post'],
    unicode: '🚩',
  },
  { id: 'triangular_ruler', name: 'triangular_ruler', names: ['triangular_ruler'], unicode: '📐' },
  { id: 'trident', name: 'trident', names: ['trident'], unicode: '🔱' },
  { id: 'triumph', name: 'triumph', names: ['triumph'], unicode: '😤' },
  { id: 'troll', name: 'troll', names: ['troll'], unicode: '🧌' },
  { id: 'trolleybus', name: 'trolleybus', names: ['trolleybus'], unicode: '🚎' },
  { id: 'trophy', name: 'trophy', names: ['trophy'], unicode: '🏆' },
  { id: 'tropical_drink', name: 'tropical_drink', names: ['tropical_drink'], unicode: '🍹' },
  { id: 'tropical_fish', name: 'tropical_fish', names: ['tropical_fish'], unicode: '🐠' },
  { id: 'truck', name: 'truck', names: ['truck'], unicode: '🚚' },
  { id: 'trumpet', name: 'trumpet', names: ['trumpet'], unicode: '🎺' },
  { id: 'tulip', name: 'tulip', names: ['tulip'], unicode: '🌷' },
  { id: 'tumbler_glass', name: 'tumbler_glass', names: ['tumbler_glass'], unicode: '🥃' },
  { id: 'turkey', name: 'turkey', names: ['turkey'], unicode: '🦃' },
  { id: 'turtle', name: 'turtle', names: ['turtle'], unicode: '🐢' },
  { id: 'tv', name: 'tv', names: ['tv'], unicode: '📺' },
  {
    id: 'twisted_rightwards_arrows',
    name: 'twisted_rightwards_arrows',
    names: ['twisted_rightwards_arrows'],
    unicode: '🔀',
  },
  { id: 'two', name: 'two', names: ['two'], unicode: '2️⃣' },
  { id: 'two_hearts', name: 'two_hearts', names: ['two_hearts'], unicode: '💕' },
  {
    id: 'two_men_holding_hands',
    name: 'two_men_holding_hands',
    names: ['two_men_holding_hands', 'men_holding_hands'],
    skins: [
      '👬🏻',
      '👬🏼',
      '👬🏽',
      '👬🏾',
      '👬🏿',
      '👨🏻‍🤝‍👨🏼',
      '👨🏻‍🤝‍👨🏽',
      '👨🏻‍🤝‍👨🏾',
      '👨🏻‍🤝‍👨🏿',
      '👨🏼‍🤝‍👨🏻',
      '👨🏼‍🤝‍👨🏽',
      '👨🏼‍🤝‍👨🏾',
      '👨🏼‍🤝‍👨🏿',
      '👨🏽‍🤝‍👨🏻',
      '👨🏽‍🤝‍👨🏼',
      '👨🏽‍🤝‍👨🏾',
      '👨🏽‍🤝‍👨🏿',
      '👨🏾‍🤝‍👨🏻',
      '👨🏾‍🤝‍👨🏼',
      '👨🏾‍🤝‍👨🏽',
      '👨🏾‍🤝‍👨🏿',
      '👨🏿‍🤝‍👨🏻',
      '👨🏿‍🤝‍👨🏼',
      '👨🏿‍🤝‍👨🏽',
      '👨🏿‍🤝‍👨🏾',
    ],
    unicode: '👬',
  },
  {
    id: 'two_women_holding_hands',
    name: 'two_women_holding_hands',
    names: ['two_women_holding_hands', 'women_holding_hands'],
    skins: [
      '👭🏻',
      '👭🏼',
      '👭🏽',
      '👭🏾',
      '👭🏿',
      '👩🏻‍🤝‍👩🏼',
      '👩🏻‍🤝‍👩🏽',
      '👩🏻‍🤝‍👩🏾',
      '👩🏻‍🤝‍👩🏿',
      '👩🏼‍🤝‍👩🏻',
      '👩🏼‍🤝‍👩🏽',
      '👩🏼‍🤝‍👩🏾',
      '👩🏼‍🤝‍👩🏿',
      '👩🏽‍🤝‍👩🏻',
      '👩🏽‍🤝‍👩🏼',
      '👩🏽‍🤝‍👩🏾',
      '👩🏽‍🤝‍👩🏿',
      '👩🏾‍🤝‍👩🏻',
      '👩🏾‍🤝‍👩🏼',
      '👩🏾‍🤝‍👩🏽',
      '👩🏾‍🤝‍👩🏿',
      '👩🏿‍🤝‍👩🏻',
      '👩🏿‍🤝‍👩🏼',
      '👩🏿‍🤝‍👩🏽',
      '👩🏿‍🤝‍👩🏾',
    ],
    unicode: '👭',
  },
  { id: 'u5272', name: 'u5272', names: ['u5272'], unicode: '🈹' },
  { id: 'u5408', name: 'u5408', names: ['u5408'], unicode: '🈴' },
  { id: 'u55b6', name: 'u55b6', names: ['u55b6'], unicode: '🈺' },
  { id: 'u6307', name: 'u6307', names: ['u6307'], unicode: '🈯' },
  { id: 'u6708', name: 'u6708', names: ['u6708'], unicode: '🈷️' },
  { id: 'u6709', name: 'u6709', names: ['u6709'], unicode: '🈶' },
  { id: 'u6e80', name: 'u6e80', names: ['u6e80'], unicode: '🈵' },
  { id: 'u7121', name: 'u7121', names: ['u7121'], unicode: '🈚' },
  { id: 'u7533', name: 'u7533', names: ['u7533'], unicode: '🈸' },
  { id: 'u7981', name: 'u7981', names: ['u7981'], unicode: '🈲' },
  { id: 'u7a7a', name: 'u7a7a', names: ['u7a7a'], unicode: '🈳' },
  { id: 'umbrella', name: 'umbrella', names: ['umbrella'], unicode: '☂️' },
  {
    id: 'umbrella_on_ground',
    name: 'umbrella_on_ground',
    names: ['umbrella_on_ground'],
    unicode: '⛱️',
  },
  {
    id: 'umbrella_with_rain_drops',
    name: 'umbrella_with_rain_drops',
    names: ['umbrella_with_rain_drops'],
    unicode: '☔',
  },
  { id: 'unamused', name: 'unamused', names: ['unamused'], unicode: '😒' },
  { id: 'underage', name: 'underage', names: ['underage'], unicode: '🔞' },
  { id: 'unicorn_face', name: 'unicorn_face', names: ['unicorn_face'], unicode: '🦄' },
  { id: 'unlock', name: 'unlock', names: ['unlock'], unicode: '🔓' },
  { id: 'up', name: 'up', names: ['up'], unicode: '🆙' },
  { id: 'upside_down_face', name: 'upside_down_face', names: ['upside_down_face'], unicode: '🙃' },
  { id: 'us', name: 'us', names: ['us', 'flag-us'], unicode: '🇺🇸' },
  { id: 'v', name: 'v', names: ['v'], skins: ['✌🏻', '✌🏼', '✌🏽', '✌🏾', '✌🏿'], unicode: '✌️' },
  {
    id: 'vampire',
    name: 'vampire',
    names: ['vampire'],
    skins: ['🧛🏻', '🧛🏼', '🧛🏽', '🧛🏾', '🧛🏿'],
    unicode: '🧛',
  },
  {
    id: 'vertical_traffic_light',
    name: 'vertical_traffic_light',
    names: ['vertical_traffic_light'],
    unicode: '🚦',
  },
  { id: 'vhs', name: 'vhs', names: ['vhs'], unicode: '📼' },
  { id: 'vibration_mode', name: 'vibration_mode', names: ['vibration_mode'], unicode: '📳' },
  { id: 'video_camera', name: 'video_camera', names: ['video_camera'], unicode: '📹' },
  { id: 'video_game', name: 'video_game', names: ['video_game'], unicode: '🎮' },
  { id: 'violin', name: 'violin', names: ['violin'], unicode: '🎻' },
  { id: 'virgo', name: 'virgo', names: ['virgo'], unicode: '♍' },
  { id: 'volcano', name: 'volcano', names: ['volcano'], unicode: '🌋' },
  { id: 'volleyball', name: 'volleyball', names: ['volleyball'], unicode: '🏐' },
  { id: 'vs', name: 'vs', names: ['vs'], unicode: '🆚' },
  { id: 'waffle', name: 'waffle', names: ['waffle'], unicode: '🧇' },
  {
    id: 'walking',
    name: 'walking',
    names: ['walking'],
    skins: ['🚶🏻', '🚶🏼', '🚶🏽', '🚶🏾', '🚶🏿'],
    unicode: '🚶',
  },
  {
    id: 'waning_crescent_moon',
    name: 'waning_crescent_moon',
    names: ['waning_crescent_moon'],
    unicode: '🌘',
  },
  {
    id: 'waning_gibbous_moon',
    name: 'waning_gibbous_moon',
    names: ['waning_gibbous_moon'],
    unicode: '🌖',
  },
  { id: 'warning', name: 'warning', names: ['warning'], unicode: '⚠️' },
  { id: 'wastebasket', name: 'wastebasket', names: ['wastebasket'], unicode: '🗑️' },
  { id: 'watch', name: 'watch', names: ['watch'], unicode: '⌚' },
  { id: 'water_buffalo', name: 'water_buffalo', names: ['water_buffalo'], unicode: '🐃' },
  {
    id: 'water_polo',
    name: 'water_polo',
    names: ['water_polo'],
    skins: ['🤽🏻', '🤽🏼', '🤽🏽', '🤽🏾', '🤽🏿'],
    unicode: '🤽',
  },
  { id: 'watermelon', name: 'watermelon', names: ['watermelon'], unicode: '🍉' },
  {
    id: 'wave',
    name: 'wave',
    names: ['wave'],
    skins: ['👋🏻', '👋🏼', '👋🏽', '👋🏾', '👋🏿'],
    unicode: '👋',
  },
  {
    id: 'waving_black_flag',
    name: 'waving_black_flag',
    names: ['waving_black_flag'],
    unicode: '🏴',
  },
  {
    id: 'waving_white_flag',
    name: 'waving_white_flag',
    names: ['waving_white_flag'],
    unicode: '🏳️',
  },
  { id: 'wavy_dash', name: 'wavy_dash', names: ['wavy_dash'], unicode: '〰️' },
  {
    id: 'waxing_crescent_moon',
    name: 'waxing_crescent_moon',
    names: ['waxing_crescent_moon'],
    unicode: '🌒',
  },
  { id: 'wc', name: 'wc', names: ['wc'], unicode: '🚾' },
  { id: 'weary', name: 'weary', names: ['weary'], unicode: '😩' },
  { id: 'wedding', name: 'wedding', names: ['wedding'], unicode: '💒' },
  {
    id: 'weight_lifter',
    name: 'weight_lifter',
    names: ['weight_lifter'],
    skins: ['🏋🏻', '🏋🏼', '🏋🏽', '🏋🏾', '🏋🏿'],
    unicode: '🏋️',
  },
  { id: 'whale', name: 'whale', names: ['whale'], unicode: '🐳' },
  { id: 'whale2', name: 'whale2', names: ['whale2'], unicode: '🐋' },
  { id: 'wheel', name: 'wheel', names: ['wheel'], unicode: '🛞' },
  { id: 'wheel_of_dharma', name: 'wheel_of_dharma', names: ['wheel_of_dharma'], unicode: '☸️' },
  { id: 'wheelchair', name: 'wheelchair', names: ['wheelchair'], unicode: '♿' },
  { id: 'white_check_mark', name: 'white_check_mark', names: ['white_check_mark'], unicode: '✅' },
  { id: 'white_circle', name: 'white_circle', names: ['white_circle'], unicode: '⚪' },
  { id: 'white_flower', name: 'white_flower', names: ['white_flower'], unicode: '💮' },
  {
    id: 'white_frowning_face',
    name: 'white_frowning_face',
    names: ['white_frowning_face'],
    unicode: '☹️',
  },
  {
    id: 'white_haired_man',
    name: 'white_haired_man',
    names: ['white_haired_man'],
    skins: ['👨🏻‍🦳', '👨🏼‍🦳', '👨🏽‍🦳', '👨🏾‍🦳', '👨🏿‍🦳'],
    unicode: '👨‍🦳',
  },
  {
    id: 'white_haired_person',
    name: 'white_haired_person',
    names: ['white_haired_person'],
    skins: ['🧑🏻‍🦳', '🧑🏼‍🦳', '🧑🏽‍🦳', '🧑🏾‍🦳', '🧑🏿‍🦳'],
    unicode: '🧑‍🦳',
  },
  {
    id: 'white_haired_woman',
    name: 'white_haired_woman',
    names: ['white_haired_woman'],
    skins: ['👩🏻‍🦳', '👩🏼‍🦳', '👩🏽‍🦳', '👩🏾‍🦳', '👩🏿‍🦳'],
    unicode: '👩‍🦳',
  },
  { id: 'white_heart', name: 'white_heart', names: ['white_heart'], unicode: '🤍' },
  {
    id: 'white_large_square',
    name: 'white_large_square',
    names: ['white_large_square'],
    unicode: '⬜',
  },
  {
    id: 'white_medium_small_square',
    name: 'white_medium_small_square',
    names: ['white_medium_small_square'],
    unicode: '◽',
  },
  {
    id: 'white_medium_square',
    name: 'white_medium_square',
    names: ['white_medium_square'],
    unicode: '◻️',
  },
  {
    id: 'white_small_square',
    name: 'white_small_square',
    names: ['white_small_square'],
    unicode: '▫️',
  },
  {
    id: 'white_square_button',
    name: 'white_square_button',
    names: ['white_square_button'],
    unicode: '🔳',
  },
  { id: 'wilted_flower', name: 'wilted_flower', names: ['wilted_flower'], unicode: '🥀' },
  {
    id: 'wind_blowing_face',
    name: 'wind_blowing_face',
    names: ['wind_blowing_face'],
    unicode: '🌬️',
  },
  { id: 'wind_chime', name: 'wind_chime', names: ['wind_chime'], unicode: '🎐' },
  { id: 'window', name: 'window', names: ['window'], unicode: '🪟' },
  { id: 'wine_glass', name: 'wine_glass', names: ['wine_glass'], unicode: '🍷' },
  { id: 'wing', name: 'wing', names: ['wing'], unicode: '🪽' },
  { id: 'wink', name: 'wink', names: ['wink'], unicode: '😉' },
  { id: 'wireless', name: 'wireless', names: ['wireless'], unicode: '🛜' },
  { id: 'wolf', name: 'wolf', names: ['wolf'], unicode: '🐺' },
  {
    id: 'woman',
    name: 'woman',
    names: ['woman'],
    skins: ['👩🏻', '👩🏼', '👩🏽', '👩🏾', '👩🏿'],
    unicode: '👩',
  },
  {
    id: 'woman-biking',
    name: 'woman-biking',
    names: ['woman-biking'],
    skins: ['🚴🏻‍♀️', '🚴🏼‍♀️', '🚴🏽‍♀️', '🚴🏾‍♀️', '🚴🏿‍♀️'],
    unicode: '🚴‍♀️',
  },
  {
    id: 'woman-bouncing-ball',
    name: 'woman-bouncing-ball',
    names: ['woman-bouncing-ball'],
    skins: ['⛹🏻‍♀️', '⛹🏼‍♀️', '⛹🏽‍♀️', '⛹🏾‍♀️', '⛹🏿‍♀️'],
    unicode: '⛹️‍♀️',
  },
  {
    id: 'woman-bowing',
    name: 'woman-bowing',
    names: ['woman-bowing'],
    skins: ['🙇🏻‍♀️', '🙇🏼‍♀️', '🙇🏽‍♀️', '🙇🏾‍♀️', '🙇🏿‍♀️'],
    unicode: '🙇‍♀️',
  },
  { id: 'woman-boy', name: 'woman-boy', names: ['woman-boy'], unicode: '👩‍👦' },
  { id: 'woman-boy-boy', name: 'woman-boy-boy', names: ['woman-boy-boy'], unicode: '👩‍👦‍👦' },
  {
    id: 'woman-cartwheeling',
    name: 'woman-cartwheeling',
    names: ['woman-cartwheeling'],
    skins: ['🤸🏻‍♀️', '🤸🏼‍♀️', '🤸🏽‍♀️', '🤸🏾‍♀️', '🤸🏿‍♀️'],
    unicode: '🤸‍♀️',
  },
  {
    id: 'woman-facepalming',
    name: 'woman-facepalming',
    names: ['woman-facepalming'],
    skins: ['🤦🏻‍♀️', '🤦🏼‍♀️', '🤦🏽‍♀️', '🤦🏾‍♀️', '🤦🏿‍♀️'],
    unicode: '🤦‍♀️',
  },
  {
    id: 'woman-frowning',
    name: 'woman-frowning',
    names: ['woman-frowning'],
    skins: ['🙍🏻‍♀️', '🙍🏼‍♀️', '🙍🏽‍♀️', '🙍🏾‍♀️', '🙍🏿‍♀️'],
    unicode: '🙍‍♀️',
  },
  {
    id: 'woman-gesturing-no',
    name: 'woman-gesturing-no',
    names: ['woman-gesturing-no'],
    skins: ['🙅🏻‍♀️', '🙅🏼‍♀️', '🙅🏽‍♀️', '🙅🏾‍♀️', '🙅🏿‍♀️'],
    unicode: '🙅‍♀️',
  },
  {
    id: 'woman-gesturing-ok',
    name: 'woman-gesturing-ok',
    names: ['woman-gesturing-ok'],
    skins: ['🙆🏻‍♀️', '🙆🏼‍♀️', '🙆🏽‍♀️', '🙆🏾‍♀️', '🙆🏿‍♀️'],
    unicode: '🙆‍♀️',
  },
  {
    id: 'woman-getting-haircut',
    name: 'woman-getting-haircut',
    names: ['woman-getting-haircut'],
    skins: ['💇🏻‍♀️', '💇🏼‍♀️', '💇🏽‍♀️', '💇🏾‍♀️', '💇🏿‍♀️'],
    unicode: '💇‍♀️',
  },
  {
    id: 'woman-getting-massage',
    name: 'woman-getting-massage',
    names: ['woman-getting-massage'],
    skins: ['💆🏻‍♀️', '💆🏼‍♀️', '💆🏽‍♀️', '💆🏾‍♀️', '💆🏿‍♀️'],
    unicode: '💆‍♀️',
  },
  { id: 'woman-girl', name: 'woman-girl', names: ['woman-girl'], unicode: '👩‍👧' },
  { id: 'woman-girl-boy', name: 'woman-girl-boy', names: ['woman-girl-boy'], unicode: '👩‍👧‍👦' },
  { id: 'woman-girl-girl', name: 'woman-girl-girl', names: ['woman-girl-girl'], unicode: '👩‍👧‍👧' },
  {
    id: 'woman-golfing',
    name: 'woman-golfing',
    names: ['woman-golfing'],
    skins: ['🏌🏻‍♀️', '🏌🏼‍♀️', '🏌🏽‍♀️', '🏌🏾‍♀️', '🏌🏿‍♀️'],
    unicode: '🏌️‍♀️',
  },
  {
    id: 'woman-heart-man',
    name: 'woman-heart-man',
    names: ['woman-heart-man'],
    skins: [
      '👩🏻‍❤️‍👨🏻',
      '👩🏻‍❤️‍👨🏼',
      '👩🏻‍❤️‍👨🏽',
      '👩🏻‍❤️‍👨🏾',
      '👩🏻‍❤️‍👨🏿',
      '👩🏼‍❤️‍👨🏻',
      '👩🏼‍❤️‍👨🏼',
      '👩🏼‍❤️‍👨🏽',
      '👩🏼‍❤️‍👨🏾',
      '👩🏼‍❤️‍👨🏿',
      '👩🏽‍❤️‍👨🏻',
      '👩🏽‍❤️‍👨🏼',
      '👩🏽‍❤️‍👨🏽',
      '👩🏽‍❤️‍👨🏾',
      '👩🏽‍❤️‍👨🏿',
      '👩🏾‍❤️‍👨🏻',
      '👩🏾‍❤️‍👨🏼',
      '👩🏾‍❤️‍👨🏽',
      '👩🏾‍❤️‍👨🏾',
      '👩🏾‍❤️‍👨🏿',
      '👩🏿‍❤️‍👨🏻',
      '👩🏿‍❤️‍👨🏼',
      '👩🏿‍❤️‍👨🏽',
      '👩🏿‍❤️‍👨🏾',
      '👩🏿‍❤️‍👨🏿',
    ],
    unicode: '👩‍❤️‍👨',
  },
  {
    id: 'woman-heart-woman',
    name: 'woman-heart-woman',
    names: ['woman-heart-woman'],
    skins: [
      '👩🏻‍❤️‍👩🏻',
      '👩🏻‍❤️‍👩🏼',
      '👩🏻‍❤️‍👩🏽',
      '👩🏻‍❤️‍👩🏾',
      '👩🏻‍❤️‍👩🏿',
      '👩🏼‍❤️‍👩🏻',
      '👩🏼‍❤️‍👩🏼',
      '👩🏼‍❤️‍👩🏽',
      '👩🏼‍❤️‍👩🏾',
      '👩🏼‍❤️‍👩🏿',
      '👩🏽‍❤️‍👩🏻',
      '👩🏽‍❤️‍👩🏼',
      '👩🏽‍❤️‍👩🏽',
      '👩🏽‍❤️‍👩🏾',
      '👩🏽‍❤️‍👩🏿',
      '👩🏾‍❤️‍👩🏻',
      '👩🏾‍❤️‍👩🏼',
      '👩🏾‍❤️‍👩🏽',
      '👩🏾‍❤️‍👩🏾',
      '👩🏾‍❤️‍👩🏿',
      '👩🏿‍❤️‍👩🏻',
      '👩🏿‍❤️‍👩🏼',
      '👩🏿‍❤️‍👩🏽',
      '👩🏿‍❤️‍👩🏾',
      '👩🏿‍❤️‍👩🏿',
    ],
    unicode: '👩‍❤️‍👩',
  },
  {
    id: 'woman-juggling',
    name: 'woman-juggling',
    names: ['woman-juggling'],
    skins: ['🤹🏻‍♀️', '🤹🏼‍♀️', '🤹🏽‍♀️', '🤹🏾‍♀️', '🤹🏿‍♀️'],
    unicode: '🤹‍♀️',
  },
  {
    id: 'woman-kiss-man',
    name: 'woman-kiss-man',
    names: ['woman-kiss-man'],
    skins: [
      '👩🏻‍❤️‍💋‍👨🏻',
      '👩🏻‍❤️‍💋‍👨🏼',
      '👩🏻‍❤️‍💋‍👨🏽',
      '👩🏻‍❤️‍💋‍👨🏾',
      '👩🏻‍❤️‍💋‍👨🏿',
      '👩🏼‍❤️‍💋‍👨🏻',
      '👩🏼‍❤️‍💋‍👨🏼',
      '👩🏼‍❤️‍💋‍👨🏽',
      '👩🏼‍❤️‍💋‍👨🏾',
      '👩🏼‍❤️‍💋‍👨🏿',
      '👩🏽‍❤️‍💋‍👨🏻',
      '👩🏽‍❤️‍💋‍👨🏼',
      '👩🏽‍❤️‍💋‍👨🏽',
      '👩🏽‍❤️‍💋‍👨🏾',
      '👩🏽‍❤️‍💋‍👨🏿',
      '👩🏾‍❤️‍💋‍👨🏻',
      '👩🏾‍❤️‍💋‍👨🏼',
      '👩🏾‍❤️‍💋‍👨🏽',
      '👩🏾‍❤️‍💋‍👨🏾',
      '👩🏾‍❤️‍💋‍👨🏿',
      '👩🏿‍❤️‍💋‍👨🏻',
      '👩🏿‍❤️‍💋‍👨🏼',
      '👩🏿‍❤️‍💋‍👨🏽',
      '👩🏿‍❤️‍💋‍👨🏾',
      '👩🏿‍❤️‍💋‍👨🏿',
    ],
    unicode: '👩‍❤️‍💋‍👨',
  },
  {
    id: 'woman-kiss-woman',
    name: 'woman-kiss-woman',
    names: ['woman-kiss-woman'],
    skins: [
      '👩🏻‍❤️‍💋‍👩🏻',
      '👩🏻‍❤️‍💋‍👩🏼',
      '👩🏻‍❤️‍💋‍👩🏽',
      '👩🏻‍❤️‍💋‍👩🏾',
      '👩🏻‍❤️‍💋‍👩🏿',
      '👩🏼‍❤️‍💋‍👩🏻',
      '👩🏼‍❤️‍💋‍👩🏼',
      '👩🏼‍❤️‍💋‍👩🏽',
      '👩🏼‍❤️‍💋‍👩🏾',
      '👩🏼‍❤️‍💋‍👩🏿',
      '👩🏽‍❤️‍💋‍👩🏻',
      '👩🏽‍❤️‍💋‍👩🏼',
      '👩🏽‍❤️‍💋‍👩🏽',
      '👩🏽‍❤️‍💋‍👩🏾',
      '👩🏽‍❤️‍💋‍👩🏿',
      '👩🏾‍❤️‍💋‍👩🏻',
      '👩🏾‍❤️‍💋‍👩🏼',
      '👩🏾‍❤️‍💋‍👩🏽',
      '👩🏾‍❤️‍💋‍👩🏾',
      '👩🏾‍❤️‍💋‍👩🏿',
      '👩🏿‍❤️‍💋‍👩🏻',
      '👩🏿‍❤️‍💋‍👩🏼',
      '👩🏿‍❤️‍💋‍👩🏽',
      '👩🏿‍❤️‍💋‍👩🏾',
      '👩🏿‍❤️‍💋‍👩🏿',
    ],
    unicode: '👩‍❤️‍💋‍👩',
  },
  {
    id: 'woman-lifting-weights',
    name: 'woman-lifting-weights',
    names: ['woman-lifting-weights'],
    skins: ['🏋🏻‍♀️', '🏋🏼‍♀️', '🏋🏽‍♀️', '🏋🏾‍♀️', '🏋🏿‍♀️'],
    unicode: '🏋️‍♀️',
  },
  {
    id: 'woman-mountain-biking',
    name: 'woman-mountain-biking',
    names: ['woman-mountain-biking'],
    skins: ['🚵🏻‍♀️', '🚵🏼‍♀️', '🚵🏽‍♀️', '🚵🏾‍♀️', '🚵🏿‍♀️'],
    unicode: '🚵‍♀️',
  },
  {
    id: 'woman-playing-handball',
    name: 'woman-playing-handball',
    names: ['woman-playing-handball'],
    skins: ['🤾🏻‍♀️', '🤾🏼‍♀️', '🤾🏽‍♀️', '🤾🏾‍♀️', '🤾🏿‍♀️'],
    unicode: '🤾‍♀️',
  },
  {
    id: 'woman-playing-water-polo',
    name: 'woman-playing-water-polo',
    names: ['woman-playing-water-polo'],
    skins: ['🤽🏻‍♀️', '🤽🏼‍♀️', '🤽🏽‍♀️', '🤽🏾‍♀️', '🤽🏿‍♀️'],
    unicode: '🤽‍♀️',
  },
  {
    id: 'woman-pouting',
    name: 'woman-pouting',
    names: ['woman-pouting'],
    skins: ['🙎🏻‍♀️', '🙎🏼‍♀️', '🙎🏽‍♀️', '🙎🏾‍♀️', '🙎🏿‍♀️'],
    unicode: '🙎‍♀️',
  },
  {
    id: 'woman-raising-hand',
    name: 'woman-raising-hand',
    names: ['woman-raising-hand'],
    skins: ['🙋🏻‍♀️', '🙋🏼‍♀️', '🙋🏽‍♀️', '🙋🏾‍♀️', '🙋🏿‍♀️'],
    unicode: '🙋‍♀️',
  },
  {
    id: 'woman-rowing-boat',
    name: 'woman-rowing-boat',
    names: ['woman-rowing-boat'],
    skins: ['🚣🏻‍♀️', '🚣🏼‍♀️', '🚣🏽‍♀️', '🚣🏾‍♀️', '🚣🏿‍♀️'],
    unicode: '🚣‍♀️',
  },
  {
    id: 'woman-running',
    name: 'woman-running',
    names: ['woman-running'],
    skins: ['🏃🏻‍♀️', '🏃🏼‍♀️', '🏃🏽‍♀️', '🏃🏾‍♀️', '🏃🏿‍♀️'],
    unicode: '🏃‍♀️',
  },
  {
    id: 'woman-shrugging',
    name: 'woman-shrugging',
    names: ['woman-shrugging'],
    skins: ['🤷🏻‍♀️', '🤷🏼‍♀️', '🤷🏽‍♀️', '🤷🏾‍♀️', '🤷🏿‍♀️'],
    unicode: '🤷‍♀️',
  },
  {
    id: 'woman-surfing',
    name: 'woman-surfing',
    names: ['woman-surfing'],
    skins: ['🏄🏻‍♀️', '🏄🏼‍♀️', '🏄🏽‍♀️', '🏄🏾‍♀️', '🏄🏿‍♀️'],
    unicode: '🏄‍♀️',
  },
  {
    id: 'woman-swimming',
    name: 'woman-swimming',
    names: ['woman-swimming'],
    skins: ['🏊🏻‍♀️', '🏊🏼‍♀️', '🏊🏽‍♀️', '🏊🏾‍♀️', '🏊🏿‍♀️'],
    unicode: '🏊‍♀️',
  },
  {
    id: 'woman-tipping-hand',
    name: 'woman-tipping-hand',
    names: ['woman-tipping-hand'],
    skins: ['💁🏻‍♀️', '💁🏼‍♀️', '💁🏽‍♀️', '💁🏾‍♀️', '💁🏿‍♀️'],
    unicode: '💁‍♀️',
  },
  {
    id: 'woman-walking',
    name: 'woman-walking',
    names: ['woman-walking'],
    skins: ['🚶🏻‍♀️', '🚶🏼‍♀️', '🚶🏽‍♀️', '🚶🏾‍♀️', '🚶🏿‍♀️'],
    unicode: '🚶‍♀️',
  },
  {
    id: 'woman-wearing-turban',
    name: 'woman-wearing-turban',
    names: ['woman-wearing-turban'],
    skins: ['👳🏻‍♀️', '👳🏼‍♀️', '👳🏽‍♀️', '👳🏾‍♀️', '👳🏿‍♀️'],
    unicode: '👳‍♀️',
  },
  { id: 'woman-woman-boy', name: 'woman-woman-boy', names: ['woman-woman-boy'], unicode: '👩‍👩‍👦' },
  {
    id: 'woman-woman-boy-boy',
    name: 'woman-woman-boy-boy',
    names: ['woman-woman-boy-boy'],
    unicode: '👩‍👩‍👦‍👦',
  },
  { id: 'woman-woman-girl', name: 'woman-woman-girl', names: ['woman-woman-girl'], unicode: '👩‍👩‍👧' },
  {
    id: 'woman-woman-girl-boy',
    name: 'woman-woman-girl-boy',
    names: ['woman-woman-girl-boy'],
    unicode: '👩‍👩‍👧‍👦',
  },
  {
    id: 'woman-woman-girl-girl',
    name: 'woman-woman-girl-girl',
    names: ['woman-woman-girl-girl'],
    unicode: '👩‍👩‍👧‍👧',
  },
  { id: 'woman-wrestling', name: 'woman-wrestling', names: ['woman-wrestling'], unicode: '🤼‍♀️' },
  {
    id: 'woman_climbing',
    name: 'woman_climbing',
    names: ['woman_climbing'],
    skins: ['🧗🏻‍♀️', '🧗🏼‍♀️', '🧗🏽‍♀️', '🧗🏾‍♀️', '🧗🏿‍♀️'],
    unicode: '🧗‍♀️',
  },
  {
    id: 'woman_feeding_baby',
    name: 'woman_feeding_baby',
    names: ['woman_feeding_baby'],
    skins: ['👩🏻‍🍼', '👩🏼‍🍼', '👩🏽‍🍼', '👩🏾‍🍼', '👩🏿‍🍼'],
    unicode: '👩‍🍼',
  },
  {
    id: 'woman_in_lotus_position',
    name: 'woman_in_lotus_position',
    names: ['woman_in_lotus_position'],
    skins: ['🧘🏻‍♀️', '🧘🏼‍♀️', '🧘🏽‍♀️', '🧘🏾‍♀️', '🧘🏿‍♀️'],
    unicode: '🧘‍♀️',
  },
  {
    id: 'woman_in_manual_wheelchair',
    name: 'woman_in_manual_wheelchair',
    names: ['woman_in_manual_wheelchair'],
    skins: ['👩🏻‍🦽', '👩🏼‍🦽', '👩🏽‍🦽', '👩🏾‍🦽', '👩🏿‍🦽'],
    unicode: '👩‍🦽',
  },
  {
    id: 'woman_in_manual_wheelchair_facing_right',
    name: 'woman_in_manual_wheelchair_facing_right',
    names: ['woman_in_manual_wheelchair_facing_right'],
    skins: ['👩🏻‍🦽‍➡️', '👩🏼‍🦽‍➡️', '👩🏽‍🦽‍➡️', '👩🏾‍🦽‍➡️', '👩🏿‍🦽‍➡️'],
    unicode: '👩‍🦽‍➡️',
  },
  {
    id: 'woman_in_motorized_wheelchair',
    name: 'woman_in_motorized_wheelchair',
    names: ['woman_in_motorized_wheelchair'],
    skins: ['👩🏻‍🦼', '👩🏼‍🦼', '👩🏽‍🦼', '👩🏾‍🦼', '👩🏿‍🦼'],
    unicode: '👩‍🦼',
  },
  {
    id: 'woman_in_motorized_wheelchair_facing_right',
    name: 'woman_in_motorized_wheelchair_facing_right',
    names: ['woman_in_motorized_wheelchair_facing_right'],
    skins: ['👩🏻‍🦼‍➡️', '👩🏼‍🦼‍➡️', '👩🏽‍🦼‍➡️', '👩🏾‍🦼‍➡️', '👩🏿‍🦼‍➡️'],
    unicode: '👩‍🦼‍➡️',
  },
  {
    id: 'woman_in_steamy_room',
    name: 'woman_in_steamy_room',
    names: ['woman_in_steamy_room'],
    skins: ['🧖🏻‍♀️', '🧖🏼‍♀️', '🧖🏽‍♀️', '🧖🏾‍♀️', '🧖🏿‍♀️'],
    unicode: '🧖‍♀️',
  },
  {
    id: 'woman_in_tuxedo',
    name: 'woman_in_tuxedo',
    names: ['woman_in_tuxedo'],
    skins: ['🤵🏻‍♀️', '🤵🏼‍♀️', '🤵🏽‍♀️', '🤵🏾‍♀️', '🤵🏿‍♀️'],
    unicode: '🤵‍♀️',
  },
  {
    id: 'woman_kneeling',
    name: 'woman_kneeling',
    names: ['woman_kneeling'],
    skins: ['🧎🏻‍♀️', '🧎🏼‍♀️', '🧎🏽‍♀️', '🧎🏾‍♀️', '🧎🏿‍♀️'],
    unicode: '🧎‍♀️',
  },
  {
    id: 'woman_kneeling_facing_right',
    name: 'woman_kneeling_facing_right',
    names: ['woman_kneeling_facing_right'],
    skins: ['🧎🏻‍♀️‍➡️', '🧎🏼‍♀️‍➡️', '🧎🏽‍♀️‍➡️', '🧎🏾‍♀️‍➡️', '🧎🏿‍♀️‍➡️'],
    unicode: '🧎‍♀️‍➡️',
  },
  {
    id: 'woman_running_facing_right',
    name: 'woman_running_facing_right',
    names: ['woman_running_facing_right'],
    skins: ['🏃🏻‍♀️‍➡️', '🏃🏼‍♀️‍➡️', '🏃🏽‍♀️‍➡️', '🏃🏾‍♀️‍➡️', '🏃🏿‍♀️‍➡️'],
    unicode: '🏃‍♀️‍➡️',
  },
  {
    id: 'woman_standing',
    name: 'woman_standing',
    names: ['woman_standing'],
    skins: ['🧍🏻‍♀️', '🧍🏼‍♀️', '🧍🏽‍♀️', '🧍🏾‍♀️', '🧍🏿‍♀️'],
    unicode: '🧍‍♀️',
  },
  {
    id: 'woman_walking_facing_right',
    name: 'woman_walking_facing_right',
    names: ['woman_walking_facing_right'],
    skins: ['🚶🏻‍♀️‍➡️', '🚶🏼‍♀️‍➡️', '🚶🏽‍♀️‍➡️', '🚶🏾‍♀️‍➡️', '🚶🏿‍♀️‍➡️'],
    unicode: '🚶‍♀️‍➡️',
  },
  {
    id: 'woman_with_beard',
    name: 'woman_with_beard',
    names: ['woman_with_beard'],
    skins: ['🧔🏻‍♀️', '🧔🏼‍♀️', '🧔🏽‍♀️', '🧔🏾‍♀️', '🧔🏿‍♀️'],
    unicode: '🧔‍♀️',
  },
  {
    id: 'woman_with_probing_cane',
    name: 'woman_with_probing_cane',
    names: ['woman_with_probing_cane'],
    skins: ['👩🏻‍🦯', '👩🏼‍🦯', '👩🏽‍🦯', '👩🏾‍🦯', '👩🏿‍🦯'],
    unicode: '👩‍🦯',
  },
  {
    id: 'woman_with_veil',
    name: 'woman_with_veil',
    names: ['woman_with_veil'],
    skins: ['👰🏻‍♀️', '👰🏼‍♀️', '👰🏽‍♀️', '👰🏾‍♀️', '👰🏿‍♀️'],
    unicode: '👰‍♀️',
  },
  {
    id: 'woman_with_white_cane_facing_right',
    name: 'woman_with_white_cane_facing_right',
    names: ['woman_with_white_cane_facing_right'],
    skins: ['👩🏻‍🦯‍➡️', '👩🏼‍🦯‍➡️', '👩🏽‍🦯‍➡️', '👩🏾‍🦯‍➡️', '👩🏿‍🦯‍➡️'],
    unicode: '👩‍🦯‍➡️',
  },
  { id: 'womans_clothes', name: 'womans_clothes', names: ['womans_clothes'], unicode: '👚' },
  { id: 'womans_flat_shoe', name: 'womans_flat_shoe', names: ['womans_flat_shoe'], unicode: '🥿' },
  { id: 'womans_hat', name: 'womans_hat', names: ['womans_hat'], unicode: '👒' },
  {
    id: 'women-with-bunny-ears-partying',
    name: 'women-with-bunny-ears-partying',
    names: ['women-with-bunny-ears-partying', 'woman-with-bunny-ears-partying'],
    unicode: '👯‍♀️',
  },
  { id: 'womens', name: 'womens', names: ['womens'], unicode: '🚺' },
  { id: 'wood', name: 'wood', names: ['wood'], unicode: '🪵' },
  { id: 'woozy_face', name: 'woozy_face', names: ['woozy_face'], unicode: '🥴' },
  { id: 'world_map', name: 'world_map', names: ['world_map'], unicode: '🗺️' },
  { id: 'worm', name: 'worm', names: ['worm'], unicode: '🪱' },
  { id: 'worried', name: 'worried', names: ['worried'], unicode: '😟' },
  { id: 'wrench', name: 'wrench', names: ['wrench'], unicode: '🔧' },
  { id: 'wrestlers', name: 'wrestlers', names: ['wrestlers'], unicode: '🤼' },
  {
    id: 'writing_hand',
    name: 'writing_hand',
    names: ['writing_hand'],
    skins: ['✍🏻', '✍🏼', '✍🏽', '✍🏾', '✍🏿'],
    unicode: '✍️',
  },
  { id: 'x', name: 'x', names: ['x'], unicode: '❌' },
  { id: 'x-ray', name: 'x-ray', names: ['x-ray'], unicode: '🩻' },
  { id: 'yarn', name: 'yarn', names: ['yarn'], unicode: '🧶' },
  { id: 'yawning_face', name: 'yawning_face', names: ['yawning_face'], unicode: '🥱' },
  { id: 'yellow_heart', name: 'yellow_heart', names: ['yellow_heart'], unicode: '💛' },
  { id: 'yen', name: 'yen', names: ['yen'], unicode: '💴' },
  { id: 'yin_yang', name: 'yin_yang', names: ['yin_yang'], unicode: '☯️' },
  { id: 'yo-yo', name: 'yo-yo', names: ['yo-yo'], unicode: '🪀' },
  { id: 'yum', name: 'yum', names: ['yum'], unicode: '😋' },
  {
    id: 'zany_face',
    name: 'zany_face',
    names: ['zany_face', 'grinning_face_with_one_large_and_one_small_eye'],
    unicode: '🤪',
  },
  { id: 'zap', name: 'zap', names: ['zap'], unicode: '⚡' },
  { id: 'zebra_face', name: 'zebra_face', names: ['zebra_face'], unicode: '🦓' },
  { id: 'zero', name: 'zero', names: ['zero'], unicode: '0️⃣' },
  {
    id: 'zipper_mouth_face',
    name: 'zipper_mouth_face',
    names: ['zipper_mouth_face'],
    unicode: '🤐',
  },
  { id: 'zombie', name: 'zombie', names: ['zombie'], unicode: '🧟' },
  { id: 'zzz', name: 'zzz', names: ['zzz'], unicode: '💤' },
];
